# XXX: Linux XP *has* dpkg but uses rpm database
# Most other systems which *have* dpkg use dpkg as the packet manager
%define is_dpkg %(test ! -f /etc/lxp-release && which dpkg >/dev/null 2>&1 && echo 1||echo 0)

%if %{!?kernel_release:1}%{?kernel_release:0}
%define kernel_release %(uname -r)
%endif
%define is_altlinux %(test -e /etc/altlinux-release && cat /etc/altlinux-release |grep -v 4.0 > /dev/null && echo 1 || echo 0)
%if %is_altlinux
%brp_strip_none *
%else
%define __spec_install_post /usr/lib/rpm/brp-compress /usr/lib/rpm/brp-strip-comment-note %{nil}
%endif
License: Crypto-Pro
Version: 3.9.0
Release: 4
Buildarch: x86_64
URL: http://www.cryptopro.ru/
Packager: CryptoPro Ltd. <support@cryptopro.ru>
%if %{!?kernel_name:1}%{?kernel_name:0}
%define kernel_name %{kernel_release}
%endif
%if %is_dpkg
%define check_pkg() set +x;if dpkg -l %1 >/dev/null;then echo "%1 ok";else echo "Build requires %1 (not installed)";exit 1;fi;set -x;
%else
%define check_pkg() set +x;if rpm -qi %1 >/dev/null;then echo "%1 ok";else echo "Build requires %1 (not installed)";exit 1;fi;set -x;
%endif
%define check_cpverify() set +x;CPV=/opt/cprocsp/bin/amd64/cpverify;HASH=`$CPV -mk $CPV`;if test $? = 0 && $CPV $CPV $HASH >/dev/null;then echo "$CPV is ok (hash $HASH)";else echo "$CPV is bugged";exit 1;fi;set -x;
Summary: LKM for linux. Build 8227.
Name: cprocsp-drv-64-%{kernel_release}
BuildRoot: %{_tmppath}/%{name}-root
Group: Development/Libraries
Requires: lsb-cprocsp-rdr-64
# BuildRequires: lsb-cprocsp-rdr-64 lsb-cprocsp-devel cprocsp-drv-devel
Source: cprocsp-drv-64.src.tar.gz

%prep
%setup -q -c

%description

This is Loadable Kernel Module for linux.

%build
%check_pkg lsb-cprocsp-devel
%check_pkg cprocsp-drv-devel
%check_pkg lsb-cprocsp-rdr-64
%check_cpverify
bash build_drv.sh %{kernel_name}

%install
rm -rf ${RPM_BUILD_ROOT}
mod_dir=/lib/modules/%{kernel_release}/kernel/crypto
hash_dir=/opt/cprocsp/lib/hashes
mkdir -p $RPM_BUILD_ROOT/$mod_dir
mkdir -p $RPM_BUILD_ROOT/$hash_dir
hash_name=cprocsp-drv-64-%{kernel_release}
if test -f drvcsp.ko; then 
  install -m644 drvcsp.ko $RPM_BUILD_ROOT/$mod_dir
  mod_path=$mod_dir/drvcsp.ko
else
  install -m644 drvcsp.o $RPM_BUILD_ROOT/$mod_dir
  mod_path=$mod_dir/drvcsp.o
fi
echo "/$mod_path `/opt/cprocsp/bin/amd64/cpverify -mk $RPM_BUILD_ROOT/$mod_path`" >$hash_name
install -m 644 $hash_name $RPM_BUILD_ROOT/$hash_dir

%clean
rm -rf ${RPM_BUILD_ROOT}

%post
/sbin/depmod -aq

%preun
#rm /lib/modules/`uname -r`/kernel/drivers/crypto/drvcsp.ko
/sbin/modprobe -r drvcsp
depmod -aq


%files
%defattr(-,root,root,0755)
/lib/modules/*/*/*
/opt/cprocsp/lib/hashes/*
