#ifndef __CPENROLL_IMPL_H__
#define __CPENROLL_IMPL_H__
#include "CPEnroll.h"

class CPEnrollImpl: public CPEnroll
{
    public:
	CPEnrollImpl();

	~CPEnrollImpl();

	virtual HRESULT SetSignerCertificate(PCCERT_CONTEXT pSignerCert);
	virtual HRESULT put_HashAlgorithm( BSTR hashOid);
	virtual HRESULT AddCProLicenseExt();
    protected:
	HRESULT encodeRequestToPKCS7(std::vector<BYTE>& Request);
	HRESULT createPKCSRequest(BSTR rdn, BSTR usage, BSTR* request, 
			    bool includeAddedExtensions, bool EncodeToPKCS7);
	HRESULT prepareKeyUsage(const std::string& usage, std::vector<std::string>& usageArray);

	HCRYPTPROV hProv;
	DWORD dwKeySpec;
	BSTR hashAlgorithm_;
	BSTR containerName_;
	DWORD providerType_;
	BSTR providerName_;
	DWORD keyFlags_;
	DWORD requestStoreFlags_;
	DWORD rootStoreFlags_;
	DWORD myStoreFlags_;
	DWORD caStoreFlags_;
	DWORD provFlags_;
	bool limitExchangeKeyToEncipherment_;
	BSTR myStoreName_;
	bool deleteRequest_;
	bool writeToCSP_;
	bool useExisting_;
	CSecurePin pin_;
	DWORD installToContainerStatus_;
	bool supressAddRootUi_;
	PCCERT_CONTEXT pSignerCertificate_;

	struct Extension {
	    std::string oid;
	    BOOL critical;
	    std::vector<BYTE> value;

	    Extension() {
	    }

	    Extension( 
		const char* argOid,
		LONG argCritical,
		const std::vector<BYTE>& argValue)
	    : oid(argOid), critical(argCritical), value(argValue) {
	    }
	};

	std::list<Extension> extensions_;
};

#endif
