/*
 * Copyright(C) 2000-2009  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 54220 $
 * \date $Date: 2009-05-02 06:33:10 +0400 (Сбт, 02 Май 2009) $
 * \author $Author: lse $
 *
 * \brief  ,   
 *   CP.
 */
#ifndef _CSPHANDLES_H_INCLUDED
#define _CSPHANDLES_H_INCLUDED

#ifdef __cplusplus
class CSPHandleLock
{
  friend class CSPHandleLocks;
  protected:
    DWORD_PTR			dwHandle;
    CRWLockMode			dwMode;
    DWORD			dwHandleType;
    LPCRYPT_OBJECT_HEADER	pObj;
    LPCRYPT_CONTAINER		pProv;
    HRESULT			dwErrOnMissing;
    HRESULT			dwErrOnBad;

    CSPHandleLock (DWORD_PTR _dwHandle, CRWLockMode _dwMode, DWORD _dwHandleType, 
	HRESULT _dwErrOnMissing, HRESULT _dwErrOnBad)
	: dwHandle (_dwHandle)
	, dwMode (_dwMode)
	, dwHandleType (_dwHandleType)
	, pObj (NULL)
	, pProv (NULL)
	, dwErrOnMissing (_dwErrOnMissing)
	, dwErrOnBad (_dwErrOnBad)
	{}
  public:
    void Delete (pCP_CALL_CTX pCallCtx);

    operator LPCRYPT_OBJECT_HEADER () const 
	{ return pObj; }
    int operator ! () const 
	{ return !pObj; }
    operator bool () const 
	{ return NULL != pObj; }
    inline CRWLockMode getMode () const { return dwMode; }
 private:
    CSPHandleLock(const CSPHandleLock&);
    CSPHandleLock& operator=(const CSPHandleLock&);
};

class CSPHandleLockContainer: public CSPHandleLock
{
  public:
    CSPHandleLockContainer (DWORD_PTR _dwHandle, CRWLockMode _dwMode, HRESULT _dwErrOnMissing, HRESULT _dwErrOnBad) 
	: CSPHandleLock (_dwHandle, _dwMode, CONTAINER_OBJ, _dwErrOnMissing, _dwErrOnBad)
	{}
    operator LPCRYPT_CONTAINER () const 
	{ return (LPCRYPT_CONTAINER) pObj; }
    LPCRYPT_CONTAINER operator -> () const 
	{ return (LPCRYPT_CONTAINER) pObj; }
};

class CSPHandleLockHash: public CSPHandleLock
{
  public:
    CSPHandleLockHash (DWORD_PTR _dwHandle, CRWLockMode _dwMode, HRESULT _dwErrOnMissing, HRESULT _dwErrOnBad)
	: CSPHandleLock (_dwHandle, _dwMode, HASH_OBJ, _dwErrOnMissing, _dwErrOnBad)
	{}
    operator LPCRYPT_COMMON_HASH () const 
	{ return (LPCRYPT_COMMON_HASH) pObj; }
    LPCRYPT_COMMON_HASH operator -> () const 
	{ return (LPCRYPT_COMMON_HASH) pObj; }
};

class CSPHandleLockKey: public CSPHandleLock
{
  public:
    CSPHandleLockKey (DWORD_PTR _dwHandle, CRWLockMode _dwMode, HRESULT _dwErrOnMissing, HRESULT _dwErrOnBad)
	: CSPHandleLock (_dwHandle, _dwMode, KEY_OBJ, _dwErrOnMissing, _dwErrOnBad)
	{}
    operator LPCRYPT_COMMON_KEY () const 
	{ return (LPCRYPT_COMMON_KEY) pObj; }
    LPCRYPT_COMMON_KEY operator -> () const 
	{ return (LPCRYPT_COMMON_KEY) pObj; }
};

class CSPHandleLocks
{
  protected:
    pCP_CALL_CTX pCallCtx;
    CSPHandleLock** locks;
    size_t n_locks;
  public:
    CSPHandleLocks (pCP_CALL_CTX _pCallCtx, CSPHandleLock** _locks, size_t _n_locks);
    bool AcquireLocks ();
    void ReleaseLocks ();
  private:
    CSPHandleLocks(const CSPHandleLocks&);
    CSPHandleLock& operator=(const CSPHandleLocks&);
};
#endif /*__cplusplus*/

/*!
 * \brief   
 */
typedef struct CSPHandleSet_ *PCSPHandleSet;

typedef struct CSPHandleTable_ {
    PCSPHandleSet	segments;
    BOOL		serialize;

    LONG		nSegments;
    LONG		nEntries;

    DWORD		nMaxSegments;
    LONG		HandlesGenerator;
} CSPHandleTable;

typedef struct CSPHandleTable_ *PCSPHandleTable;

#endif /* _CPHANDLES_H_INCLUDED */
