/* vim:set sw=4 ts=8 fileencoding=cp1251:::WINDOWS-1251[] */
#ifdef _WIN32
    #pragma setlocale("rus")
#endif
/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 104242 $
 * \date $Date: 2014-03-27 10:42:44 +0300 (Чтв, 27 Мар 2014) $
 * \author $Author: lse $
 *
 * \brief  ,    .  .
 */

#ifndef _CSPKERNEL_H_INCLUDED
#define _CSPKERNEL_H_INCLUDED

#include "wincsp.h"
#include "wincspc.h"
#include "WinCryptEx.h"
#include "callctx.h"
#include "asn1type.h" 
#include "reader/support.h"
#include "reader/dprint.h"
#include "BaseArithmDef_64.h"

#ifdef __cplusplus
extern "C" {
#endif

/*#pragma warning (push)*/
/*#pragma warning (disable: 4214)*/
#define IN  
#define OUT  
#define IN_OUT
/*      */
#ifdef EXCLUDE_READER
# define RNDM_TYPE_WINDOWLESS 1
# define RNDM_TYPE_REMOVABLE 2
# define RNDM_TYPE_ANY_MASK  3
#endif /* EXCLUDE_READER */

struct KeyCarrierHandle_;
typedef struct KeyCarrierHandle_ KeyCarrierHandle;

struct KeyCarrierList_;
typedef struct KeyCarrierList_ KeyCarrierList;

struct TSupSysEList_;
typedef struct TSupSysEList_ KeyRdrList;

struct KeyRdrListCacheElement_;
typedef struct KeyRdrListCacheElement_ KeyRdrListCacheElement;

struct KeyCarrierEnumContainers_;
typedef struct KeyCarrierEnumContainers_ KeyCarrierEnumContainers;

struct KeyCarrierEnumExtensions_;
typedef struct KeyCarrierEnumExtensions_ KeyCarrierEnumExtensions;

struct KeyCarrierEnumReaders_;
typedef struct KeyCarrierEnumReaders_ KeyCarrierEnumReaders;

typedef struct _LIST_OID_PARAMS_ *LPLIST_OID_PARAMS;

#define TYPEDEF_BUFFER(n) \
typedef struct \
{\
    uint128_t Dummy[n/sizeof(uint128_t)];\
} BUFFER##n

typedef struct 
{
    long long dummy;
} BUFFER8;


TYPEDEF_BUFFER(32);

TYPEDEF_BUFFER(64);

TYPEDEF_BUFFER(256);

TYPEDEF_BUFFER(512);

/*      BUFFER<NN> */
#define _1bp(x)   x.Dummy[0].ui8
#define _2bp(x)   x.Dummy[0].ui16
#define _4bp(x)   x.Dummy[0].ui32
#define _4bpdw(x) x.Dummy[0].dw /*  Win uint32_t   DWORD  unsigned long  unsigned int */
#define _8bp(x)   x.Dummy[0].ui64

#define SIMPLE_MODE				0
#define IS_MODE					1

/*       */
/*      34.11-94*/
#include "simple_hash.h"

typedef union CPC_LOCK_OBJ_UNION_ {
  struct {
      volatile int	iRdrCount:30;
      volatile int	iWriter:1;
  }			vb;
  volatile LONG	vl;
} CPC_LOCK_OBJ_UNION;

typedef struct CPC_LOCK_OBJ_ {
  BOOL			fSerialize;
  CPC_LOCK_OBJ_UNION 
  			u;
  CPC_RWLOCK		criticalSection;
} CPC_LOCK_OBJ;

/* ,     */

extern LONG CPC_INTERLOCKED_EXCHANGE_ADD (pCP_CALL_CTX pCallCtx, volatile LONG * dest, LONG incr);
extern LONG CPC_INTERLOCKED_INCREMENT (pCP_CALL_CTX pCallCtx, volatile LONG * dest);
extern LONG CPC_INTERLOCKED_DECREMENT (pCP_CALL_CTX pCallCtx, volatile LONG * dest);
extern BOOL CPC_INTERLOCKED_CASL (pCP_CALL_CTX pCallCtx, volatile LONG * dest, LONG xchg, LONG compare);
extern BOOL CPC_INTERLOCKED_CASLL (pCP_CALL_CTX pCallCtx, volatile LONGLONG * dest, LONGLONG xchg, LONGLONG compare);

/* ,   ,      */

extern BOOL 
CPC_lcRWLOCK_INIT(pCP_CALL_CTX pCallCtx, LPCPC_RWLOCK pSection);
extern VOID 
CPC_lcRWLOCK_DESTROY(pCP_CALL_CTX pCallCtx, LPCPC_RWLOCK pSection);
//extern BOOL 
//CPC_lcRWLOCK_RDLOCK(pCP_CALL_CTX pCallCtx, LPCPC_RWLOCK pSection);
extern BOOL 
CPC_lcRWLOCK_WRLOCK(pCP_CALL_CTX pCallCtx, LPCPC_RWLOCK pSection);
extern BOOL 
CPC_lcRWLOCK_UNLOCK(pCP_CALL_CTX pCallCtx, LPCPC_RWLOCK pSection);

/* ,      ,      */

extern BOOL 
CPC_RWLOCK_INIT(pCP_CALL_CTX pCallCtx, 
		CPC_LOCK_OBJ *pSection, 
		BOOL fSerialize);
extern VOID 
CPC_RWLOCK_DESTROY(pCP_CALL_CTX pCallCtx, CPC_LOCK_OBJ *pSection);
extern BOOL 
CPC_RWLOCK_RDLOCK(pCP_CALL_CTX pCallCtx, CPC_LOCK_OBJ *pSection);
extern BOOL 
CPC_RWLOCK_WRLOCK(pCP_CALL_CTX pCallCtx, CPC_LOCK_OBJ *pSection);
extern BOOL 
CPC_RWLOCK_UNLOCK(pCP_CALL_CTX pCallCtx, CPC_LOCK_OBJ *pSection);

extern BOOL CPC_GET_TIME (pCP_CALL_CTX pCallCtx, CPC_timeval *pTV);

/*    */
typedef struct _CRYPT_OBJECT_HEADER_ {
	ALG_ID			 ObjClassAlgId;	/*    ALG_ID */
	DWORD			 ObjType;	    /* SECRET_KEY,  PUBLIC_KEY*/
	DWORD			 Id;
	DWORD			dwReserved;	//  , TODO 
	struct _CRYPT_OBJECT_HEADER_ *pNextCryptObj;
	struct _CRYPT_OBJECT_HEADER_ *pPrevCryptObj;
} CRYPT_OBJECT_HEADER, *LPCRYPT_OBJECT_HEADER;

typedef struct _CRYPT_OBJECT_LIST_ {
	LPCRYPT_OBJECT_HEADER pFirstCryptObj;
	LPCRYPT_OBJECT_HEADER pLastCryptObj;
} CRYPT_OBJECT_LIST, *LPCRYPT_OBJECT_LIST;
/*     .*/
#define SECRET_KEY	   1
#define SERT_KEYDATA	   0x100
#define PUBLIC_KEY	   2
//TODO:#define ECPUBLIC_KEY	   (PUBLIC_KEY|0xec0)
#define OID_OBJECT	   3

#define CONTAINER_OBJ	   4
#define KEY_OBJ		   5
#define HASH_OBJ	   6
#define KEYTYPE_MASK	0x0f
/*  */
#define ADD_32_MASK		0x00
#define ADD_2_MASK		0x10
#define ADD_GFQ_MASK	0x20
#define MUL_GFQ_MASK	0x30
#define MASKTYPE_MASK	0xf0
#define ADD_32_ZEROMASK		0x40

    //    ?     
static SUP_INLINE DWORD 
Id2HCRYPT(const CRYPT_OBJECT_HEADER *pObj) {
    if(pObj->dwReserved) {
	switch(pObj->ObjType) {
	case KEY_OBJ:
	case SECRET_KEY:
	case PUBLIC_KEY:
	    return pObj->Id^KEY_OBJ;
	case CONTAINER_OBJ:
	case HASH_OBJ:
	default:
	    return pObj->Id^pObj->ObjType;
	}
    }
    return 0;
}

static SUP_INLINE DWORD
HCRYPT2Id(DWORD_PTR dwpH, DWORD dwHandleTypeObjType) {
    switch(dwHandleTypeObjType) {
    case KEY_OBJ:
    case SECRET_KEY:
    case PUBLIC_KEY:
	return (DWORD)dwpH^KEY_OBJ;
    case CONTAINER_OBJ:
    case HASH_OBJ:
    default:
	return (DWORD)dwpH^dwHandleTypeObjType;
    }
}


/*    */
//#define MAGIKDESTRKM	0xffffffee
typedef struct KEY_MATERIAL_FLAGS_ {
#ifndef WORDS_BIGENDIAN
    unsigned int pad:8;
    unsigned int usepad:2;
    unsigned int kc1export:1;
    unsigned int resevd:21;
#else /* WORDS_BIGENDIAN */
    unsigned int resevd:21;
    unsigned int kc1export:1;
    unsigned int usepad:2;
    unsigned int pad:8;
#endif /* WORDS_BIGENDIAN */
} KEY_MATERIAL_FLAGS;
typedef struct  _CRYPT_KEY_MATERIAL_ {
//	DWORD dwHeader;
	KEY_MATERIAL_FLAGS Flags;		    		
	DWORD	    dwMaskType;		    /*  */
	LPCRYPT_DATA_BLOB_EX  pKey;	    /* */
	LPCRYPT_DATA_BLOB_EX  pMask;	    /* */
	ASN1OBJID * pszKeyParamOID;	    /*  */
//	DWORD	    dwReserv;		    		
//	DWORD dwTale;
} CRYPT_KEY_MATERIAL, *LPCRYPT_KEY_MATERIAL;

/*    CreateUserKeyMaterial*/
#define DuplicateKeyMaterial(pCallCtx,pRndContext,pkmSrcKey) \
    DuplicateKeyMaterial_(pCallCtx,pRndContext,pkmSrcKey,1)

/* ,     CRYPT_KEY_MATERIAL*/
#define SECRET_KEY_BLOB      SECRET_KEY
#define PUBLIC_KEY_BLOB      PUBLIC_KEY

#define SECRET_BLOB			 SECRET_KEY_BLOB
#define PUBLIC_BLOB			 PUBLIC_KEY_BLOB
#define PLAIN_BLOB			 3
#define PUBLICBLOBLEN	0x64

#define ENCRYPT_SEANCE_KEY	 1
#define IMIT_SEANCE_KEY		 2

/*         ,*/
/*       28147-89*/
#define G28147_BLOCKLEN      8
#define G28147_FEEDBACK_BITS	 64
#define G28147_IV_LEN		 8
#define G28147_IV_DWORDLEN	 2
typedef DWORD S_BOX_WIDE[1024];
typedef BYTE S_BOX_PACK[64];

/*        */
#define SIZE_KEY_BYTE		 SECRET_KEY_LEN
#define	SIZE_KEY_DWORD		 8 

/*    */
#define	SIZE_GOST_BLOCK_BYTE	G28147_BLOCKLEN
#define	MASK_GOST_BLOCK_BYTE	(G28147_BLOCKLEN - 1)
#define	SHIFT_GOST_BLOCK_BYTE	(3)

#define	SIZE_GOST_BLOCK_DWORD	2   

#define SSL3_MASTER_SECRET_SIZE			48
#define SSL3_RANDOM_SIZE			32

#define KEY_FP_SIZE		8

/*  */
typedef	union _CHAIN_BLOCK_ {
	BYTE	bField[SIZE_GOST_BLOCK_BYTE];
	DWORD	dwField[SIZE_GOST_BLOCK_DWORD];
} CHAIN_BLOCK, *LPCHAIN_BLOCK_;



#define GR3410_BLOCKLEN		512
#define DEFAULT_GR3410_KEYLEN	512

/*    */
typedef struct _ELIPTIC_POINT_ {
	uint64_t	    x[4];	
	uint64_t	    y[4];	
	uint64_t	    z[4];	
	DWORD	    NullPonit;
} ELIPTIC_POINT, *LPELIPTIC_POINT;

typedef struct _ELIPTIC_CURVE_ {/*y**2 = x**3 + a*x + b (mod p)*/
	DWORD *	    pa;	/*  */
	uint64_t *	    b;	
	uint64_t *	    p;	
	uint64_t *	    q;	/*    */
	DWORD 	    a;	/*a  DWORD*/
	DWORD 	    sign_a;	/*0->+  1->-*/
	DWORD 	    OPT_ModP;	/**/
	DWORD 	    dwModLen; /*    */
/*	DWORD	    Mont_Z;*/
	LPELIPTIC_POINT	    pPoint;
	LPCRYPT_DATA_BLOB_EX	    pMultTabs;	 
	uint64_t *	    ReduceTabP_256;
	uint64_t *	    P_Mult2; /*  P*/
	LPCRYPT_DATA_BLOB_EX	    pMultTabs_Q;	 
	uint64_t *	    ReduceTabQ_256;
	uint64_t *	    Q_Mult2; /*  Q*/
	DWORD * p_32;
	DWORD * q_32;
} ELIPTIC_CURVE, *LPELIPTIC_CURVE;

typedef struct _CRYPT_ELLIPTICPOINT_ {
	LPCRYPT_DATA_BLOB_EX	    x;	
	LPCRYPT_DATA_BLOB_EX	    y;	
	LPCRYPT_DATA_BLOB_EX	    z;	
} CRYPT_ELLIPTICPOINT, *LPCRYPT_ELLIPTICPOINT;

typedef union CRYPT_GENKEY_FLAGS {
  struct {
#ifndef WORDS_BIGENDIAN
    unsigned int Exportable:1;		//0x00000001
    unsigned int UserProtected:1;	//0x00000002
    unsigned int CreateSalt:1;		//0x00000004
    unsigned int UpdateKey:1;		//0x00000008
    unsigned int NoSalt:1;		//0x00000010
    unsigned int unused_6:1;		//
    unsigned int Pregen:1;		//0x00000040
    unsigned int Online:1;		//0x00000080
    unsigned int SF:1;			//0x00000100
    unsigned int CreateIV:1;		//0x00000200
    unsigned int KEK:1;			//0x00000400
    unsigned int unused_12:1;		//0x00000800
    unsigned int Voletile:1;		//0x00001000
    unsigned int SGCKey:1;		//0x00002000
    unsigned int Archivable:1;		//0x00004000
    unsigned int FKCShared:1;		//0x00008000
    unsigned int wKeyLen:16;
#else /* WORDS_BIGENDIAN */
    unsigned int wKeyLen:16;
    unsigned int FKCShared:1;		//0x00008000
    unsigned int Archivable:1;		//0x00004000
    unsigned int SGCKey:1;		//0x00002000
    unsigned int Voletile:1;		//0x00001000
    unsigned int unused_12:1;		//0x00000800
    unsigned int KEK:1;			//0x00000400
    unsigned int CreateIV:1;		//0x00000200
    unsigned int SF:1;			//0x00000100
    unsigned int Online:1;		//0x00000080
    unsigned int Pregen:1; 
    unsigned int unused_6:1; 
    unsigned int NoSalt:1; 
    unsigned int UpdateKey:1; 
    unsigned int CreateSalt:1; 
    unsigned int UserProtected:1;
    unsigned int Exportable:1;
#endif /* WORDS_BIGENDIAN */
  } s;
  DWORD d;
} CRYPT_GENKEY_FLAGS;

#define BLOB_DATA_LEN(Len)			(Len+EXPORT_IMIT_SIZE)

#define G28147_SIMPLEBLOB_SV_OFFSET		(0)
#define G28147_SIMPLEBLOB_EXPKEY_OFFSET		(G28147_SIMPLEBLOB_SV_OFFSET+SEANCE_VECTOR_LEN)
#define G28147_SIMPLEBLOB_EXPIMIT_OFFSET	(G28147_SIMPLEBLOB_EXPKEY_OFFSET+G28147_KEYLEN)
#define G28147_SIMPLEBLOB_SIZE			(SEANCE_VECTOR_LEN+G28147_KEYLEN+EXPORT_IMIT_SIZE)

#define G28147_SIMPLEBLOB_EXPOID_OFFSET		(G28147_SIMPLEBLOB_EXPIMIT_OFFSET+EXPORT_IMIT_SIZE)

#define G28147_OPAQUEBLOB_INITKEY_OFFSET	(G28147_SIMPLEBLOB_SIZE)
#define G28147_OPAQUEBLOB_INITIMIT_OFFSET	(G28147_OPAQUEBLOB_INITKEY_OFFSET+G28147_KEYLEN)
#define G28147_OPAQUEBLOB_IV_OFFSET		(G28147_OPAQUEBLOB_INITIMIT_OFFSET+EXPORT_IMIT_SIZE)
#define G28147_OPAQUEBLOB_CHAIN_OFFSET		(G28147_OPAQUEBLOB_IV_OFFSET+SEANCE_VECTOR_LEN)
#define G28147_OPAQUEBLOB_ACC_OFFSET		(G28147_OPAQUEBLOB_CHAIN_OFFSET+sizeof(CHAIN_BLOCK))
#define G28147_OPAQUEBLOB_CMODE_OFFSET		(G28147_OPAQUEBLOB_ACC_OFFSET+sizeof(DWORD))
#define G28147_OPAQUEBLOB_MMODE_OFFSET		(G28147_OPAQUEBLOB_CMODE_OFFSET+sizeof(DWORD))
#define G28147_OPAQUEBLOB_FLAGS_OFFSET		(G28147_OPAQUEBLOB_MMODE_OFFSET+sizeof(DWORD))
#define G28147_OPAQUEBLOB_PMODE_OFFSET		(G28147_OPAQUEBLOB_FLAGS_OFFSET+sizeof(CRYPT_SESSION_KEY_FLAGS))
#define G28147_OPAQUEBLOB_ALGID_OFFSET		(G28147_OPAQUEBLOB_PMODE_OFFSET+sizeof(DWORD))
#define G28147_OPAQUEBLOB_CFLAGS_OFFSET		(G28147_OPAQUEBLOB_ALGID_OFFSET+sizeof(ALG_ID))
#define G28147_OPAQUEBLOB_CHCKS_OFFSET		(G28147_OPAQUEBLOB_CFLAGS_OFFSET+sizeof(CRYPT_COMMON_KEY_FLAGS))

#define G28147_OPAQUEBLOB_SIZE			(G28147_OPAQUEBLOB_CHCKS_OFFSET+sizeof(DWORD))


#define G28147_OPAQUEBLOB_EXPOID_OFFSET		(G28147_OPAQUEBLOB_CHCKS_OFFSET+sizeof(DWORD))

#if 0
#define G28147_OPAQUEBLOB2_HKEY_OFFSET		(0)
#define G28147_OPAQUEBLOB2_CHCKS_OFFSET		(G28147_OPAQUEBLOB2_HKEY_OFFSET+sizeof(void*))

#define G28147_OPAQUEBLOB2_SIZE			(G28147_OPAQUEBLOB2_CHCKS_OFFSET+sizeof(DWORD))


#define OPAQUEHASHBLOB_CURKEY_OFFSET		(8)
#define OPAQUEHASHBLOB_CHAIN_OFFSET		(OPAQUEHASHBLOB_CURKEY_OFFSET+SIZE_KEY_BYTE)
#define OPAQUEHASHBLOB_ACC_OFFSET		(OPAQUEHASHBLOB_CHAIN_OFFSET+sizeof(CHAIN_BLOCK))
#define OPAQUEHASHBLOB_FLAGS_OFFSET		(OPAQUEHASHBLOB_ACC_OFFSET+sizeof(DWORD))
#define OPAQUEHASHBLOB_PMODE_OFFSET		(OPAQUEHASHBLOB_FLAGS_OFFSET+sizeof(CRYPT_SESSION_KEY_FLAGS))
#define OPAQUEHASHBLOB_CHCKS_OFFSET		(OPAQUEHASHBLOB_PMODE_OFFSET+sizeof(DWORD))
#define OPAQUEHASHBLOB_SIZE			(OPAQUEHASHBLOB_CHCKS_OFFSET + sizeof(DWORD)\
						+sizeof(CRYPT_SIMPLEBLOB_HEADER))
#else
#define OPAQUEHASHBLOB_IMITVAL_OFFSET		(G28147_OPAQUEBLOB_IV_OFFSET)
#define OPAQUEHASHBLOB_CURKEY_OFFSET		(G28147_OPAQUEBLOB_INITKEY_OFFSET)
#define OPAQUEHASHBLOB_CHAIN_OFFSET		(G28147_OPAQUEBLOB_CHAIN_OFFSET)
#define OPAQUEHASHBLOB_ACC_OFFSET		(G28147_OPAQUEBLOB_ACC_OFFSET)
#define OPAQUEHASHBLOB_FLAGS_OFFSET		(G28147_OPAQUEBLOB_FLAGS_OFFSET)
#define OPAQUEHASHBLOB_PMODE_OFFSET		(G28147_OPAQUEBLOB_PMODE_OFFSET)
#define OPAQUEHASHBLOB_HFLAGS_OFFSET		(G28147_OPAQUEBLOB_CFLAGS_OFFSET)
#define OPAQUEHASHBLOB_CHCKS_OFFSET		(G28147_OPAQUEBLOB_CHCKS_OFFSET)
#define OPAQUEHASHBLOB_SIZE			(G28147_OPAQUEBLOB_SIZE \
						+sizeof(CRYPT_SIMPLEBLOB_HEADER))
#endif
/* \internal
 * \brief    " CSP" OID. 
 */
#define MAX_OID_LEN	    64

/*  SIMPLEBLOB*/
/*#define SIMPLEBLOB_SIZE sizeof(CRYPT_SIMPLEBLOB_HEADER)+	\ */
/*				G28147_SIMPLEBLOB_SIZE +	\ */
/*				MAX_OID_LEN */
/*  SIMPLEBLOB  ,    1   */
/*#define SIMPLEBLOB_SIZE_T 0x43 */
#define SIMPLEBLOB_SIZE_T1 0x47

typedef struct _CERT_GR3410_PARAMETERS_ {
    CRYPT_DATA_BLOB_EX *P;
    CRYPT_DATA_BLOB_EX *Q;
    CRYPT_DATA_BLOB_EX *P32;
    CRYPT_DATA_BLOB_EX *Q32;
    union {
	CRYPT_DATA_BLOB_EX *A;
	CRYPT_DATA_BLOB_EX *G;
    } a;
    CRYPT_DATA_BLOB_EX *X0;
    CRYPT_DATA_BLOB_EX *C;
    CRYPT_DATA_BLOB_EX *D;
    DWORD Sign_a;
    DWORD OPT_ModP;
} CERT_GR3410_PARAMETERS, *PCERT_GR3410_PARAMETERS,
  CERT_DHEX_PARAMETERS, *PCERT_DHEX_PARAMETERS;


/* a   ,   OID.*/
typedef struct _CRYPT_PARAMS_ {
	DWORD dwOID_Tipe;
	DWORD	dwReserved;
	const ASN1OBJID * _OID_;
	union u1 {
	    PCERT_GR3410_PARAMETERS pKeyParams;
	    LPCRYPT_DATA_BLOB_EX pS_Box;
	} u1;
	union u2 {
	    LPCRYPT_DATA_BLOB_EX pdb_HashSV;
	    DWORD MIX_ALG;
	    LPCRYPT_DATA_BLOB_EX pdbPowTable;
	} u2;
	LPELIPTIC_CURVE pEllipticCv;
	LPLIST_OID_PARAMS pOIDObj;
} CRYPT_PARAMS,  *LPCRYPT_PARAMS;

/*C  (Pseudo-random-sequence generator)*/
/*     */
#define PRSG_BUFFER_ELEMENT_SIZE		4
/*    */
#define PRSG_BUFFER_ELEMENT_NUMBER		256
#define PRSG_BUFFER_SIZE				PRSG_BUFFER_ELEMENT_NUMBER*PRSG_BUFFER_ELEMENT_SIZE
/*    */
#define PRSG_RNDSEEDBUF_ELEMENT_NUMBER	11
#define PRSG_RNDSEEDBUF_LEN				PRSG_RNDSEEDBUF_ELEMENT_NUMBER*PRSG_BUFFER_ELEMENT_SIZE

#define PRSG_BUFFER_INFILL_NUMBER		100 

#define PRSG_RNDSEED_LEN			44
#define PRSG_RNDSEED_BLOBSIZE			48 
/*        64=44+20*/
#define START_INIT_PRSG				64
/*,     WORK_INIT_PRSG = 20*/
#define WORK_INIT_PRSG				40   /*  0*/

/*   . */
struct RND_CONTEXT_;

/*! \internal 
 * \brief      . 
 *
 * \param context [in/out]  ,     
 *    .
 * \param buffer [out] ,     .
 * \param length [in]     .
 * \return TRUE,   , FALSE .
 */
typedef BOOL (*GetRandomFunction)( pCP_CALL_CTX pCallCtx, struct RND_CONTEXT_ *context, LPBYTE buffer, DWORD length, DWORD flags );


/*! \internal 
 * \brief      .
 *
 * \param context [in/out]  ,     
 *    .
 * \return TRUE,      ( ), 
 *  FALSE .
 */
typedef BOOL (*IsRandomInitedFunction)( struct RND_CONTEXT_ *context );

/*! \internal
 * \brief      .
 *
 * \param context [in/out]  ,     
 *    .
 * \param seed [out]  .
 */
typedef BOOL (*GetRandomSeedFunction)( struct RND_CONTEXT_ *context, LPBYTE seed, size_t length );

/*! \internal
 * \brief      .
 *
 * \param context [in/out]  ,     
 *    .
 * \param seed [in]  .
 */
typedef BOOL (*SetRandomSeedFunction)( pCP_CALL_CTX pCallCtx, struct RND_CONTEXT_ *context, const LPBYTE seed, size_t length );
/*! \internal
 * \brief      ,
 *       CPSetProvParam(), PP_RANDOM. 
 */
#define RND_INITED 0x00000001
/*! \internal
 * \brief     .
 */
typedef struct RND_CONTEXT_ {
    GetRandomFunction make_random; /*!<      . */
    IsRandomInitedFunction is_inited; /*!<      . */
    GetRandomSeedFunction get_random_seed; /*!<     random seed. */
    SetRandomSeedFunction set_random_seed; /*!<     random_seed. */
    DWORD Flags;			    /*!<   .*/
} RND_CONTEXT, *LPRND_CONTEXT;

/*! \internal
 * \brief       .
 * \param context [in/out]    .
 * \param buffer [out]    .
 * \param length [in]  .
 * \return TRUE,    , FALSE .
 */
#define MakeRandom(cctx,context,buffer,length,flags) context->make_random(cctx,context,buffer,length,flags)

/*! \internal
 * \brief     .
 * \param context [in/out]    .
 * \return TRUE,   , FALSE .
 */
#define IsRandomInited(context) context->is_inited(context)

/*! \internal
 * \brief     .
 * \param context [in/out]    .
 * \param seed [out]  .
 * \return TRUE,  seed , FALSE .
 */
#define GetRandomSeed(context,seed,length) context->get_random_seed(context,seed,length)

/*! \internal
 * \brief     .
 * \param context [in/out]    .
 * \param seed [in]  .
 * \return TRUE,  seed , FALSE .
 */
#define SetRandomSeed(cctx,context,seed,length) context->set_random_seed(cctx,context,seed,length)


/*  */
typedef struct _CRYPT_CIPHER_CONTEXT_{
	/*     ()*/
	DWORD				  InitVector[SIZE_GOST_BLOCK_DWORD];
	/*    */
	DWORD				  CurrentInitVector[SIZE_GOST_BLOCK_DWORD];
	/*   */
	CHAIN_BLOCK			  ChainBlock;
	/*    */
	uint64_t			  dwAccCiphertextLen;
	uint64_t			  dwCommAccCiphertextLen;
	DWORD				  dwCommFinal;
	DWORD				  dwPrevAccCiphertextLen;
	/*  */
	LPCRYPT_KEY_MATERIAL  pKeyMaterial;
	/*  */
	LPCRYPT_KEY_MATERIAL  pInitKeyMaterial;
	/*  pSecretKey      
	  FillRndBuffer()      1*/
	void*	    pSecretKey;
	void*	    pPublicKey;
	void*	    pAddPublicKey;
	/*  */
	LPCRYPT_KEY_MATERIAL  pKeyMaterialImp;
	/*  */
	LPCRYPT_KEY_MATERIAL  pInitKeyMaterialImp;
	/*pRNDContext   CIPHER_CONTEXT  
	         , ..
	          */
	LPRND_CONTEXT	    pRNDContext;
	    /*    (+) */
	    // ASSERT -    FPUAllignValue
	struct cp_mp_28147_89  *pm;
	    /*    */
	    // ASSERT -    FPUAllignValue
	struct cp_vtb_28147_89 *pVTB;
	    /*       */
	DWORD			kernelArrayLength;
	    /* Solaris  .   ,     */
	BYTE			kernelArray[4]; 
} CRYPT_CIPHER_CONTEXT, *LPCRYPT_CIPHER_CONTEXT;


/*        DH ECC
 * PREV   ( ).IsECCAgreed=0.
 * AGREED  ( /).IsECCAgreed=1.
 * EXPORT       
 *  ( /).IsECCAgreed=0.
*/
typedef struct CRYPT_SESSION_KEY_FLAGS {
    unsigned int KeyInUse:1;
    unsigned int Invalid:1;
    unsigned int IsECCAgreed:1;
    unsigned int CreateECCDHExport:1;
    unsigned int CreateECCDHImport:1;
    unsigned int CreateECCDHimm:1;
    unsigned int DiversKey:1;
} CRYPT_SESSION_KEY_FLAGS;

typedef struct _CRYPT_SESSION_KEY_ {
	DWORD			dwCipherMode;
	DWORD			dwProMixMode;
	CRYPT_SESSION_KEY_FLAGS Flags;
	
	DWORD			dwPaddingMode;
	DWORD			dwFeedbackBits;
/*	DWORD			dwHashCount;*/
	/*   */
	DWORD			dwTunnelMode;

	LPCRYPT_PARAMS		OIDandCipherParms;
	LPCRYPT_CIPHER_CONTEXT	pCContext;
} CRYPT_SESSION_KEY, *LPCRYPT_SESSION_KEY;


/*       34.10      DH.*/
typedef struct _CRYPT_GR3410_PUBLICKEY_INFO_ {
	BLOBHEADER BlobHeader;
	CRYPT_PUBKEYPARAM	PubKeyParam;
	LPCRYPT_PARAMS		   OIDandPQAParms;
	LPCRYPT_PARAMS		   OIDandHashParms;
	LPCRYPT_KEY_MATERIAL	pPublic;
	LPCRYPT_DATA_BLOB_EX	pTab;
} CRYPT_GR3410_PUBLICKEY_INFO, *LPCRYPT_GR3410_PUBLICKEY_INFO;

typedef struct _CRYPT_R3410_PRIVATEKEY_INFO_ {
	CRYPT_GR3410_PUBLICKEY_INFO PublicInfo;
//	DWORD			  SeansVector[SIZE_GOST_BLOCK_DWORD];
	LPCRYPT_KEY_MATERIAL	  pSecret;	
} CRYPT_GR3410_PRIVATEKEY_INFO, *LPCRYPT_GR3410_PRIVATEKEY_INFO,
  CRYPT_GR3410_KEYPAIR,		*LPCRYPT_GR3410_KEYPAIR;

/*      bloba    .*/
typedef int (*CRYPT_DUPPER)(LPVOID src, BYTE ** p, LPVOID *dst);
LPCRYPT_DATA_BLOB_EX RebuildDataBlobEx (LPCRYPT_DATA_BLOB_EX old_blob, CRYPT_DUPPER pdup, BOOL fDestroy);

typedef struct OID_PARAMS_FLAGS {
    unsigned int Test:1;
    unsigned int Def_Def:1;
    unsigned int Default:1;
    unsigned int PowTable:1;
    unsigned int Carrier:1;
    unsigned int TestOnly:1;
} OID_PARAMS_FLAGS;

/* a  OID - .*/
typedef struct _OID_PARAMS_ {
	const ASN1OBJID * _OID_;
	DWORD dwOID_Tipe;
	DWORD Reserved;
	OID_PARAMS_FLAGS Flags;
	CRYPT_UINT_BLOB vParm1;	
	DWORD		dwParm4;
	CRYPT_UINT_BLOB vParm2;
	DWORD		dwParm5;
	CRYPT_UINT_BLOB vParm3;
	DWORD		dwParm9;
	CRYPT_UINT_BLOB vParm6;
	DWORD		dwParm10;
	CRYPT_UINT_BLOB vParm7;
	DWORD		dwReserved2;
	CRYPT_UINT_BLOB vParm8;
	LPCRYPT_DATA_BLOB_EX pS_Box;
} OID_PARAMS, *LPOID_PARAMS;

typedef struct _LIST_OID_PARAMS_ {
	CRYPT_OBJECT_HEADER			ObjHeader;
	const OID_PARAMS *			pOID_Params;
	LPCRYPT_PARAMS				pCrypt_Params;
	OID_PARAMS_FLAGS			Flags;
} LIST_OID_PARAMS;

typedef struct _CRYPT_MASTER_KEY_FLAGS_ {
#ifndef WORDS_BIGENDIAN
    unsigned int CR:1;
    unsigned int SR:1;
    unsigned int MS:1;
    unsigned int Resevd:29;
#else /* WORDS_BIGENDIAN */
    unsigned int Resevd:29;
    unsigned int MS:1;
    unsigned int SR:1;
    unsigned int CR:1;
#endif /* WORDS_BIGENDIAN */
} CRYPT_MASTER_KEY_FLAGS;

typedef struct _CRYPT_MASTER_KEY_ {
	LPCRYPT_KEY_MATERIAL		pPreMasterSecret;
        BYTE				client_random[SSL3_RANDOM_SIZE];
        BYTE				server_random[SSL3_RANDOM_SIZE];
	CRYPT_MASTER_KEY_FLAGS		Flags;
	DWORD			dwReserved;
} CRYPT_MASTER_KEY, *LPCRYPT_MASTER_KEY;

/*   */
typedef union _CRYPT_KEY_CLASS_ {
	LPCRYPT_SESSION_KEY    pSessionKey;
	LPCRYPT_GR3410_KEYPAIR pKeyPair;
	LPCRYPT_MASTER_KEY     pMasterKey;
} CRYPT_KEY_CLASS, *LPCRYPT_KEY_CLASS;

// KP_PERMISSIONS
#define CRYPT_USER_KEY						0x0100
#define CRYPT_IMPORTED						0x0200
#define CRYPT_PREUSER_KEY					0x0800
#define CRYPT_SECRET_ONLY					0x1000
//#define CRYPT_FKCSHARED					0x00008000

#define DEFAULT_SESSION_KEY_FLAGS			CRYPT_ENCRYPT|	\
							CRYPT_DECRYPT|	\
							CRYPT_READ  |	\
							CRYPT_WRITE |	\
							CRYPT_MAC   |	\
							CRYPT_EXPORT_KEY|\
							CRYPT_IMPORT_KEY

#define USER_SESSION_KEY_FLAGS				CRYPT_READ|\
							CRYPT_EXPORT_KEY|\
							CRYPT_IMPORT_KEY|\
							CRYPT_USER_KEY

#define DEFAULT_KEY_PAIR_FLAGS				CRYPT_READ	|\
							CRYPT_WRITE			
								
#define USER_KEY_PAIR_FLAGS				CRYPT_READ  |\
							CRYPT_WRITE|\
							CRYPT_USER_KEY

#define STRONG_USER_KEY_PAIR_FLAGS			CRYPT_READ  |\
							CRYPT_USER_KEY

#define DEFAULT_DIVERS_KEY_FLAGS			CRYPT_ENCRYPT|	\
							CRYPT_DECRYPT|	\
							CRYPT_READ  |	\
							CRYPT_WRITE |	\
							CRYPT_MAC

typedef union CRYPT_COMMON_KEY_FLAGS {
  struct {
#ifndef WORDS_BIGENDIAN
    unsigned int PermitEncrypt:1;
    unsigned int PermitDecrypt:1;
    unsigned int PermitExport:1;
    unsigned int PermitRead:1;	    // 4
    unsigned int PermitWrite:1;
    unsigned int PermitMAC:1;
    unsigned int PermitExportKey:1;
    unsigned int PermitImportKey:1; //8
    unsigned int IsUserKey:1;
    unsigned int Imported:1;
    unsigned int Pregen:1;
    unsigned int PreUserKey:1;	    //12
    unsigned int UserSecretOnly:1;
    unsigned int AT_MasterKey : 2;
    unsigned int FKCShared:1;
    unsigned int unused_17:1;
    unsigned int Archivable:1;
    unsigned int unused_19_32:14;
#else /* WORDS_BIGENDIAN */
    unsigned int unused_19_32:14;
    unsigned int Archivable:1;
    unsigned int unused_17:1;
    unsigned int FKCShared:1;
    unsigned int AT_MasterKey : 2;
    unsigned int UserSecretOnly:1;
    unsigned int PreUserKey:1;
    unsigned int Pregen:1;
    unsigned int Imported:1;
    unsigned int IsUserKey:1;
    unsigned int PermitImportKey:1;
    unsigned int PermitExportKey:1;
    unsigned int PermitMAC:1;
    unsigned int PermitWrite:1;
    unsigned int PermitRead:1;
    unsigned int PermitExport:1;
    unsigned int PermitDecrypt:1;
    unsigned int PermitEncrypt:1;
#endif /* WORDS_BIGENDIAN */
  } s;
  DWORD d;
} CRYPT_COMMON_KEY_FLAGS, *LPCRYPT_COMMON_KEY_FLAGS;

typedef struct _CRYPT_COMMON_KEY_ {
	CRYPT_OBJECT_HEADER	   ObjHeader;
	ALG_ID			   AlgId;
	CRYPT_COMMON_KEY_FLAGS	   Flags;
	DWORD			   dwBlockLen;
	DWORD			   dwKeyLen; 
	CRYPT_KEY_CLASS		   KeyClass;
} CRYPT_COMMON_KEY, *LPCRYPT_COMMON_KEY;

#ifdef WITH_STRIBOG

typedef struct STRIBOGA_ {
#ifdef _MSC_VER
    __declspec(align(16)) uint64_t h[8];
    __declspec(align(16)) uint64_t N[8];
    __declspec(align(16)) uint64_t Sigma[8];
    __declspec(align(16)) uint64_t tmp1[8];
    __declspec(align(16)) uint64_t m[8];
    __declspec(align(16)) uint64_t K[13*8];
    __declspec(align(16)) uint64_t Stk[24];
    __declspec(align(16)) uint64_t A[64];
    __declspec(align(16)) uint64_t A_4[256];
    __declspec(align(16)) uint64_t A_8[8][256];
    __declspec(align(16)) uint64_t A_8p[8][256];
#elif defined (AIX)
    __attribute__((aligned(16))) uint64_t h[8];
    __attribute__((aligned(16))) uint64_t N[8];
    __attribute__((aligned(16))) uint64_t Sigma[8];
    __attribute__((aligned(16))) uint64_t tmp1[8];
    __attribute__((aligned(16))) uint64_t m[8];
    __attribute__((aligned(16))) uint64_t K[13*8];
    __attribute__((aligned(16))) uint64_t Stk[24];
    __attribute__((aligned(16))) uint64_t A[64];
    __attribute__((aligned(16))) uint64_t A_4[256];
    __attribute__((aligned(16))) uint64_t A_8[8][256];
    __attribute__((aligned(16))) uint64_t A_8p[8][256];
#elif defined(__GNUC__)
    uint64_t h[8] __attribute__((aligned(16)));
    uint64_t N[8] __attribute__((aligned(16)));
    uint64_t Sigma[8] __attribute__((aligned(16)));
    uint64_t tmp1[8] __attribute__((aligned(16)));
    uint64_t m[8] __attribute__((aligned(16)));
    uint64_t K[13*8] __attribute__((aligned(16)));
    uint64_t Stk[24] __attribute__((aligned(16)));
    uint64_t A[64] __attribute__((aligned(16)));
    uint64_t A_4[256] __attribute__((aligned(16)));
    uint64_t A_8[8][256] __attribute__((aligned(16)));
    uint64_t A_8p[8][256] __attribute__((aligned(16)));
#elif (defined(__SUNPRO_C) || defined(__SUNPRO_CC))
// , TODO:    clang #pragma align 16 (h, N, Sigma, tmp1, m, K, Stk, A, A_4, A_8, A_8p)
    uint64_t h[8];
    uint64_t N[8];
    uint64_t Sigma[8];
    uint64_t tmp1[8];
    uint64_t m[8];
    uint64_t K[13*8];
    uint64_t Stk[24];
    uint64_t A[64];
    uint64_t A_4[256];
    uint64_t A_8[8][256];
    uint64_t A_8p[8][256];
#else
    uint64_t h[8];
    uint64_t N[8];
    uint64_t Sigma[8];
    uint64_t tmp1[8];
    uint64_t m[8];
    uint64_t K[13*8];
    uint64_t Stk[24];
    uint64_t A[64];
    uint64_t A_4[256];
    uint64_t A_8[8][256];
    uint64_t A_8p[8][256];
#endif
    DWORD   dwRestTextLen;
    DWORD   dwTotalAccLen;
    BYTE RestTextBuffer[64];
} STRBGA, *LPSTRBGA;

typedef struct STRIBOG_ {
    uint64_t* h;
    uint64_t* N;
    uint64_t* Sigma;
    uint64_t* tmp1;
    uint64_t* m;
    uint64_t* K;
    uint64_t* Stk;
    uint64_t* A;
    uint64_t* A_4;
    uint64_t* A_8[256];
    uint64_t* A_8p[256];
} STRBG, *LPSTRBG;
#endif // WITH_STRIBOG

typedef struct _CRYPT_GR3411_MATERIAL_ {
	BUFFER32		     HashVal;
	BUFFER32		     StartHashVect;
	LPCRYPT_PARAMS		     OIDandHashParms;
	LPCRYPT_HASH_CONTEXT	     pHContext;
	LPCRYPT_COMMON_KEY	     pKey;
} CRYPT_GR3411_HASH, *LPCRYPT_GR3411_HASH;

typedef struct _CRYPT_SSLEAY_MATERIAL_ {
	BUFFER64		     HashVal;
	LPVOID			     ctx;
} CRYPT_SSLEAY_HASH, *LPCRYPT_SSLEAY_HASH;

typedef struct _CRYPT_PRF_HASH_ {
	LPCRYPT_KEY_MATERIAL	key;
        LPCRYPT_DATA_BLOB_EX	label;
        LPCRYPT_DATA_BLOB_EX	seed;
} CRYPT_PRF_HASH, *LPCRYPT_PRF_HASH;

typedef struct _CRYPT_MASTER_HASH_ {
	LPCRYPT_KEY_MATERIAL	key_block;
} CRYPT_MASTER_HASH, *LPCRYPT_MASTER_HASH;

typedef struct _CRYPT_G28147_IMIT_MATERIAL_ {
	BUFFER8			   ImitVal;
	LPCRYPT_COMMON_KEY pImitKey;
} CRYPT_G28147_IMIT, *LPCRYPT_G28147_IMIT;

typedef struct _CRYPT_EKEVERIFY_HASH_MATERIAL_ {
	DWORD		   HashVal;
	LPCRYPT_COMMON_KEY pKey;
} CRYPT_EKEVERIFY_HASH, *LPCRYPT_EKEVERIFY_HASH;

typedef union _CRYPT_HASH_TYPE_ {
	LPCRYPT_GR3411_HASH pGR3411Hash;
	LPCRYPT_SSLEAY_HASH pSSLEAYHash;
#ifdef WITH_STRIBOG
	LPSTRBGA	    pStrbga;
#endif //WITH_STRIBOG
	LPCRYPT_MASTER_HASH pMasterHash;
	LPCRYPT_PRF_HASH    pPRFHash;
	LPCRYPT_G28147_IMIT pImitHash;
	LPCRYPT_EKEVERIFY_HASH pEKEVerify;
	LPVOID		    pHashMaterial;
} CRYPT_HASH_TYPE, *LPCRYPT_HASH_TYPE;

typedef struct CRYPT_COMMON_HASH_FLAGS {
    unsigned int HashInUse:1;
    unsigned int HashFinished:1;
    unsigned int HashFinalized:1;
} CRYPT_COMMON_HASH_FLAGS;

typedef struct _CRYPT_COMMON_HASH_ {
	CRYPT_OBJECT_HEADER			ObjHeader;
	ALG_ID					AlgId;
	CRYPT_COMMON_HASH_FLAGS Flags;
	
	DWORD					dwHashSize;
	CRYPT_HASH_TYPE				HashType; 
	ASN1OBJID                               oidHashParam;
} CRYPT_COMMON_HASH, *LPCRYPT_COMMON_HASH;

typedef struct _FKCSHAREDKEYS_ {
	DWORD					dwKeySpec;
	DWORD					dwKeyAlg;
	LPCRYPT_OBJECT_HEADER			Sign;
	LPCRYPT_OBJECT_HEADER			DH;
	LPCRYPT_COMMON_KEY			Secur;		/*K_pw*/
	LPCRYPT_KEY_MATERIAL			pkmRecovery;
} FKCSHAREDKEYS, *LPFKCSHAREDKEYS;
//#define UNUSED_GENKEY 1

typedef struct _CRYPT_CONTAINER_ {
    CRYPT_OBJECT_HEADER ObjHeader;
//    CHAR szName[MAX_CONTAINER_NAME_LEN];

    LPLIST_OID_PARAMS		pHashParmsListOID;
    LPLIST_OID_PARAMS		pCipherParmsListOID;
    LPLIST_OID_PARAMS		pSignatureParmsElListOID;
    LPLIST_OID_PARAMS		pExchangeParmsElListOID;

    LPLIST_OID_PARAMS		pCarrierHashParmsListOID;
    LPLIST_OID_PARAMS		pCarrierCipherParmsListOID;
    LPLIST_OID_PARAMS		pCarrierSignatureParmsListOID;
    LPLIST_OID_PARAMS		pCarrierExchangeParmsListOID;
    LPRND_CONTEXT		PRSGenerator; /*!<  . */

    KeyCarrierHandle		*Carrier;

    struct {
	volatile LPCRYPT_COMMON_KEY pSecretOnly;
	volatile LPCRYPT_COMMON_KEY pPreUserKey;
    }				 pUserKeys[AT_SIGNATURE+AT_KEYEXCHANGE+2];

    DWORD   CntFlags;
    DWORD   dwEnumAlgsCount;
    DWORD   dwEnumAlgsExCount;
    DWORD   dwEnumOIDsExCount;
    KeyCarrierEnumContainers    *enumContainers;
    KeyCarrierEnumReaders	*enumReaders;
    KeyCarrierEnumExtensions    *enumContainerExtensions;
    DWORD   dwEnumHashOid;
    DWORD   dwEnumCipherOid;
    DWORD   dwEnumSignOid;
    DWORD   dwEnumDHOid;

    ALG_ID				DefaultSignatureAlgId;
    ALG_ID				DefaultExchangeAlgId;

    CPC_LOCK_OBJ		AccessLock;
    PVTABLEPROVSTRUC		pVTable;
    LPCRYPT_CSP			hCSP;

    LPTSTR			media_type;
    LPTSTR			reader_default;
    unsigned			license_restriction;//  ,       
    LPFKCSHAREDKEYS		FKC;
    DWORD			imp_type;
#if defined (TEST_CONTAINER)
    BYTE KeySign[SECRET_KEY_LEN];
#endif /* defined (TEST_CONTAINER)*/
#if !defined EXCLUDE_READER && defined LINUX && !defined CSP_LITE /* , , ""  ! && SECURITY_LEVEL >= KB1*/
    DWORD			stat_cnt_signs;
    DWORD			stat_cnt_keys;
    DWORD			stat_cnt_encryptedkeys;
#endif //!defined EXCLUDE_READER && defined LINUX && !defined CSP_LITE && SECURITY_LEVEL >= KB1
} CRYPT_CONTAINER, *LPCRYPT_CONTAINER;

/*     (  )*/
typedef struct _CRYPT_THREAD_PARAMS_ {
	WORD wLastError;
	WORD wReserved;
} CRYPT_THREAD_PARAMS, *LPCRYPT_THREAD_PARAMS;


/*    */


/*  -  ,    .
 *
 *       TEST_OK;   
 *       ! */
typedef union tester_flags {
    struct _flags {
	/*        */
	unsigned EncryptECB:1;
	unsigned GammingCNT:1;
	unsigned EncryptCFB:1;
	/*        */
	unsigned DecryptECB:1; 
	unsigned DecryptCFB:1;
	    /*  :  */
	unsigned StreamImit:1;
	unsigned OnePassKeyImit:1;
	/*  :  */
	unsigned StreamHash:1;
	unsigned OnePassHash:1;
	/*  : ""  */
	unsigned Signature64:1;
	unsigned VerifySignature64:1;
	/*  : ""  */
	unsigned Signature128:1;
	unsigned SignatureEl:1;
	unsigned VerifySignature128:1;
	unsigned VerifySignatureEl:1;
	unsigned PowMod64:1; /*     512  */
	unsigned PowMod128:1; /*     1024  */
	unsigned PowModEl:1; 
	unsigned Phi:1; /*   */
	unsigned ProcessingKey:1; /*   ProcessingKey */
	unsigned EncryptCBC:1;
	unsigned DecryptCBC:1;
	unsigned MasterKey:1;
	unsigned DiversKey:1;
	unsigned EvalePassWord:1;
	unsigned SharedScret:1;
	unsigned Mod64:1;
	unsigned Integrity:1;
	unsigned Resevd:4;
    } s;
    DWORD i;
} TESTER_FLAGS;

#define TEST_OK_M   {{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0}}
#define TEST_ZERO_M {{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}}

typedef struct _TESTER_TIMERS_ {
    DWORD Period;
    DWORD All;
    DWORD Encrypt;
    DWORD Exp;
    DWORD Sign;
    DWORD Verify;
}TESTER_TIMERS;

#if 0

/*! \internal
 * \brief    .
 *
* \param pData [in/out]    ,   .
* \param dwDataLength [in]     .
* \param pCContext [in]   .
* \param pS_Box [in]   .
* \return TRUE   , FALSE  .
 */

typedef BOOL (*CStreamFunc)( LPBYTE pData,DWORD  dwDataLength,
	LPCRYPT_CIPHER_CONTEXT pCContext,LPCRYPT_DATA_BLOB_EX	pS_Box  );


/*! \internal
 * \brief     .
 *
* \param pData [in/out]    ,   .
* \param dwDataLength [in]     .
* \param pCContext [in]   .
* \param pS_Box [in]   .
* \return TRUE   , FALSE  .
* \param dwCryptMode [in]   .
 */

typedef BOOL (*CommonCStreamFunc)( LPBYTE pData,DWORD  dwDataLength,
	LPCRYPT_CIPHER_CONTEXT pCContext,LPCRYPT_DATA_BLOB_EX	pS_Box,
	DWORD	dwCryptMode);
#endif

typedef struct _CRYPT_CSP_FUNCS_ {
	/*   */
	BOOL (*CContextG28147Imit)(
	    pCP_CALL_CTX  pCallCtx,
	    LPBYTE   pData,		/*  - XOR- */
	    DWORD   dwDataLength,	/*    */
	    LPCRYPT_CIPHER_CONTEXT pCContext,/*  */
	    LPCRYPT_DATA_BLOB_EX pS_Box );
	
	
	/*       */
	BOOL (*CContextG28147DecryptMaskECB)(
	    pCP_CALL_CTX  pCallCtx,
	    LPBYTE   pData,	    /*   				*/
	    LPBYTE   pDataMask,	    /*   */
	    DWORD   dwDataLength,   /*    ( SIZE_GOST_BLOCK_BYTE)*/
	    LPCRYPT_CIPHER_CONTEXT pCContext,	/*  */
	    LPCRYPT_DATA_BLOB_EX pS_Box,
	    BOOL  CheckContext    );

	BOOL (*CContextG28147EncryptECB)(
	    pCP_CALL_CTX pCallCtx,
	    LPBYTE   pData,		
	    DWORD   dwDataLength,	
	    LPCRYPT_CIPHER_CONTEXT pCContext,	
	    LPCRYPT_DATA_BLOB_EX pS_Box,
	    DWORD dwHorLE );
	
	BOOL (*CContextG28147DecryptECB)(
	    pCP_CALL_CTX pCallCtx,
	    LPBYTE   pData,		
	    DWORD   dwDataLength,	
	    LPCRYPT_CIPHER_CONTEXT pCContext,	
	    LPCRYPT_DATA_BLOB_EX pS_Box);
	
	/*      */
	BOOL (*CContextG28147EncryptCBC)(	
	    pCP_CALL_CTX pCallCtx,
	    LPBYTE pData,
	    DWORD  dwDataLength,
	    LPCRYPT_CIPHER_CONTEXT pCContext,
	    LPCRYPT_DATA_BLOB_EX pS_Box);

	BOOL (*CContextG28147DecryptCBC)(
	    pCP_CALL_CTX   pCallCtx,
	    LPBYTE	   pData,	
	    DWORD	   dwDataLength,
	    LPCRYPT_CIPHER_CONTEXT pCContext,	
	    LPCRYPT_DATA_BLOB_EX pS_Box );

	BOOL (*CContextG28147GammaCNT)(
	    pCP_CALL_CTX pCallCtx,
	    LPBYTE	pData,
	    DWORD	dwDataLength,
	    LPCRYPT_CIPHER_CONTEXT pCContext,
	    LPCRYPT_DATA_BLOB_EX	pS_Box	);

	/*     .*/
	BOOL (*CContextG28147EncryptCFB)(
	    pCP_CALL_CTX pCallCtx,
	    LPBYTE  pData,
	    DWORD   dwDataLength,
	    LPCRYPT_CIPHER_CONTEXT pCContext,
	    LPCRYPT_DATA_BLOB_EX	pS_Box);

	BOOL (*CContextG28147DecryptCFB)(
	    pCP_CALL_CTX pCallCtx,
	    LPBYTE	pData,
	    DWORD	dwDataLength,
	    LPCRYPT_CIPHER_CONTEXT pCContext,
	    LPCRYPT_DATA_BLOB_EX	pS_Box	);
/* XXX Borodin */
	BOOL (*MultModP_256Ex)(pCP_CALL_CTX pCallCtx,uint64_t*Res,uint64_t*M1,uint64_t*M2,uint64_t* P,
	    uint64_t *ReduceTabP_256,uint64_t*P_Mult2,DWORD OPT_modP);

	CSP_HASH_FUNCS Hash;
#if 0
	CommonCStreamFunc CommonCNTGamming,CommonCFBEncrypt,CommonCFBDecrypt;
	CommonCStreamFunc CommonCNTGammingI,CommonCFBEncryptI,CommonCFBDecryptI;
	CommonCStreamFunc CommonCNTGammingH,CommonCFBEncryptH,CommonCFBDecryptH;
#endif
} CRYPT_CSP_FUNCS;

#if defined(PRO_MAP_ALLOC)
typedef struct _HANDLE_ID_ {
        LPVOID      p;
        DWORD       heap;
        DWORD       line;
        long long   CtxId;
        const char  * fname;
        const char  * fcall;
} HANDLE_ID, *LPHANDLE_ID;
#define N_HID 4000
#endif

#if 1//defined MCT_COUNT 
typedef struct _MCT_ID_ {
	char	    frg[32];	
	double	    t;
	LONGLONG    d;
} MCT_ID, *LPMCT_ID;
#define N_MCT 2000
#endif /*MCT_COUNT*/


#include "CSPHandles.h"

struct _CRYPT_CSP_ {
  CPC_FUNCTION_TABLE		vtbl;
  DWORD				cbAlgs;
  const PROV_ENUMALGS_EX	**AlgsInfo;
  /* DWORD					dwANSI_TLS; unused ??? */
  /*     */
  LPCRYPT_DATA_BLOB_EX	pDefaultPRSGS_Box;
  LPCRYPT_DATA_BLOB_EX	pDefaultPRSG_StartHashVector;
  
  LPRND_CONTEXT			PRSGenerator; /*!<  . */
  void *pHandlePhisRndmContext;
  void *random_list;
  
  DWORD   dwEnumContainersCount;
  LONG	dwContextCount;
  DWORD	dwCheckPublic;
  /*  .*/
  CRYPT_OBJECT_LIST		OID_ParamsList; 
  CPC_LOCK_OBJ			ParamsLock;
  CSPHandleTable		handles;
  
  DWORD_PTR			dwTesterSec;
  TESTER_FLAGS			TesterFlags;
  LONG				dwTesterPassFlag;
  TESTER_TIMERS			TestrTimers;
  CPC_LOCK_OBJ			TesterLock;
  ULONGLONG			dwTesterTSC;
  
  CRYPT_CSP_FUNCS		CSPFuncs;
  
  CPC_CONFIG2			Config;
  BOOL				fSerialize;

  HCRYPTPROV			default_encryption_carrier;

  DWORD				n_encryption_carriers;
  HCRYPTPROV *			p_encryption_carriers;

  /* table of other containers */

  TSupportDbContext *		cpdb_ctx;

  BOOL				fPRSGeneratorInited;

  /* Its really Good Thing To Do - move cond.compil. to end of struct... */
#if !defined( EXCLUDE_READER ) 
  CPC_RWLOCK			ReaderLock; /*   carrier_context_default */
  KeyCarrierList		*carrier_context_default;
  TSupRegNotificator		*ParamNotificator;
  long				need_stat; /*      */
  long				need_audit; /* need only for HSM */
  BOOL				bCertStoreParamsSupported;
  TCHAR				ProductCode[38 + 1];
#endif /*EXCLUDE_READER*/
#if defined PRO_MAP_ALLOC 
  CPC_LOCK_OBJ ProMapLock;
  LPHANDLE_ID pph_id;
  DWORD n_hid;
#endif /*PRO_MAP_ALLOC*/
#if defined MCT_COUNT 
  LPMCT_ID ppmct_id;
  DWORD n_mct;
#endif /*MCT_COUNT*/
};

/* ***************************************************************************/
/*  6.*/
/*     .*/
/* ***************************************************************************/
//BOOL RegSaveRootRandomSeed(LPCRYPT_DATA_BLOB_EX pRandomSeed);

BOOL SetPhisicRSG (pCP_CALL_CTX pCallCtx, DWORD cInitPRSG, BOOL start, ULONG mask, 
    ULONG rngvalue, HWND hwnd);


/* ***  6 **************************************************************/





/* **********************************************************************/
/*   7.*/
/*	    .*/
/* **********************************************************************/

/*   */
LPCRYPT_OBJECT_HEADER
CreateCryptObject(
	pCP_CALL_CTX pCallCtx,
	LPCRYPT_CONTAINER  pContainer,
	ALG_ID			   AlgId,
	DWORD			   dwFlags,
	LPVOID			   pvParams
	);

LPCRYPT_OBJECT_HEADER
CreateUserCryptObject (pCP_CALL_CTX pCallCtx,
    LPCRYPT_CONTAINER pContainer,
    ALG_ID AlgId, DWORD dwFlags, DWORD dwParams
    );
BOOL
CompleteUserKey(pCP_CALL_CTX pCallCtx,
    LPCRYPT_CONTAINER pContainer,
    LPCRYPT_COMMON_KEY pckKeyPair
    );

/*  */
BOOL
DestroyCryptObject(
	pCP_CALL_CTX pCallCtx,
	LPCRYPT_CONTAINER     pContainer,
	LPCRYPT_OBJECT_HEADER pDstrObj
	);

/*     */
void AddCryptObjToContainer(pCP_CALL_CTX pCC, LPCRYPT_CONTAINER pContainer, ALG_ID ObjClassAlgId, DWORD dwObjType, /* SECRET_KEY, PUBLIC_KEY*/ LPCRYPT_OBJECT_HEADER pAddObjHeader );

/*      */
BOOL
DelCryptObjFromContainer(
	pCP_CALL_CTX pCallCtx,
	LPCRYPT_CONTAINER	  pContainer,
	LPCRYPT_OBJECT_HEADER pDelObjHeader
	);

/*   */
LPCRYPT_OBJECT_HEADER
DuplicateCryptObject(
	pCP_CALL_CTX pCallCtx,
	LPCRYPT_CONTAINER		pContainer,
	LPCRYPT_OBJECT_HEADER	pSrcCryptObject
	);

/* ***  7 *********************************************************/





/* **********************************************************************/
/*   8.*/
/*	    CRYPT_KEY_MATERIAL ( ).*/
/* **********************************************************************/
LPCRYPT_KEY_MATERIAL
DuplicateKeyMaterial_(
	pCP_CALL_CTX pCallCtx,
	LPRND_CONTEXT pRndContext,
	LPCRYPT_KEY_MATERIAL pkmSrcKey,
	DWORD dwNeedRemask );

BOOL
CreateUserKeyData(
    pCP_CALL_CTX pCallCtx,
    LPRND_CONTEXT  pRndContext,LPDWORD pKeyData,  DWORD dwKeyLen,
    LPDWORD Q, DWORD dwLow);

BOOL
InitUserKeyMaterial(
    pCP_CALL_CTX pCallCtx,
    LPRND_CONTEXT  pRndContext,
    LPCRYPT_KEY_MATERIAL pKeyMaterial,
    LPBYTE	  pKeyBody, 
    DWORD	  dwKeyLen,
    DWORD	  dwKeyType,
    DWORD	  dwMaskType,
    const ASN1OBJID*	  pszKeyParamOID,
    BOOL	  bntoh );

LPCRYPT_KEY_MATERIAL
CreateUserKeyMaterial(
    pCP_CALL_CTX pCallCtx,
    LPRND_CONTEXT  pRndContext,
    LPBYTE	  pKeyBody, 
    DWORD	  dwKeyLen,
    DWORD	  dwKeyType,
    DWORD	  dwMaskType,
    const ASN1OBJID*  pszKeyParamOID,
    BOOL	  bntoh );

/*      */
BOOL
VerifyKeyMaterial(LPCRYPT_KEY_MATERIAL pKeyMaterial);
/*     
 *   */
void
CheckKeyMaterial(LPCRYPT_KEY_MATERIAL pKeyMaterial);

/*      	*/
LPCRYPT_KEY_MATERIAL 
CreatePublicKeyMaterial (
    pCP_CALL_CTX pCallCtx,
    LPRND_CONTEXT pRndContext,    
    LPCRYPT_GR3410_KEYPAIR pKeyPair);

/*  CRYPT_KEY_MATERIAL*/
LPCRYPT_KEY_MATERIAL DuplicateUserKeyMaterial(
    pCP_CALL_CTX pCallCtx,
    LPRND_CONTEXT pRndContext,    
    LPCRYPT_KEY_MATERIAL pkmSrcKey,
    LPCRYPT_PARAMS pPQAParms,	  
    DWORD dwDstMaskType  );

/*  CRYPT_KEY_MATERIAL     */
BOOL
CopyKeyMaterial(
	pCP_CALL_CTX pCallCtx,
	LPRND_CONTEXT pRndContext,
	LPCRYPT_KEY_MATERIAL pkmDstKey,
	LPCRYPT_KEY_MATERIAL pkmSrcKey );
BOOL
CmpKeyMaterial(LPCRYPT_KEY_MATERIAL pkmKey1, LPCRYPT_KEY_MATERIAL pkmKey2);

/*   CRYPT_KEY_MATERIAL*/
BOOL
ExportKeyMaterial(
	pCP_CALL_CTX pCallCtx,
/*	LPRND_CONTEXT pRndContext,*/
	LPCRYPT_KEY_MATERIAL	pkmKey,
	LPBYTE			pbBlobBuf,
	LPCRYPT_SESSION_KEY	pckExpKey,
/*	LPBYTE			pbExpVector,*/
	DWORD			dwBlobType );

/*   CRYPT_KEY_MATERIAL*/
LPCRYPT_KEY_MATERIAL
ImportKeyMaterial(
	pCP_CALL_CTX pCallCtx,
	LPRND_CONTEXT pRndContext,
	DWORD			   dwKeyLen,
	LPCRYPT_SESSION_KEY pckImpKey,
	LPBYTE			   pbBlob,
/*	LPBYTE			   pbImpVector,*/
	DWORD			   dwBlobType,
	DWORD			   dwKeyType
	);
BOOL ExportUserKeyMaterial(
    pCP_CALL_CTX pCallCtx,
    LPCRYPT_KEY_MATERIAL pkmKey,    
    LPBYTE pbBlobBuf,
    LPCRYPT_SESSION_KEY pckExpKey,    
    DWORD dwBlobType  );
LPCRYPT_KEY_MATERIAL
ImportUserKeyMaterial(
    pCP_CALL_CTX pCallCtx,
    LPRND_CONTEXT		   pRndContext,
    DWORD			   dwKeyLen,
    LPCRYPT_SESSION_KEY		   pckImpSessKey,
    LPBYTE			   pbBlob,
    const ASN1OBJID               *key_oid,
    DWORD			   dwBlobType);
/*   */
BOOL
RemaskKeyMaterial(
	pCP_CALL_CTX pCallCtx,
	LPRND_CONTEXT pRndContext,
	LPCRYPT_KEY_MATERIAL pKeyMaterial
	);

/*  CRYPT_KEY_MATERIAL*/
void
DestroyKeyMaterial(
	pCP_CALL_CTX pCallCtx,
	LPCRYPT_KEY_MATERIAL pKeyMaterial
	);

LPCRYPT_KEY_MATERIAL CreateUserPublicKeyMaterialLow (
    pCP_CALL_CTX pCallCtx,
    LPRND_CONTEXT pRndContext,
    LPCRYPT_PARAMS OIDandPQAParms,
    LPCRYPT_KEY_MATERIAL pkmSecretKey,
    DWORD dwKeyAlg,
    DWORD dwKeyLen);

ASN1OBJID* ASN1OBJID_dup(pCP_CALL_CTX  pCallCtx, ASN1OBJID* pOID);

#if 0
LPCRYPT_KEY_MATERIAL 
CreatePublicKeyMaterialLow (
    pCP_CALL_CTX pCallCtx,
    LPRND_CONTEXT pRndContext,
    LPCRYPT_PARAMS OIDandPQAParms,
    LPCRYPT_KEY_MATERIAL pkmSecretKey,
    DWORD dwKeyAlg,
    DWORD dwKeyLen );
#endif /* 0 */
/* ***  8 *********************************************************/





/* **********************************************************************/
/*   9.*/
/*	    CRYPT_DATA_BLOB_EX (  */
/*   ).*/
/* **********************************************************************/

/*  CRYPT_DATA_BLOB_EX*/
LPCRYPT_DATA_BLOB_EX
CreateDataBlob(
	pCP_CALL_CTX pCallCtx,
	LPDWORD pbData,
	DWORD  dwDataLen,
	DWORD  dwMemPoolId,
	BOOL   FreeMem,
	BOOL   CheckOn
	);
/*  CRYPT_DATA_BLOB_EX*/
#if 0
LPCRYPT_DATA_BLOB_EX
DuplicateDataBlob(
	pCP_CALL_CTX pCallCtx,
	LPCRYPT_DATA_BLOB_EX pdbSrcDataBlob
	);
#endif /* 0 */
/*   CRYPT_DATA_BLOB_EX*/
BOOL
ExportDataBlob(
/*	LPCRYPT_CONTAINER     pContainer,*/
	LPCRYPT_DATA_BLOB_EX pcdData,
	LPBYTE			      pbBlobBuf,
	LPCRYPT_COMMON_KEY    pckExpKey,
/*	LPBYTE			      pbExpVector,*/
	DWORD			      dwBlobType
	);

/*   CRYPT_DATA_BLOB_EX*/
LPCRYPT_DATA_BLOB_EX
ImportDataBlob(
/*	LPCRYPT_CONTAINER  pContainer,*/
	DWORD			   dwBlobLen,
	LPCRYPT_COMMON_KEY pckImpKey,
	LPBYTE			   pbBlob,
/*	LPBYTE			   pbImpVector,*/
	DWORD			   dwBlobType,
	DWORD			   dwMemType,
	BOOL			   CheckOn
	);

/*  CRYPT_DATA_BLOB_EX*/
BOOL
DestroyDataBlob(
	pCP_CALL_CTX pCallCtx,
	LPCRYPT_DATA_BLOB_EX pDataBlob
	);

/* ***  9 *********************************************************/


/*   PRF*/
BOOL
GOSTR3411_PRF (
	pCP_CALL_CTX pCallCtx,
	LPCRYPT_CONTAINER	pContainer,
        LPCRYPT_KEY_MATERIAL	pckKey,
        DATA_BLOB   *pData,
        DWORD        cData,
        BYTE        *pbDigest,
        DWORD       dwDigestLen);

LPCRYPT_KEY_MATERIAL
GOSTR3411_PRFKEY (
	pCP_CALL_CTX		pCallCtx,
	LPCRYPT_CONTAINER	pContainer,
	LPCRYPT_COMMON_KEY	pKey);


/* **********************************************************************/
/*   10.*/
/*	 .*/
/* **********************************************************************/

/*     */
BOOL
CheckProcCorrect(
	DWORD dwProcId
	);

/*void CleaKey( LPCRYPT_COMMON_KEY pKey );*/
/*void CleaKeyMat( LPCRYPT_KEY_MATERIAL pKeyMat );*/

//void			CPCSPDelHandle (pCP_CALL_CTX pCallCtx, LPCRYPT_CONTAINER pProv, LPCRYPT_OBJECT_HEADER pCPCSPHandle);
void			CPCSPDelLockedHandle (pCP_CALL_CTX pCallCtx, DWORD_PTR dwHandle);
#if !defined( __BOUNDSCHECKER__ )
	//     
    DWORD		TODO_XXX_NOBOUNDSCHECKER_AddLockFreeList (pCP_CALL_CTX pCallCtx, LPCRYPT_OBJECT_HEADER pCPCSPHandle, LPCRYPT_CONTAINER pProv);
    DWORD		TODO_XXX_NOBOUNDSCHECKER_RemoveLockFreeList (pCP_CALL_CTX pCallCtx, LPCRYPT_OBJECT_HEADER pCPCSPHandle, LPCRYPT_CONTAINER pProv);
    DWORD		TODO_XXX_NOBOUNDSCHECKER_AllRemoveLockFreeList (pCP_CALL_CTX pCallCtx, LPCRYPT_CONTAINER pProv);
#endif /* !defined( __BOUNDSCHECKER__ ) */
DWORD			CPCSPNewHandle (pCP_CALL_CTX pCallCtx, LPCRYPT_OBJECT_HEADER pCPCSPHandle, LPCRYPT_CONTAINER pProv);
LPCRYPT_OBJECT_HEADER	CPCSPGetHandle (pCP_CALL_CTX pCallCtx, DWORD_PTR pSecHandle, DWORD dwHandleType, DWORD dwMode);
void			CPCSPReleaseHandle (pCP_CALL_CTX pCallCtx, LPCRYPT_OBJECT_HEADER pCPCSPHandle, DWORD dwMode);
void			CPCSPFreeAllContexts (pCP_CALL_CTX pCallCtx, const LPCRYPT_CONTAINER pProv);
BOOL			CPCSPInitHandleTable (pCP_CALL_CTX pCallCtx, BOOL serialize);
void			CPCSPFreeHandleTable (pCP_CALL_CTX pCallCtx);

/*#pragma warning (pop)*/

#ifdef CSP_LITE
extern void *CRWLock_mutex_arg;
#else
#define CRWLock_mutex_arg NULL
#endif

typedef BOOL (*GetParamFun)(
    pCP_CALL_CTX pCallCtx,
    RND_CONTEXT *rnd_context, 
    KeyCarrierHandle *key_carrier_handle,
    ASN1OBJID *param,
    ALG_ID type );

#ifndef EXCLUDE_READER
extern BOOL get_param (pCP_CALL_CTX pCallCtx, RND_CONTEXT *rnd_context, KeyCarrierHandle*, GetParamFun, ASN1OBJID **, ALG_ID type ); 
/* extern BOOL set_param (KeyCarrierHandle, GetParamFun, const char *); */
#endif /*EXCLUDE_READER*/

typedef struct selectwnd_enum_args_ {
    pCP_CALL_CTX pCallCtx;
    KeyRdrListCacheElement *swe_ce_rdr_list;
    LPCTSTR media_type;
    LPCTSTR reader_name;
} selectwnd_enum_args;

typedef struct selectwnd_enum_info_ {
    KeyCarrierEnumContainers *info;
    CRYPT_UINT_BLOB blob;
    DWORD size;
} selectwnd_enum_info;

extern HRESULT WINAPI selectwnd_enum_open (
    void *arg, void **ctx, DWORD flags );
extern HRESULT WINAPI selectwnd_enum_next (
    void *arg, void *ctx, CPUISelectItem* item );
extern HRESULT WINAPI selectwnd_enum_close (
    void *arg, void *ctx );

extern LPCRYPT_CSP CPGetDefaultCSP();

#ifdef __cplusplus
}
#endif
/*      -     */
#endif /* _CSPKERNEL_H_INCLUDED */
/* end of file:$Id: CSPKernel.h 104242 2014-03-27 07:42:44Z lse $ */
