/* vim:set sw=4 ts=8 fileencoding=cp1251:::WINDOWS-1251[] */
#ifdef _WIN32
    #pragma setlocale("rus")
#endif
/*
 * Copyright(C) 2013  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */
/*!
 * \version $Revision: 89611 $
 * \date $Date: 2013-05-29 23:43:11 +0400 (ср, 29 май 2013) $
 * \author $Author: lse $
 *
 * \brief   TLS  
 */

#ifndef __KTLS_h__
#define __KTLS_h__

#if !defined(_MSC_VER)
    #include "CSP_WinDef.h"
    #include "ntstatus.h"
    typedef ULONG NTSTATUS;
#endif

#include "wincspc.h"
#include "CSP_Sspi.h"
#include "ipsec/include/sadb.h"

typedef void CAPI_EXTC
KTLSLogDecl(void *pUfnAgr, 
	   log_severity_t severity, unsigned uFlags, 
	   const char *fmt, ...);

typedef void CAPI_EXTC
KTLSSetLogLvlDecl(void *pUfnAgr, log_severity_t severity, unsigned uFlags);

typedef struct ktls_gost_in_st {
    void             *pUfnArg;
    /*!< \brief    .*/
    KTLSLogDecl	     *LogUfn;
    /*!< \brief   #LogUfn,   0.*/
    KTLSSetLogLvlDecl *SetLogLvlUfn;
    /*!< \brief    #SetLogLvlUfn,    #LogUfn.*/
    unsigned         allocatedMem;
    /*!< \brief    ktls_gost_handle  (  requiredMem  #esp_gost_out).*/
    void*            reserved[4];
    /*!< \brief ,  ,  .*/
    LPCPC_CONFIG pConfig;
    HCRYPTMODULE hCSP;
} ktls_gost_in;

typedef struct ktls_gost_out_st {
    unsigned requiredMem;
    /*!< \brief   ktls_gost_handle  .*/
   void*    reserved[7];
    /*!< \brief ,  ,  .*/
} ktls_gost_out;

typedef struct 
{
    int dummy;
} *CPKTLS_HANDLE; 

typedef struct _CPKTLS_vtbl_ CPKTLS_VTBL, * ktls_gost_handle;

#define CPKTLS_CONTEXT_EXPORT_TO_USER    (0x10000)  //   
#define CPKTLS_CONTEXT_EXPORT_DELETE_OLD (0x20000)  //    

/*
cpktls_init_gost()
   TLS.
*/
DWORD CAPI_EXTC cpktls_init_gost(
    ktls_gost_handle h,
    const ktls_gost_in *in,
    unsigned uFlags,
    ktls_gost_out *out
);

/*
cpktls_shutdown_gost()
    TLS.
*/
DWORD CAPI_EXTC cpktls_shutdown_gost (
    ktls_gost_handle h,
    unsigned uFlags
);

/*
ImportContext()
     ( ImportSecurityContext()  ).
*/
typedef DWORD CAPI_EXTC ImportContext_t (
    ktls_gost_handle h,
    PSecBuffer pPackedContext, // (in) marshalled context
    PRIVKEY *hPriv,
    PUBKEY *hPub,
    unsigned uFlags, 
    CPKTLS_HANDLE *phCtx
);

/*
ExportContext()
 CPExportSecurityContext()     ( ExportSecurityContext()  ).
*/
typedef DWORD CAPI_EXTC ExportContext_t (
    ktls_gost_handle h,
    CPKTLS_HANDLE hCtx,
    PRIVKEY *hPriv,
    PUBKEY *hPub,
    unsigned uFlags,
    PSecBuffer pPackedContext // (out) marshalled context
);

/*
Seal()
      ,     ,    ( EncryptMessage()  ).
*/
typedef DWORD CAPI_EXTC Seal_t (
    ktls_gost_handle h,
    CPKTLS_HANDLE hCtx,
    IN ULONG fQOP,
    IN OUT PSecBufferDesc Message,
    IN ULONG MessageSeqNo 
);

/*
UnSeal()
  ,               ( DecryptMessage()  ).
*/
typedef DWORD CAPI_EXTC UnSeal_t (
    ktls_gost_handle h,
    CPKTLS_HANDLE hCtx,
    IN OUT PSecBufferDesc Message,
    IN ULONG MessageSeqNo,
    OUT PULONG pfQOP 
);

/*
QueryAttributes()
       ( QueryContextAttributes()  ).
*/
typedef DWORD CAPI_EXTC QueryAttributes_t (
    ktls_gost_handle h,
    CPKTLS_HANDLE hCtx,
    IN ULONG Attribute,
    IN OUT PVOID Buffer
);

/*
CompleteToken()
      ( ApplyControlToken()  ).
*/
typedef DWORD CAPI_EXTC CompleteToken_t (
    ktls_gost_handle h,
    CPKTLS_HANDLE hCtx,
    IN PSecBufferDesc Token
);

/*
   ,     ( DeleteSecurityContext()  ).
*/
typedef DWORD CAPI_EXTC DeleteContext_t (
    ktls_gost_handle h,
    unsigned uFlags,
    CPKTLS_HANDLE hCtx
);

struct _CPKTLS_vtbl_
{
    ImportContext_t * ImportContext;
    ExportContext_t * ExportContext;
    Seal_t * Seal;
    UnSeal_t * UnSeal;
    QueryAttributes_t * QueryAttributes;
    CompleteToken_t * CompleteToken;
    DeleteContext_t * DeleteContext;
    GEN_SADB tlsdb;
};

#endif
