/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 81059 $
 * \date $Date: 2012-09-16 16:00:29 +0400 (Вск, 16 Сен 2012) $
 * \author $Author: dim $
 *
 * \brief   .
 */

#ifndef _KEYPAIROPERS_H_INCLUDED
#define _KEYPAIROPERS_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

#define GR3410_SECRET_LEN 32
#define GR3410_SECRET_LENDW 8
#define GR3410_DEFAULT_MODULUS_LEN 128
#define GR3410_SHORT_MODULUS_LEN 64
#define GR3410_ELLIPTIC_MODULUS_LEN 32
#define GR3410_Q_LEN 32 

typedef struct _CRYPT_GR3410_SIGNATURE_ {
    BUFFER32 r_;
    BUFFER32 s;
} CRYPT_GR3410_SIGNATURE, *LPCRYPT_GR3410_SIGNATURE;

#ifdef TEST_CONTAINER
#define KC1_EXPORT	0x8a73d5cf
#endif /*TEST_CONTAINER*/


/* ***************************************************************************/
/*  1.*/
/*      .  .*/
/* ***************************************************************************/

/*!   .
 *    pKeyPairBlob -   . */
extern LPCRYPT_COMMON_KEY CreateKeyPair (
    pCP_CALL_CTX pCallCtx, LPCRYPT_CONTAINER pContainer,
    LPBYTE pKeyPairBlob, DWORD dwBlobLen, ALG_ID AlgId,
    LPCRYPT_COMMON_KEY pImportKey, DWORD dwKeyFlags, DWORD dwGenFlags,
    LPCRYPT_KEY_MATERIAL pSecretMaterial, LPCRYPT_KEY_MATERIAL pPublicMaterial, 
    LPLIST_OID_PARAMS pPQAParamsOID, LPLIST_OID_PARAMS pHashParamsOID);


/*!    */
extern LPCRYPT_COMMON_KEY DuplicateKeyPair (pCP_CALL_CTX pCallCtx, 
    LPCRYPT_CONTAINER pContainer, LPCRYPT_COMMON_KEY pKeyPair);
/*!    */
extern BOOL ExportKeyPair (pCP_CALL_CTX pCallCtx, LPCRYPT_CONTAINER pContainer,
    LPCRYPT_COMMON_KEY pKeyPair, LPCRYPT_COMMON_KEY pExportKey,
    DWORD dwBlobType, DWORD dwFlags, LPBYTE pKeyPairBlob, DWORD *pBlobLen);
/*!    */
extern void DestroyKeyPair (pCP_CALL_CTX pCallCtx, LPCRYPT_COMMON_KEY pDstrPubKey);
extern BOOL DestroyUserKey (LPCRYPT_CONTAINER pContainer);

/*!     */
extern BOOL GetKeyPairParam (pCP_CALL_CTX pCallCtx, LPCRYPT_CONTAINER pContainer,
    LPCRYPT_COMMON_KEY pckKey, DWORD dwParam, BYTE *pbData, DWORD *pdwDataLen);
/*!     */
extern BOOL SetKeyPairParam (pCP_CALL_CTX pCallCtx, LPCRYPT_CONTAINER pContainer,
    LPCRYPT_COMMON_KEY pckKey, DWORD dwParam, BYTE *pbData/*, DWORD dwFlags*/);

/* **********************************************************************/
/*  3.*/
/* **********************************************************************/

/*!       -. */
extern LPCRYPT_COMMON_KEY CreateDHExchangeKey (
    pCP_CALL_CTX pCallCtx,
    LPCRYPT_CONTAINER pContainer,
    LPCRYPT_COMMON_KEY pPrivate, 
    LPCRYPT_COMMON_KEY pPublic 
//    LPCRYPT_GR3410_PUBLICKEY_INFO pkiPublicKeyInfo
    );
				
/* **********************************************************************/
/*  4.*/
/*  /  .  .*/
/* **********************************************************************/

//#if !defined CSP_LITE
    /*! ""  ()  */
    LPCRYPT_COMMON_KEY CUK_OpenUserKey_interlocked(pCP_CALL_CTX pCallCtx,
			LPCRYPT_CONTAINER pContainer, 
			DWORD dwKeySpec, DWORD dwFlags, DWORD IsSign);
    void CUK_clear(pCP_CALL_CTX pCallCtx, LPCRYPT_CONTAINER pContainer);

    /*!      */
    BOOL SignHash (pCP_CALL_CTX, LPCRYPT_CONTAINER, LPCRYPT_COMMON_HASH, DWORD,
	LPCWSTR, BYTE *, LPDWORD);
//#endif /* CSP_LITE */

/*!    */
extern BOOL VerifySignature (pCP_CALL_CTX, LPCRYPT_CONTAINER, LPCRYPT_COMMON_HASH,	
    CONST BYTE*, DWORD, LPCRYPT_COMMON_KEY, LPCWSTR);

BOOL CheckKeyData(LPBYTE pKeyData, LPBYTE Q, DWORD dwLow, DWORD dwKeyLen);
BOOL CheckExpPubKey(pCP_CALL_CTX pCallCtx, LPCRYPT_COMMON_KEY pkPublic);
BOOL CheckECCPubKey(pCP_CALL_CTX pCallCtx, LPCRYPT_COMMON_KEY pkPublic);
BOOL CheckDHKey(LPCRYPT_COMMON_KEY pkDHKey);
BOOL CheckPublicMaterial (pCP_CALL_CTX pCallCtx, LPCRYPT_KEY_MATERIAL pkmPublic, DWORD AlgId, LPCRYPT_PARAMS OIDandPQAParms,DWORD dwCheck);
BOOL CheckCertParameters (pCP_CALL_CTX pCallCtx, LPCRYPT_COMMON_KEY pckKey, const BYTE* pbCert, DWORD cbCert);
#ifdef __cplusplus
}
#endif

#endif /* _KEYPAIROPERS_H_INCLUDED */
/* end of file: $Id: KeyPairOpers.h 81059 2012-09-16 12:00:29Z dim $ */
