/* vim:set sw=4 ts=8 fileencoding=cp1251:::WINDOWS-1251[] */
#ifdef _WIN32
    #pragma setlocale("rus")
#endif
/*
 * Copyright(C) 2013  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */
/*!
 * \version $Revision: 89611 $
 * \date $Date: 2013-05-29 23:43:11 +0400 (ср, 29 май 2013) $
 * \author $Author: lse $
 *
 * \brief     TLS   
 *          .
 */

#ifndef __UTLS_h__
#define __UTLS_h__

#if !defined(_MSC_VER)
    #include "CSP_WinDef.h"
    #include "ntstatus.h"
    typedef ULONG NTSTATUS;
#endif

#include "wincspc.h"
#include "CSP_Sspi.h"
#include "ipsec/include/sadb.h"
typedef struct
{
    PRIVKEY Priv;
    PUBKEY Pub;
} utlsdb_token;
typedef struct _CPUTLS_vtbl_ CPUTLS_VTBL, * utls_gost_handle;
struct _CPUTLS_vtbl_
{
    GEN_SADB tlsdb;
    PSecurityFunctionTable pSSPI;
};
typedef struct utls_gost_in_st {
   unsigned         allocatedMem;
    /*!< \brief    ktls_gost_handle  (  requiredMem  #esp_gost_out).*/
    void*            reserved[7];
    /*!< \brief ,  ,  .*/
} utls_gost_in;

typedef struct utls_gost_out_st {
    unsigned requiredMem;
    /*!< \brief   esp_gost_handle  .*/
   void*    reserved[7];
    /*!< \brief ,  ,  .*/
} utls_gost_out;

#define CPUTLS_CONTEXT_EXPORT_TO_KERNEL  (0x1000)   //      
#define CPUTLS_CONTEXT_EXPORT_RESET_NEW	 (0x2000)   //  master_secret    
#define CPUTLS_CONTEXT_EXPORT_DELETE_OLD (0x4000)   //    
#define CPUTLS_ATTR_CREDENTIAL_HANDLE	 (0x1001)   //        Credentials

/*
cputls_init_gost()
     TLS.
*/
DWORD cputls_init_gost(
    utls_gost_handle h,
    const utls_gost_in *in,
    unsigned uFlags,
    utls_gost_out *out
);

/*
cputls_shutdown_gost()
    TLS.
*/
DWORD cputls_shutdown_gost (
    utls_gost_handle h,
    unsigned uFlags
);
#endif



