/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 36827 $
 * \date $Date: 2006-10-25 19:33:44 +0400 (Срд, 25 Окт 2006) $
 * \author $Author: pre $
 *
 * \brief   Cryptography Service Provider.
 *
 *   DLL,     cpcsp.dll
 */
#ifndef _WINRMCSP_H_INCLUDED
#define _WINRMCSP_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

#include "wincsp.h"

typedef struct hrmcryptprov_dummy_stuff *HRMCRYPTPROV;

typedef struct RMCSP_VTABLE_CONFIG {
    DWORD m_version;
    DWORD m_magic;
    DWORD m_check;
} RMCSP_VTABLE_CONFIG;

extern BOOL WINAPI RmCPAcquireContext (
    /* [out] */ HRMCRYPTPROV *phProv,
    /* [string][in] */ CHAR *pszContainer,
    /* [in] */ DWORD dwFlags,
    /* [in] */ PVTABLEPROVSTRUC pVTable);

extern BOOL WINAPI RmCPReleaseContext (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ DWORD dwFlags);

extern BOOL WINAPI RmCPGetProvParam ( 
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ DWORD dwParam,
    /* [size_is][out] */ BYTE *pbData,
    /* [out][in] */ DWORD *pdwDataLen,
    /* [in] */ DWORD dwFlags);

extern BOOL WINAPI RmCPSetProvParam (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ DWORD dwParam,
    /* [size_is][in] */ BYTE *pbData,
    /* [in] */ DWORD dwFlags);

extern BOOL WINAPI RmCPGenKey (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ ALG_ID Algid,
    /* [in] */ DWORD dwFlags,
    /* [out] */ HCRYPTKEY *phKey);

extern BOOL WINAPI RmCPDestroyKey (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTKEY hKey);

extern BOOL WINAPI RmCPCreateHash (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ ALG_ID Algid,
    /* [in] */ HCRYPTKEY hKey,
    /* [in] */ DWORD dwFlags,
    /* [out] */ HCRYPTHASH *phHash);

extern BOOL WINAPI RmCPDestroyHash (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTHASH hHash);

extern BOOL WINAPI RmCPEncrypt (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTKEY hKey,
    /* [in] */ HCRYPTHASH hHash,
    /* [in] */ BOOL Final,
    /* [in] */ DWORD dwFlags,
    /* [size_is][out][in] */ BYTE *pbData,
    /* [out][in] */ DWORD *pdwDataLen,
    /* [in] */ DWORD dwBufLen);

extern BOOL WINAPI RmCPDecrypt (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTKEY hKey,
    /* [in] */ HCRYPTHASH hHash,
    /* [in] */ BOOL Final,
    /* [in] */ DWORD dwFlags,
    /* [full][size_is][out][in] */ BYTE *pbData,
    /* [out][in] */ DWORD *pdwDataLen);

extern BOOL WINAPI RmCPDeriveKey (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ ALG_ID AlgId,
    /* [in] */ HCRYPTHASH hBaseData,
    /* [in] */ DWORD dwFlags,
    /* [out] */ HCRYPTKEY *phKey);

extern BOOL WINAPI RmCPDuplicateKey (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTKEY hKey,
    /* [full][in] */ DWORD *pdwReserved,
    /* [in] */ DWORD dwFlags,
    /* [out] */ HCRYPTKEY *phKey);

extern BOOL WINAPI RmCPDuplicateHash (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTHASH hHash,
    /* [full][in] */ DWORD *pdwReserved,
    /* [in] */ DWORD dwFlags,
    /* [out] */ HCRYPTHASH *phHash);

extern BOOL WINAPI RmCPExportKey (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTKEY hKey,
    /* [in] */ HCRYPTKEY hExpKey,
    /* [in] */ DWORD dwBlobType,
    /* [in] */ DWORD dwFlags,
    /* [full][size_is][out][in] */ BYTE *pbData,
    /* [out][in] */ DWORD *pdwDataLen);

extern BOOL WINAPI RmCPGenRandom (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ DWORD dwLen,
    /* [size_is][out][in] */ BYTE *pbBuffer);

extern BOOL WINAPI RmCPGetHashParam (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTHASH hHash,
    /* [in] */ DWORD dwParam,
    /* [full][size_is][out][in] */ BYTE *pbData,
    /* [out][in] */ DWORD *pdwDataLen,
    /* [in] */ DWORD dwFlags);

extern BOOL WINAPI RmCPGetKeyParam (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTKEY hKey,
    /* [in] */ DWORD dwParam,
    /* [full][size_is][out][in] */ BYTE *pbData,
    /* [out][in] */ DWORD *pdwDataLen,
    /* [in] */ DWORD dwFlags);

extern BOOL WINAPI RmCPGetUserKey (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ DWORD dwKeySpec,
    /* [out] */ HCRYPTKEY *phUserKey);

extern BOOL WINAPI RmCPHashData (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTHASH hHash,
    /* [full][size_is][in] */ CONST BYTE *pbData,
    /* [in] */ DWORD dwDataLen,
    /* [in] */ DWORD dwFlags);

extern BOOL WINAPI RmCPHashSessionKey (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTHASH hHash,
    /* [in] */ HCRYPTKEY hKey,
    /* [in] */ DWORD dwFlags);

extern BOOL WINAPI RmCPImportKey (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [full][size_is][in] */ CONST BYTE *pbData,
    /* [in] */ DWORD dwDataLen,
    /* [in] */ HCRYPTKEY hImpKey,
    /* [in] */ DWORD dwFlags,
    /* [out] */ HCRYPTKEY *phKey);

extern BOOL WINAPI RmCPSetHashParam (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTHASH hHash,
    /* [in] */ DWORD dwParam,
    /* [size_is][in] */ BYTE *pbData,
    /* [in] */ DWORD dwFlags);

extern BOOL WINAPI RmCPSetKeyParam (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTKEY hKey,
    /* [in] */ DWORD dwParam,
    /* [size_is][in] */ BYTE *pbData,
    /* [in] */ DWORD dwFlags);

extern BOOL WINAPI RmCPSignHash (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTHASH hHash,
    /* [in] */ DWORD dwKeySpec,
    /* [string][full][in] */ LPCWSTR sDescription,
    /* [in] */ DWORD dwFlags,
    /* [size_is][out][in] */ BYTE *pbSignature,
    /* [out][in] */ DWORD *pdwSigLen);

extern BOOL WINAPI RmCPVerifySignature (
    /* [in] */ HRMCRYPTPROV hProv,
    /* [in] */ HCRYPTHASH hHash,
    /* [size_is][in] */ CONST BYTE *pbSignature,
    /* [in] */ DWORD dwSigLen,
    /* [in] */ HCRYPTKEY hPubKey,
    /* [string][full][in] */ LPCWSTR sDescription,
    /* [in] */ DWORD dwFlags);

extern HRESULT WINAPI RmCPSelectContainer ( 
    /* in */ HWND parent,
    /* in */ CRYPTOAPI_SELECT_WND_CONFIG * info,
    /* out */ CRYPTOAPI_SELECT_WND_OUT * out );

extern HRESULT WINAPI RmCPQueryPin (
    /* [in] */ HWND parent, 
    /* [in] */ CRYPTOAPI_PIN_WND_CONFIG *info, 
    /* [in] */ CRYPTOAPI_SELECT_WND_CONFIG * select_info,
    /* [out] */ CRYPTOAPI_PIN_WND_OUT * out);

extern HRESULT WINAPI RmCPDisplayMessage (
    /* [in] */ HWND parent, 
    /* [in] */ CRYPTOAPI_MESSAGE_WND_CONFIG *info, 
    /* [out] */ CRYPTOAPI_MESSAGE_WND_OUT * out);

extern BOOL WINAPI DllStopServer (
    /* in */ const RMCSP_VTABLE_CONFIG *pCfg);
#ifdef __cplusplus
}
#endif

#endif /* _WINRMCSP_H_INCLUDED */
