/*
 * Copyright(C) 2003  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile: CA_CMP_Certificate.h,v $
 * \version $Revision: 1.15 $
 * \date $Date: 2005/01/24 12:36:43 $
 * \author $Author: cav $
 *
 * \brief CertificateInfo class
 */

#ifndef CA_CMP_CERIFICATE_H
#define CA_CMP_CERIFICATE_H

#include "CA_CMP_Types.h"
#include "CA_CMP_Msg.h"

/**************************************************************/
/*                                                            */
/*  Internal structure                                        */
/*                                                            */
/**************************************************************/

class CertificateTemplate;

class CertificateInfo : public PKIXCMP_Message
{
public:
    friend class PKIXCMP_Server;
    friend class PKIXCMP_Client;

    // Init by zero
    CertificateInfo();
    ~CertificateInfo();

    CertificateInfo( const CertificateInfo& c ) : PKIXCMP_Message()
    {
	preprocessed = NULL;
	*this = c;
    }
    CertificateInfo& operator=( const CertificateInfo& c );
    void clear();

    //  
    int RequestID;
    
    int Status;

    // !!!!!  ,     ?????  
    int CertificateType;

    //   ,   Subject (  ASN1T_Name.ASN1T_RDNSequence)
    // ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_Name subject
    CACMPT_PARSED_RDN subjectRDN;

    //   ,   Issuer (  ASN1T_Name.ASN1T_RDNSequence)
    // ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_Name issuer
    CACMPT_PARSED_RDN issuerRDN;
    
    //  -	ASN1T_Certificate
    CACMPT_BLOB RawCertificate;
    
    //  - 	ASN1T_Certificate.ASN1TDynBitStr signature;
    CACMPT_BLOB CertificateSignature;
    
    //  -		ASN1T_Certificate.ASN1T_AlgorithmIdentifier signatureAlgorithm;
    char CertificateSignatureAlgorithm[ 254 ];
    
    //  - 	ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_CertificateSerialNumber serialNumber
    CACMPT_SERIAL SerialNumber;
    
    // Date -		ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_Validity.ASN1T_Time notBefore
    CACMPT_Date NotBefore;
    	
    // Date -		ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_Validity.ASN1T_Time notAfter
    CACMPT_Date NotAfter;

    // Date -		ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_Validity.ASN1T_Time SuspendedBefore
    CACMPT_Date SuspendedBefore;

    // Date -		ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_Validity.ASN1T_Time ArchiveDate
    CACMPT_Date ArchiveDate;
    
    // ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_SubjectPublicKeyInfo
    CACMPT_PublicKeyInfo	SubjectPublicKey;
    
    // ID -			ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_UniqueIdentifier issuerUniqueID
    int IssuerUniqueID;
    
    // ID -			ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_UniqueIdentifier issuerUniqueID
    int SubjectUniqueID;
    
    // ASN1T_Certificate.ASN1T_TBSCertificate.ASN1T_Extensions extensions
    CACMPT_Extensions Extensions;
    
    //   
    CACMPT_BLOB SubjectKeyIdentifier;

    //   
    CACMPT_BLOB AuthorityKeyIdentifier;

    // 
    char DeviceSerialNumber[ 256 ];
    
    // 
    char RawSMIMECapabilities[ 8192 ];

    bool subject_changed;
    bool validity_changed;
protected:
    //  
    CertificateTemplate *preprocessed;
};

#endif // CA_CMP_CERIFICATE_H
