/*
 * Copyright(C) 2003  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile: PKIXCMP_Client.h,v $
 * \version $Revision: 1.46.2.2 $
 * \date $Date: 2007/05/10 10:53:42 $
 * \author $Author: alexl $
 *
 * \brief PKIXCMP_Client class
 */

#ifndef PKIXCMP_CLIENT_H
#define PKIXCMP_CLIENT_H

#include "PKIXCMP_Base.h"

class PKIXCMP_Client : public PKIXCMP_Base {
public:
    PKIXCMP_Client( const char * szProvider=NULL, DWORD dwProvType = PROV_GOST_2001_DH );
    //      .
    PKIXCMP_Client( WndProv &wnd_prov, const char *ini_path, 
	const char * szProvider=0, DWORD dwProvType = PROV_GOST_2001_DH );

    PKIXCMP_Client( WndProv &wnd_prov, const CACMPT_BLOB &cert,
	const char * szProvider=0, DWORD dwProvType = PROV_GOST_2001_DH );
    // old
    PKIXCMP_Client( const char *ini_path, const char *pin = 0,
	const char * szProvider=0, DWORD dwProvType = PROV_GOST_2001_DH );

    ~PKIXCMP_Client();
    //     RequestInfo ( ,  
    // SubjectPublicKey) 
    //         
    //     ,      
    //  .
    // szContainer [in/out] :   .
    //        , , , 
    //     "\\\\.\\HDIMAGE\\"; 
    static PKIXCMP_Client *GenerateKeyPair( WndProv &wnd_prov,
	const char *ini_path, const char *provider, int dwProvType, 
	const char *szContainer, unsigned long keySpec = 2 );

    // old
    static PKIXCMP_Client *GenerateKeyPair( const char *ini_path, const char * szProvider,
	int dwProvType, const char *szContainer, unsigned long keySpec = 2, 
	const char *pin = NULL);

    static PKIXCMP_Client *OpenRequest ( WndProv &wnd_prov,
	const CACMPT_BLOB &cert );

    // old
    static PKIXCMP_Client *OpenRequest ( const CACMPT_BLOB &cert,
	const char *pin = NULL );

    bool ChangePin( WndProv &wnd_prov );

    void PKIXCMP_Sign (CACMPT_BLOB &in_msg,
	CACMPT_BLOB &out_msg, const PKIXCMP_Message *msg );

    int CertReqMessage_EncodeAndSign(RequestInfo *info, 
	CACMPT_BLOB &cr_msg,bool ToSign=true);

    //  ,    / ,
    //   PKIStatus.
    //   "waiting",    
    //  "granted".
    int CertReqMessage_Process( void *cr_msg, int cr_size, void
	*cp_msg, int *cp_size);
    
    //      
    //     
    int CertRepMessage_Verify ( const CACMPT_BLOB &cr_msg, 
	const CACMPT_BLOB &cp_msg, unsigned *chain_status = 0 );

    //     store   .
    void CertRepMessage_Install( const CACMPT_BLOB &cert, const char * ini_path = "", bool fToStore = true );

    //    crl
    int Crl_Verify( const CACMPT_BLOB &crl_msg, 
	const CACMPT_BLOB &pbCert );
    
    //     .
    int RevAnnContent_DecodeAndVerify( const CACMPT_BLOB &ra_msg,
	RevAnnContentInfo *info, unsigned *chain_status = 0 );

    //     :
    // -   
    // -     RequestInfo
    // \param RequestInfo [out]  
    // \param new_ini_path [in]  
    // \param szContainer [in]     
    // \param keySpec [in]
    // \param pin [in]  pin
    int UpdateKey( WndProv &wnd_prov, RequestInfo *info, const char *new_ini_path, 
	const char *provider, int dwProvType, const char *szContainer, 
	unsigned long keySpec = 2 );

    int UpdateKey( RequestInfo *info, const char *new_ini_path, 
	const char * szProvider,int dwProvType, const char *szContainer, unsigned long keySpec = 2, 
	const char *pin = NULL );

    unsigned long GetCSP() const { return hProv; }
    unsigned long GetKeySpec() const { return dwKeySpec; }

    void SetTransactionID( const CACMPT_BLOB* ptid ) 
    { 
	if ( ptid )
	    m_transactionID = *ptid; 
	else m_transactionID.clear();
    }
    const CACMPT_BLOB& GetTransactionID() const { return m_transactionID; }

    void SetMsgNonce( const CACMPT_BLOB* pnonce ) 
    { 
	if ( pnonce )
	    m_msgNonce = *pnonce; 
	else m_msgNonce.clear();
    }
    const CACMPT_BLOB& GetMsgNonce() const { return m_msgNonce; }

    int ErrorMsgInfo_Verify( const CACMPT_BLOB &em_msg,
	unsigned *chain_status = 0 );

    CACMPT_BLOB GetCertificateFromContainer() 
    { return PKIXCMP_Base::GetCertificateFromContainer( hProv, dwKeySpec ); }

    int CertAnnContent_DecodeAndVerify( const CACMPT_BLOB &ann_msg,
	CACMPT_BLOB &cert );

    //       Root
    void BuildChain( encoded_certificate_list &list,  unsigned int *status = NULL );

    //  ErrorMsgInfo
    //   em_info   Sender,     
    int ErrorMsgInfo_EncodeAndSign( const ErrorMsgInfo *em_info,
	CACMPT_BLOB &em_msg, CACMPT_BLOB &cert, bool ToSign=true )
    { UNUSED(cert); 
      return 
    PKIXCMP_Base::ErrorMsgInfo_EncodeAndSign( em_info, em_msg, 
	hProv, dwKeySpec, MYCert, ToSign );
    }
public:
    // @devnote This fields are used by PkiClient
    static const CertificateStore *ADD_STORE;
    static const int ADD_STORE_LEN;

    virtual const CertificateStore *Get_ADD_STORE () const { return ADD_STORE; }
    virtual int Get_ADD_STORE_LEN () const { return ADD_STORE_LEN; }

protected:
    std::string IniPath;

    CACMPT_BLOB m_msgNonce;
    CACMPT_BLOB m_transactionID;
    CACMPT_BLOB m_kid;

    PKIXCMP_Client (WndProv &wnd_prov, const CACMPT_BLOB& cert, bool isRequest,
	 const char * szProvider=0,DWORD dwProvType = PROV_GOST_2001_DH);
    void BuildRequestByCertificate( const CACMPT_BLOB cert, 
	RequestInfo *req_info );
    void init (WndProv &wnd_prov, const CACMPT_BLOB& cert, bool isRequest);
    void init( const char * szProvider, DWORD dwProvType );
    void UpdateKeyInfo( RequestInfo *info, const CACMPT_BLOB &old );
    PKIXCMP_Client *new_client;
};
#endif // PKIXCMP_CLIENT_H
