/*
 * Copyright(C) 2008  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 110687 $
 * \date $Date: 2014-08-28 09:51:11 +0400 (Чтв, 28 Авг 2014) $
 * \author $Author: borodin $
 * \brief    
 */

#if !defined(_RDR_FKC_H)
#define _RDR_FKC_H

#include "reader/rdr.h"
#include "reader/support_fkc.h"

/*   FKC. */
#define RDR_FLAG_BLOCK_FKC 0x3100
#define RDR_FLAG_FKC_NULL_FOLDER	0
#define RDR_FLAG_FKC_DISABLE_PASSWORD	1
#define RDR_FLAG_FKC_ENABLE_INIT_KEYS	2
#define RDR_FLAG_FKC_ENABLE_SET_KEYS	3
#define RDR_FLAG_FKC_VERSION_1		4
/* UEC   "  "  */
#define RDR_FLAG_UEC			4
#define RDR_FLAG_FKC_VERSION_2		5
/* ,   ,      
 *  ,      EKE    */
#define RDR_FLAG_NOT_SPLIT		5
#define RDR_FLAG_FKC_VERSION_3		6
#define RDR_FLAG_FKC_PIN_TO_DELETE	6
#define RDR_FLAG_FKC_VERSION_4		7

/* 
 *    RDR 
 */
#define RDR_FOLDER_NAME_MAX_SIZE		(256)
#define RDR_FRIENDLY_NAME_MAX_SIZE		(224)
#define RDR_OID_MAX_SIZE			(192)
#define RDR_PIN_MAX_SIZE			(128)
#define RDR_EKE_SV_SIZE				(4)
#define RDR_OPERATION_IV_SIZE			(8)


/*   */
#define RDR_ERR_FKC_TRANSACTION		0x3100
#define RDR_ERR_FKC_NEED_ROOT_AUTH	0x3101
#define RDR_ERR_FKC_NEED_CONT_AUTH	0x3102
#define RDR_ERR_FKC_OPLIMIT_REACHED	0x3103
#define RDR_ERR_FKC_MIM_WARNING		0x3104

struct TRdrHashContext_;

/*!
 * \ingroup rdr_ext_hash_struct
 * \brief  ,  .
 * \req_rdr
 */
typedef struct TRdrHashContext_ TRdrHashContext;

#if defined( DUMMY_STRUCT )
struct TRdrHashContext_
{
    TDummy dummy;
}
#endif


/*!
 * \ingroup rdr_ext_chl
 * \defgroup rdr_ext_chl_struct   Challenge/Responce
 */
/*!
 * \ingroup rdr_ext_chl
 * \defgroup rdr_ext_chl_const   Challenge/Responce
 */

/*! \ingroup rdr_ext_chl_struct
 * \brief  
 * \req_rdr
 */
typedef enum TRdrLoginInfoType_class_ 
{
    TRLITc_passwd = 0<<16,	    //!<    /PIN
    TRLITc_eke = 1<<16,		    //!<  EKE
    TRLITc_oscar_external = 2<<16,  //!<  EXTERNAL__AUTHENTICATE /
    TRLITc_oscar_mutual = 3<<16,    //!<  MUTUAL__AUTHENTICATE /
    TRLITc_unknown = 0x7fff<<16
} TRdrLoginInfoType_class; 

/*! \ingroup rdr_ext_chl_struct
 * \brief  
 * \req_rdr
 */
typedef enum TRdrLoginInfoType_type_ 
{
    TRLITt_no = 0,	    //!<   
    TRLITt_container = 1,   //!<   
    TRLITt_master = 2,	    //!<      
    TRLITt_prime = 3, 	    //!<    
    TRLITt_public = 4, 	    //!<  
    TRLITt_admin = 5,	    //!<   / 
    TRLITt_unknown = 0xffff
} TRdrLoginInfoType_type; 

/*!
 * \ingroup rdr_ext_chl_struct
 * \brief   
 * \req_rdr
 */
static SUP_INLINE TRdrLoginInfoType_class TRLIT_class(TRdrLoginInfoType lt)
{
    switch (lt&TRLITc_unknown) {
	case TRLITc_passwd:	    return TRLITc_passwd;
	case TRLITc_eke:	    return TRLITc_eke;
	case TRLITc_oscar_external: return TRLITc_oscar_external;
	case TRLITc_oscar_mutual:   return TRLITc_oscar_mutual;
	default:		    return TRLITc_unknown;
    }
}

/*!
 * \ingroup rdr_ext_chl_struct
 * \brief   
 * \req_rdr
 */
static SUP_INLINE TRdrLoginInfoType_type TRLIT_type(TRdrLoginInfoType lt)
{
    switch (lt&TRLITt_unknown) {
	case TRLITt_no:		return TRLITt_no;
	case TRLITt_container:	return TRLITt_container;
	case TRLITt_master:	return TRLITt_master;
	case TRLITt_prime:	return TRLITt_prime;
	case TRLITt_public:	return TRLITt_public;
	case TRLITt_admin:	return TRLITt_admin;
	default:		return TRLITt_unknown;
    }
}


/*! \ingroup rdr_ext_chl_const
 * \brief  EKE  
 */
#define RDR_LOGIN_INFO_EKE		((TRdrLoginInfoType)(		\
					    TRLITt_container |		\
					    TRLITc_eke))
#define RDR_LOGIN_INFO_OSCAR_EXTERNAL	((TRdrLoginInfoType)(		\
					    TRLITt_container |		\
					    TRLIT_oscar_external))
#define RDR_LOGIN_INFO_OSCAR_MUTUAL	((TRdrLoginInfoType)(		\
					    TRLITt_container |		\
					    TRLIT_oscar_mutual))
#define RDR_LOGIN_INFO_ALL_UNKNOWN	((TRdrLoginInfoType)(		\
					    TRLITt_unknown |		\
					    TRLIT_unknown))
#if defined RDR_LOGIN_INFO_NO
#undef RDR_LOGIN_INFO_NO
#endif /*RDR_LOGIN_INFO_NO*/
#define RDR_LOGIN_INFO_NO		((TRdrLoginInfoType)(		\
					    TRLITt_no |			\
					    TRLITc_passwd))
#if defined RDR_LOGIN_INFO_UNKNOWN
#undef RDR_LOGIN_INFO_UNKNOWN
#endif /*RDR_LOGIN_INFO_UNKNOWN*/
#define RDR_LOGIN_INFO_UNKNOWN		((TRdrLoginInfoType)(		\
					    TRLITt_unknown |		\
					    TRLITc_passwd))
/*! \ingroup rdr_ext_chl_const
 * \brief  PIN/  
 */
#if defined RDR_LOGIN_INFO_PASSWD
#undef RDR_LOGIN_INFO_PASSWD
#endif /*RDR_LOGIN_INFO_PASSWD*/
#define RDR_LOGIN_INFO_PASSWD		((TRdrLoginInfoType)(		\
					    TRLITt_container |		\
					    TRLITc_passwd))
#if defined RDR_LOGIN_INFO_PASSWD_MASTER
#undef RDR_LOGIN_INFO_PASSWD_MASTER
#endif /*RDR_LOGIN_INFO_PASSWD_MASTER*/
#define RDR_LOGIN_INFO_PASSWD_MASTER	((TRdrLoginInfoType)(		\
					    TRLITt_master |		\
					    TRLITc_passwd))
#if defined RDR_LOGIN_INFO_PRIME_PASSWD
#undef RDR_LOGIN_INFO_PRIME_PASSWD
#endif /*RDR_LOGIN_INFO_PRIME_PASSWD*/
#define RDR_LOGIN_INFO_PRIME_PASSWD	((TRdrLoginInfoType)(		\
					    TRLITt_prime |		\
					    TRLITc_passwd))
#if defined RDR_LOGIN_INFO_PUBLIC
#undef RDR_LOGIN_INFO_PUBLIC
#endif /*RDR_LOGIN_INFO_PUBLIC*/
#define RDR_LOGIN_INFO_PUBLIC		((TRdrLoginInfoType)(		\
					    TRLITt_public |		\
					    TRLITc_passwd))
/*! \ingroup rdr_ext_chl_const
 * \brief      EKE
 */
#define RDR_LOGIN_TRANSPORT_EKE		((TRdrLoginInfoType)(		\
					    TRLITt_no |			\
					    TRLIT_eke))

/*! \ingroup rdr_ext_chl_struct
 * \brief      ()
 * \req_rdr
 */
typedef struct TRdrInfoAuthTypePwd_ 
{
    size_t size_of;		//!<   
    TRdrLoginInfoType type;	//!<    
    TCHAR tFriendlyName[RDR_FRIENDLY_NAME_MAX_SIZE];
				//!< ""  ,      PIN
    unsigned int uiRetries;	//!<   ,      PIN
    size_t sMaxPwdLength;	//!<   PIN
    size_t sMinPwdLength; 	//!<   PIN
} TRdrInfoAuthTypePwd;

/*! \ingroup rdr_ext_chl_struct
 * \brief       ()
 * \req_rdr
 */
typedef struct TRdrInfoAuthTypeHeader_ 
{
    size_t size_of;		//!<   
    TRdrLoginInfoType type;	//!<    
    TCHAR tFriendlyName[RDR_FRIENDLY_NAME_MAX_SIZE];
				//!< ""  ,      PIN
} TRdrInfoAuthTypeHeader;

#define sMaxTRdrInfoAuthTypeSize (sizeof(TRdrInfoAuthTypeHeader)+512);

struct TRdrInfoAuthType_;
/*! \ingroup rdr_ext_chl_struct
 * \brief        ()
 * \req_rdr
 */
typedef struct TRdrInfoAuthType_ TRdrInfoAuthType;

MAKE_CONVERSION_FUNCTIONS(TRdrInfoAuthTypePwd, TRdrInfoAuthType, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrInfoAuthTypeHeader, TRdrInfoAuthType, MCF_CHECK_size_of)


/* 
 *     
 */
#define RDR_FKC_FOLDER_NAME_CHECK_SIZE		(3*32)		// 96
#define RDR_FKC_FRIENDLY_NAME_CHECK_SIZE	(19+2*32)	// 83
#define RDR_FKC_POINT_SIZE			(512/8)		// 64
#define RDR_FKC_COORD_SIZE			(256/8)		// 32
#define RDR_FKC_ORDER_SIZE			(256/8)		// 32
#define RDR_FKC_SYNCRO_SIZE			(192/8)		// 24
#define RDR_FKC_UKM_SIZE			(64/8)		// 8


/*!
 * \ingroup rdr_ext_folder_fkc
 * \defgroup rdr_ext_folder_fkc_struct   
 */


/*! \ingroup rdr_ext_fld_fkc_struct
 * \brief     () 
 * \sa \ref rdr_ext_fld_fkc_struct, #rdr_folder_open_ex, #READER_FUN_FOLDER_OPEN_EX, #TRdrInfoFolderOpenEx_paramUntyped, #TrdrInfoFolderOpenEx_fkc_param, #TRdrFkcGOSTR3410param_
 * \req_rdr
 */
typedef struct TRdrInfoFolderOpenEx_paramUntyped_	    // TODO:   ...Header ???? 
{
    size_t size_of;		//!<   
} TRdrInfoFolderOpenEx_paramUntyped;

struct TRdrInfoFolderOpenEx_param_;

/*! \ingroup rdr_ext_fld_fkc_struct
 * \brief      () 
 * \req_rdr
 */
typedef struct TRdrInfoFolderOpenEx_param_ TRdrInfoFolderOpenEx_param;

MAKE_CONVERSION_FUNCTIONS(TRdrInfoFolderOpenEx_paramUntyped, TRdrInfoFolderOpenEx_param, MCF_CHECK_size_of)

/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief      .
 * \req_rdr
 */
typedef int TRdrFolderEnumParam;

/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief      .      
 *      (. #TRdrFolderParamValue ),    
 *   .
 * \req_rdr
 */
typedef struct TRdrFolderParamValueHeader_ 
{
    size_t			size_of; //!<   
    TRdrFolderEnumParam		paramID; //!<   
} TRdrFolderParamValueHeader;

#define sMaxTRdrFolderParamValueSize (sizeof(TRdrFolderParamValueHeader) + 512);

struct TRdrFolderParamValue_;


/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief  ,    ().       #P2CH 
 *        : #TRdrFolderParamValueHeader, #TRdrFkcFolderParamTitle, #TRdrFkcFolderPasswordParam,
 * #TRdrFkcFolderDisablePasswordParam, #TRdrFkcFolderNewKeysParam, #TRdrFkcFolderCountersParam, #TRdrFkcFolderOID0Param.
 * \sa \ref rdr_ext_folder_fkc_struct, #rdr_folder_get_param, #rdr_folder_set_param, #rdr_auth_type, #TRdrFolderEnumParam
 * \req_rdr
 */
typedef struct TRdrFolderParamValue_ TRdrFolderParamValue;

MAKE_CONVERSION_FUNCTIONS(TRdrFolderParamValueHeader, TRdrFolderParamValue, MCF_NO_CHECK_size_of)

//TODO: remove MAKE_CONVERSION_FUNCTIONS(TRdrInfoPasswdType,TReaderInfoAuthTypeUntyped, MCF_NO_CHECK_size_of)

/*! \ingroup rdr_ext_chl_struct
 * \brief     (  )  
 * \req_rdr
 */
typedef int TRdrChallenge_class;

/*! \ingroup rdr_ext_chl_struct
 * \brief     (  )  
 * \req_rdr
 */
typedef int TRdrChallenge_id;

struct TRdrChallenge2folder_;

/*! \ingroup rdr_ext_chl_struct
 * \brief     CSP     EKE.
 *        : #TRdrFkcEKEChallengeFirst2fkc, #TRdrFkcEKEChallengeReadSyncro2fkc, 
 * #TRdrFkcEKEChallengeWriteSyncro2fkc, #TRdrFkcEKEChallengeWriteDelta2fkc, #TRdrFkcEKEChallengeWriteQPW2fkc, 
 * #TRdrFkcEKEChallengeChangeMask2fkc.
 * \req_rdr
 */
typedef struct TRdrChallenge2folder_ TRdrChallenge2folder;

struct TRdrChallenge2rdr_;

/*! \ingroup rdr_ext_chl_struct
 * \brief       CSP   EKE.
 *        : #TRdrFkcEKEChallengeFirst2csp, #TRdrFkcEKEChallengeReadSyncro2csp, 
 * #TRdrFkcEKEChallengeWriteSyncro2csp, #TRdrFkcEKEChallengeReadQFKC2csp.
 * \req_rdr
 */
typedef struct TRdrChallenge2rdr_ TRdrChallenge2rdr;

/*!
 * \ingroup rdr_ext_fkc
 * \defgroup rdr_ext_fkc_stuct    
 *
 *    big-endian (""),   -  0x80  ,     0x1  .
 *
 * \{
 */
//!   
typedef struct TRdrFkcPoint_
{
    BYTE x[RDR_FKC_COORD_SIZE];	//!<  (mod p) x  big-endian
    BYTE y[RDR_FKC_COORD_SIZE]; //!<  (mod p) y  big-endian
} TRdrFkcPoint;

//!    
typedef struct TRdrFkcOrder_
{
    BYTE v[RDR_FKC_ORDER_SIZE];	//!<   (mod q)  big-endian
} TRdrFkcOrder;

//! UKM   
typedef struct TRdrFkcUKM_
{
    BYTE ukm[RDR_FKC_UKM_SIZE];	//!< 
} TRdrFkcUKM;



//!    CSP
typedef struct TRdrFkcSyncro_
{
	BYTE v[RDR_FKC_SYNCRO_SIZE];	//!<  ,  192  (( (s&~((1<<64)-1)) )>>64)  big-endian
} TRdrFkcSyncro;

//!  (mod 2^16)  big-endian
typedef unsigned short TRdrFkcSigma;	// TODO: uint16_t  WORD

MAKE_CONVERSION_FUNCTIONS(TRdrFkcPoint, PBYTE, MCF_NO_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcOrder, PBYTE, MCF_NO_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcSyncro, PBYTE, MCF_NO_CHECK_size_of)

//!       34.10-2001
typedef enum TRdrFkcGOSTR3410param_
{
    RDR_FKC_IDG_CP_A_PARAMSET = 2,		//!<  ID
    RDR_FKC_IDG_CP_B_PARAMSET = 1,		//!<  ID
    RDR_FKC_IDG_CP_C_PARAMSET = 3,		//!<  ID
    RDR_FKC_IDG_CP_OPTIONAL_PARAMSET = 0,	//!<  ID
						    //!< OID   
						    //!< 
    RDR_FKC_IDG_CP_TEST_PARAMSET = 4		//!<  ID  
						//!< " "
} TRdrFkcGOSTR3410param;

//    RDR_FKC_IDG_CP_A_PARAMSET
#	define RDR_FKC_IDG_CP_A_OID_SIGN	    ("1.2.643.2.2.35.1")
#	define RDR_FKC_IDG_CP_A_OID_EXCH	    ("1.2.643.2.2.36.0")
//    RDR_FKC_IDG_CP_B_PARAMSET
#	define RDR_FKC_IDG_CP_B_OID_SIGN	    ("1.2.643.2.2.35.2")
//    RDR_FKC_IDG_CP_C_PARAMSET
#	define RDR_FKC_IDG_CP_C_OID_SIGN	    ("1.2.643.2.2.35.3")
#	define RDR_FKC_IDG_CP_C_OID_EXCH	    ("1.2.643.2.2.36.1")
//    RDR_FKC_IDG_CP_OPTIONAL_PARAMSET
//    RDR_FKC_IDG_CP_TEST_PARAMSET
#	define RDR_FKC_IDG_CP_TEST_OID_SIGN	    ("1.2.643.2.2.35.0")
#	define RDR_FKC_IDG_CP_TEST_OID_EXCH	    ("1.2.643.2.2.35.0")



/*! \} */

/*! \ingroup rdr_ext_fld_fkc_struct
 * \brief    ()  
 * \sa \ref rdr_ext_fld_fkc_struct, #rdr_folder_open_ex, #READER_FUN_FOLDER_OPEN_EX, #TRdrInfoFolderOpenEx_param, #TRdrFkcGOSTR3410param_
 * \req_rdr
 */
typedef struct TRdrInfoFolderOpenEx_fkc_param_
{
    size_t size_of;			//!<   
    BOOL bEnableDH;			//!<   -
    TRdrFkcGOSTR3410param uiIDg;	//!< ID   
} TrdrInfoFolderOpenEx_fkc_param;

MAKE_CONVERSION_FUNCTIONS(TrdrInfoFolderOpenEx_fkc_param, TRdrInfoFolderOpenEx_param, MCF_CHECK_size_of)

/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief     ()      .
 * \sa \ref rdr_ext_folder_fkc_struct, #rdr_folder_get_param, #rdr_folder_set_param, #TRdrFolderEnumParam, #TRdrFkcFolderPasswordParam, #TRdrFkcFolderDisablePasswordParam, #TRdrFkcFolderNewKeysParam, #TRdrFkcFolderCountersParam, #TRdrFkcFolderOID0Param, #TRdrFkcFolderParamTitle
 * \req_rdr
 */
typedef enum TRdrFkcFolderEnumParam_
{
    TCEP_password, 			//!<   NULL-
    TCEP_disablePassword,		//!<     NULL-
    TCEP_newKeys,			//!<    
    TCEP_counters,			//!<   EKE
    TCEP_oid0,				//!<  OID    
    TCEP_MAX_V1, 
    TCEP_admin_auth = TCEP_MAX_V1,	//!<       1,    .
    TCEP_MAX_V2,
    TCEP_DefaultPassword = TCEP_MAX_V2,
    TCEP_disableDefaultPassword,	//!<      . TRUE -  , FALSE - .
    TCEP_egost_params,	//!<   eGOST
    TCEP_counters_PIN,	//!<     
    TCEP_MAX_V3
} TRdrFkcFolderEnumParam;


/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief ,    \ref TRdrFolderParamValue ,    NULL-    
 * \sa \ref rdr_ext_folder_fkc_struct, #rdr_folder_get_param, #rdr_folder_set_param, #TRdrFolderParamValue, #TRdrFolderEnumParam
 * \req_rdr
 */
typedef struct TRdrFkcFolderPasswordParam_
{
    size_t			size_of; 			//!<  
    TRdrFkcFolderEnumParam	paramID;  			//!< ,  TCEP_password  TCEP_DefaultPassword.
    TCHAR			tPassword[RDR_PIN_MAX_SIZE];	//!<      
} TRdrFkcFolderPasswordParam;

/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief ,    \ref TRdrFolderParamValue ,     NULL-.
 * \sa \ref rdr_ext_folder_fkc_struct, #rdr_folder_get_param, #rdr_folder_set_param, #TRdrFolderParamValue, #TRdrFolderEnumParam
 * \req_rdr
 */
typedef struct TRdrFkcFolderDisablePasswordParam_
{
    size_t			size_of;                //!<                         
    TRdrFkcFolderEnumParam	paramID;                //!< ,  TCEP_disablePassword  TCEP_disableDefaultPassword
    BOOL			bDisablePassword;       //!<   
} TRdrFkcFolderDisablePasswordParam;

typedef struct TRdrFkcFolderUECCertParam_
{
    size_t			size_of;                //!<                         
    BOOL			isCertExists;		//!<    
} TRdrFkcFolderUECCertParam;

typedef struct TRdrFkcFolderEGOSTParam_
{
    size_t		size_of;                //!<                         
    BOOL		isRosTelecom;		//!<  
    TRdrFkcPoint	publicKey;		//!<   
    BOOL		enableDH;		//!<   
    unsigned int	uiIDg;			//!< ID   
} TRdrFkcFolderEGOSTParam;


/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief ,    \ref TRdrFolderParamValue ,       .
 * \sa \ref rdr_ext_folder_fkc_struct, #rdr_folder_get_param, #rdr_folder_set_param, #TRdrFolderParamValue, #TRdrFolderEnumParam
 * \req_rdr
 */
typedef struct TRdrFkcFolderNewKeysParam_		
{
    size_t			size_of;                //!<                                 
    TRdrFkcFolderEnumParam	paramID;                //!< ,  TCEP_newKeys
    BOOL			bEnableInitKeys;        //!<      
    BOOL			bEnableSetKeys;         //!<      
} TRdrFkcFolderNewKeysParam;

/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief    EKE
 * \sa \ref rdr_ext_folder_fkc_struct, #rdr_folder_get_param, #rdr_folder_set_param, #rdr_get_auth_type
 * \req_rdr
 */
typedef enum TRdrFkcInfoCounter_
{
    TRIFc_EKE,			//!<   EKE (c1)
    TRIFc_Sign, 		//!<    (c2)
    TRIFc_DH, 			//!<   - (c3)
    TRIFc_fail, 		//!<    (c4)
    TRIFc_cfail, 		//!<     (c5)
    TRIFc_MAX_V1                //!<    
} TRdrFkcInfoCounter;

/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief ,   EKE
 * \sa \ref rdr_ext_folder_fkc_struct, #rdr_folder_get_param, #rdr_folder_set_param, #rdr_auth_type, #TRdrFkcInfoCounter
 * \req_rdr
 */
typedef DWORD TRdrFkcInfoCounters[TRIFc_MAX_V1];


/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief ,    \ref TRdrFolderParamValue ,    EKE   ().
 * \sa \ref rdr_ext_folder_fkc_struct, #rdr_folder_get_param, #rdr_folder_set_param, #TRdrFolderParamValue, #TRdrFolderEnumParam
 * \req_rdr
 */
typedef struct TRdrFkcFolderCountersParam_
{
    size_t			size_of;   //!<                                
    TRdrFkcFolderEnumParam	paramID;   //!< ,  TCEP_counters
    TRdrFkcInfoCounters	 initCounters;     //!<  
} TRdrFkcFolderCountersParam;

/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief ,    \ref TRdrFolderParamValue ,    EKE   ().
 * \sa \ref rdr_ext_folder_fkc_struct, #rdr_folder_get_param, #rdr_folder_set_param, #TRdrFolderParamValue, #TRdrFolderEnumParam
 * \req_rdr
 */
typedef struct TRdrEGostFolderCountersParam_
{
    size_t			size_of;   //!<                                
    TRdrFkcFolderEnumParam	paramID;   //!< ,  TCEP_counters
    TRdrFkcInfoCounters		initCounters;     //!<  
    BOOL			isPinInit;	  //!<    
} TRdrEGostFolderCountersParam;

/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief ,    \ref TRdrFolderParamValue ,   OID    
 * \sa \ref rdr_ext_folder_fkc_struct, #rdr_folder_get_param, #rdr_folder_set_param, #TRdrFolderParamValue, #TRdrFolderEnumParam
 * \req_rdr
 */
typedef struct TRdrFkcFolderOID0Param_ {
    size_t			size_of;                    //!<                                
    TRdrFkcFolderEnumParam	paramID;                    //!< ,  TCEP_oid0
    TCHAR	    		tOID0[RDR_OID_MAX_SIZE];    //!<                        
} TRdrFkcFolderOID0Param;

typedef struct TRdrFkcFolderAdminAuth_ {
    size_t			size_of;                    //!<                                
    TRdrFkcFolderEnumParam	paramID;                    //!< ,  TCEP_admin_auth
    BOOL			bEnablePUK;		    //!<     PUK
    BOOL			bEnableEKE;		    //!<     EKE  NULL-
} TRdrFkcFolderAdminAuth;


/*! \ingroup rdr_ext_folder_fkc_struct
 * \brief ,    \ref TRdrFolderParamValue ,       
 * \sa \ref rdr_ext_folder_fkc_struct, #rdr_folder_get_param, #rdr_folder_set_param, #TRdrFolderParamValue, #TRdrFolderEnumParam
 * \req_rdr
 */
typedef struct TRdrFkcFolderParamTitle_ {		
    size_t			size_of; 		//!<                     
    TRdrFkcFolderEnumParam	paramID;                //!<  ,   \ref TRdrFkcFolderEnumParam
} TRdrFkcFolderParamTitle;

MAKE_CONVERSION_FUNCTIONS(TRdrFkcFolderParamTitle, TRdrFolderParamValue, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcFolderPasswordParam, TRdrFolderParamValue, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcFolderDisablePasswordParam, TRdrFolderParamValue, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcFolderNewKeysParam, TRdrFolderParamValue, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcFolderEGOSTParam, TRdrFolderParamValue, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcFolderCountersParam, TRdrFolderParamValue, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrEGostFolderCountersParam, TRdrFolderParamValue, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcFolderOID0Param, TRdrFolderParamValue, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcFolderAdminAuth, TRdrFolderParamValue, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcFolderUECCertParam, TRdrFolderParamValue, MCF_CHECK_size_of)

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief       ()    EKE
 * \sa #TRdrInfoAuthType, #TRdrInfoAuthTypeHeader_, #rdr_auth_type
 * \req_rdr
 */
typedef struct TRdrInfoAuthTypeEKE_
{
    size_t size_of;		    //!<   
    TRdrLoginInfoType type;	    //!<    
    TCHAR tFriendlyName[RDR_FRIENDLY_NAME_MAX_SIZE];
				    //!< ""  ,      PIN
    TRdrFkcInfoCounters c;	    //!<   ,      PIN
    BOOL bEnableDH;		    //!<   -
    unsigned int uiIDg;		    //!< ID   
    TRdrFkcPoint uQs;		    //!<   
} TRdrInfoAuthTypeEKE;

MAKE_CONVERSION_FUNCTIONS(TRdrInfoAuthTypeEKE, TRdrInfoAuthType, MCF_CHECK_size_of)

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrLoginInfoType_class_    EKE
 * \sa #TRdrInfoAuthType, #TRdrInfoAuthTypeHeader_, #rdr_auth_type
 * \req_rdr
 */
typedef enum TRdrFkcEKEChallenge_class_
{ 
    TRECc_first = 1,		//!<   EKE
    TRECc_second = 2,		//!<   EKE
    TRECc_first_dbg =0xf1,	//!<   EKE  DEBUG . 
    TRECc_commit = 0xff		//!<  
} TRdrFkcEKEChallenge_class; 


/*!
 * \ingroup rdr_ext_folder_fkc_struct
 * \defgroup rdr_ext_trans_struct      
 * \brief          ,   EKE, , -.
 */

/*!
 * \ingroup rdr_ext_trans_struct
 * \defgroup rdr_ext_trans_const   .
 * \brief         ,     ,
 *    .
 */

/*! \ingroup rdr_ext_trans_struct
 * \brief       .   
 *   EKE           
 *        \ref TRdrFkcTrNewID(  ). 
 *          \ref FKC_TRANSACTION_IS_NEW,  
 *        .    
 *    .
 * \sa #rdr_auth_challenge, #rdr_auth_change, #rdr_crypt_signature_1, #rdr_crypt_signature_2, #rdr_crypt_agreement_1
 * \req_rdr
 */
typedef DWORD TRdrFkcTrID;

/*! \ingroup rdr_ext_trans_struct
 * \brief        .    \ref FKC_TRANSACTION_IS_NEW
 *  \ref FKC_TRANSACTION_IS_SAME. 
 * \sa #rdr_auth_challenge, #rdr_auth_change, #rdr_crypt_signature_1, #rdr_crypt_agreement_1
 * \req_rdr
 */
typedef BOOL TRdrFkcTrNewID;

/*! \ingroup rdr_ext_trans_struct
 * \brief -,     . 
 *     EKE   ,      ,    
 *     ,     .
 * \sa #rdr_auth_change
 * \req_rdr
 */
typedef WORD TRdrFkcCommitMask;

/*! \ingroup rdr_ext_trans_const
 * \brief   \ref TRdrFkcTrNewID,     .
 * \sa #rdr_auth_challenge, #rdr_auth_change, #rdr_crypt_signature_1, #rdr_crypt_agreement_1, #TRdrFkcTrNewID, #TRdrFkcTrID
 * \req_rdr
 */
#define FKC_TRANSACTION_IS_NEW ((TRdrFkcTrNewID)TRUE)

/*! \ingroup rdr_ext_trans_const
 * \brief   \ref TRdrFkcTrNewID,     .
 * \sa #rdr_auth_challenge, #rdr_auth_change, #rdr_crypt_signature_1, #rdr_crypt_agreement_1, #TRdrFkcTrNewID, #TRdrFkcTrID
 * \req_rdr
 */
#define FKC_TRANSACTION_IS_SAME ((TRdrFkcTrNewID)FALSE)

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrLoginInfoType_type_    EKE
 * \sa #TRdrInfoAuthType, #TRdrInfoAuthTypeHeader_, #rdr_auth_type
 * \req_rdr
 */
typedef enum TRdrFkcEKEChallenge_id_
{
    TRECi_syncro = 1,		//!< id_syncro
    TRECi_syncroBIS = 2,	//!< id_syncro''
    TRECi_deltaBIS = 3,		//!< id_Delta''
    TRECi_Qpw = 4,		//!< id_Q''PW 
    TRECi_Qfkc = 5,		//!< id_Q''
    TRECi_Qs = 6		//!< id_Q''S
} TRdrFkcEKEChallenge_id;

/*! \ingroup rdr_ext_trans_const
 * \brief   \ref TRdrFkcCommitMask,    
 * \sa #rdr_auth_change, #TRdrFkcCommitMask
 * \req_rdr
 */
#define FKC_TRANS_SET_ZERO ((TRdrFkcCommitMask)0)

/*! \ingroup rdr_ext_trans_const
 * \brief   \ref TRdrFkcCommitMask,    Syncro''
 * \sa #rdr_auth_change, #TRdrFkcCommitMask
 * \req_rdr
 */
#define FKC_TRANS_SET_SYNCRO_BIT ((TRdrFkcCommitMask)(1<<TRECi_syncroBIS))

/*! \ingroup rdr_ext_trans_const
 * \brief   \ref TRdrFkcCommitMask,    Delta''
 * \sa #rdr_auth_change, #TRdrFkcCommitMask
 * \req_rdr
 */
#define FKC_TRANS_SET_DELTA_BIT ((TRdrFkcCommitMask)(1<<TRECi_deltaBIS))

/*! \ingroup rdr_ext_trans_const
 * \brief   \ref TRdrFkcCommitMask,    Qpw
 * \sa #rdr_auth_change, #TRdrFkcCommitMask
 * \req_rdr
 */
#define FKC_TRANS_SET_QPW_BIT ((TRdrFkcCommitMask)(1<<TRECi_Qpw))

/*! \ingroup rdr_ext_trans_const
 * \brief   \ref TRdrFkcCommitMask,    Qs
 * \sa #rdr_auth_change, #TRdrFkcCommitMask
 * \req_rdr
 */
#define FKC_TRANS_SET_QS_BIT ((TRdrFkcCommitMask)(1<<TRECi_Qs))

/*! \ingroup rdr_ext_trans_const
 * \brief   \ref TRdrFkcCommitMask,     
 * \sa #rdr_auth_change, #TRdrFkcCommitMask
 * \req_rdr
 */
#define FKC_TRANS_SET_ALL ((TRdrFkcCommitMask)0xffff)


/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrChallenge2folder    EKE 
 * \sa #TReaderInfoAuthChallenge_, #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_change
 * \req_rdr
 */
typedef struct TRdrFkcEKEChallengeFirst2fkc_ {
    size_t size_of;		    //!<   
    TRdrFkcPoint u1;		    //!<   
    TRdrFkcTrID	TrId;		    //!<  
    TRdrFkcTrNewID IsNewTr;         //!<   
} TRdrFkcEKEChallengeFirst2fkc;

#if _DEBUG
/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrChallenge2folder    EKE    DEBUG
 * \sa #TReaderInfoAuthChallenge_, #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_change
 * \req_rdr
 */
typedef struct TRdrFkcEKEChallengeFirst2fkc_debug_ {
    size_t size_of;		    //!<   
    TRdrFkcPoint u1;		    //!<   
    TRdrFkcTrID	TrId;		    //!<  
    TRdrFkcTrNewID IsNewTr;         //!<   
    TRdrFkcOrder betta;		    //!<    EKE 
} TRdrFkcEKEChallengeFirst2fkc_debug;
#endif /*_DEBUG*/

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrChallenge2rdr    EKE 
 * \sa #TReaderInfoAuthChallenge_, #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_change, 
 * 
 * \req_rdr
 */
typedef struct TRdrFkcEKEChallengeFirst2csp_ {
    size_t size_of;		    //!<   
    TRdrFkcPoint u2;		    //!<   
} TRdrFkcEKEChallengeFirst2csp;

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrChallenge2folder     syncro
 * \sa #TReaderInfoAuthChallenge_, #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_change
 * \req_rdr
 */
typedef struct TRdrFkcEKEChallengeReadSyncro2fkc_ {
    size_t size_of;		    //!<   
    TRdrFkcSigma uiS1;		    //!<    
    TRdrFkcTrID	TrId;		    //!<  
} TRdrFkcEKEChallengeReadSyncro2fkc;

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrChallenge2rdr     syncro
 * \sa #TReaderInfoAuthChallenge_, #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_change
 * \req_rdr
 */
typedef struct TRdrFkcEKEChallengeReadSyncro2csp_ {
    size_t size_of;		    //!<   
    TRdrFkcSyncro u3;		    //!<  syncro
    TRdrFkcSigma uiS2;		    //!<    
} TRdrFkcEKEChallengeReadSyncro2csp;

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrChallenge2folder     syncro"
 * \sa #TReaderInfoAuthChallenge_, #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_change
 * \req_rdr
 */
typedef struct TfkcEKEChallengeWriteSyncro2fkc_ {
    size_t size_of;		    //!<   
    TRdrFkcSyncro u3;		    //!<   syncro"
    TRdrFkcSigma uiS1;		    //!<    
    TRdrFkcTrID	TrId;		    //!<  
} TRdrFkcEKEChallengeWriteSyncro2fkc;

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrChallenge2rdr     syncro"
 * \sa #TReaderInfoAuthChallenge_, #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_change
 * \req_rdr
 */
typedef struct TRdrFkcEKEChallengeWriteSyncro2csp_ {
    size_t size_of;		    //!<   
    TRdrFkcSigma uiS2;		    //!<    
} TRdrFkcEKEChallengeWriteSyncro2csp;

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrChallenge2folder     Delta" (  -  )
 * \sa #TReaderInfoAuthChallenge_, #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_change
 * \req_rdr
 */
typedef struct TRdrFkcEKEChallengeWriteDelta2fkc_ {
    size_t size_of;		    //!<   
    TRdrFkcOrder u3;		    //!<   Delta"
    TRdrFkcTrID	TrId;		    //!<  
} TRdrFkcEKEChallengeWriteDelta2fkc;

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrChallenge2folder     Q
 * \sa #TReaderInfoAuthChallenge_, #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_change
 * \req_rdr
 */
typedef struct TRdrFkcEKEChallengeReadQFKC2fkc_ {
    size_t size_of;		    //!<   
    TRdrFkcTrID	TrId;		    //!<  
} TRdrFkcEKEChallengeReadQFKC2fkc;

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrChallenge2rdr     Q
 * \sa #TReaderInfoAuthChallenge_, #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_change
 * \req_rdr
 */
typedef struct TRdrFkcEKEChallengeReadQFKC2csp_ {
    size_t size_of;		    //!<   
    TRdrFkcPoint u3;		    //!<  Q
} TRdrFkcEKEChallengeReadQFKC2csp;

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrChallenge2folder     Qpw" (  -  )
 * \sa #TReaderInfoAuthChallenge_, #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_change
 * \req_rdr
 */
typedef struct TRdrFkcEKEChallengeWriteQPW2fkc_ {
    size_t size_of;		    //!<   
    TRdrFkcPoint u3;		    //!<   Qpw"
    TRdrFkcTrID	TrId;		    //!<  
} TRdrFkcEKEChallengeWriteQPW2fkc;

/*! \ingroup rdr_ext_chl_eke_struct
 * \brief   #TRdrChallenge2folder  "   ()   " (  -  )
 * \sa #TReaderInfoAuthChallenge_, #TReaderInfoAuthChange_, #rdr_auth_challenge, #rdr_auth_change
 * \req_rdr
 */
typedef struct TRdrFkcEKEChallengeChangeMask2fkc_ {
    size_t size_of;		    //!<   
    TRdrFkcPoint uQs;		    //!<  -  EKE (   EKE)
    unsigned char utf8PIN[RDR_PIN_MAX_SIZE];
				    //!<  PIN  
    TRdrFkcTrID	TrId;		    //!<  
    TRdrFkcCommitMask savemask;     //!<  
} TRdrFkcEKEChallengeChangeMask2fkc;

MAKE_CONVERSION_FUNCTIONS(TRdrFkcEKEChallengeFirst2fkc, TRdrChallenge2folder, MCF_CHECK_size_of)
#if _DEBUG
MAKE_CONVERSION_FUNCTIONS(TRdrFkcEKEChallengeFirst2fkc_debug, TRdrChallenge2folder, MCF_CHECK_size_of)
#endif
MAKE_CONVERSION_FUNCTIONS(TRdrFkcEKEChallengeReadSyncro2fkc, TRdrChallenge2folder, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcEKEChallengeWriteSyncro2fkc, TRdrChallenge2folder, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcEKEChallengeWriteDelta2fkc, TRdrChallenge2folder, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcEKEChallengeWriteQPW2fkc, TRdrChallenge2folder, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcEKEChallengeChangeMask2fkc, TRdrChallenge2folder, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcEKEChallengeReadQFKC2fkc, TRdrChallenge2folder, MCF_CHECK_size_of)

MAKE_CONVERSION_FUNCTIONS(TRdrFkcEKEChallengeFirst2csp, TRdrChallenge2rdr, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcEKEChallengeReadSyncro2csp, TRdrChallenge2rdr, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcEKEChallengeWriteSyncro2csp, TRdrChallenge2rdr, MCF_CHECK_size_of)
MAKE_CONVERSION_FUNCTIONS(TRdrFkcEKEChallengeReadQFKC2csp, TRdrChallenge2rdr, MCF_CHECK_size_of)

#if defined( __cplusplus )
extern "C" {
#endif /* defined( __cplusplus ) */

_RDR_DECL TSupErr fkc_lock(		// TODO: doc
    TSupSysEContext *context );

_RDR_DECL TSupErr rdr_folder_open_ex(		// TODO: doc
    TSupSysEContext *context,
    const TCHAR *mode,
    const TCHAR *folder,
    const TRdrInfoFolderOpenEx_param *param );

_RDR_DECL TSupErr rdr_folder_get_param(		// TODO: doc
    const TSupSysEContext * context,
    const TRdrFolderEnumParam paramID,
    TRdrFolderParamValue *paramValue,
    size_t *paramSize );

_RDR_DECL TSupErr rdr_folder_set_param(		// TODO: doc
    TSupSysEContext * context,
    const TRdrFolderParamValue *paramValue );

_RDR_DECL TSupErr fkc_passwd_term(
    const TSupSysEContext *context,
    size_t *length,
    TCHAR *term );

/*     . */
_RDR_DECL TSupErr fkc_passwd_length(
    const TSupSysEContext *context, TRdrLoginInfoType *type, 
    size_t *max_length, size_t *min_length );

_RDR_DECL TSupErr rdr_auth_type(
    TSupSysEContext *context,
    TRdrInfoAuthType *authType,
    size_t *authSize );

_RDR_DECL TSupErr rdr_auth_challenge(
    TSupSysEContext *context,
    TRdrLoginInfoType type,
    TRdrChallenge_class Class,
    TRdrChallenge_id id,
    const TRdrChallenge2folder *toFolder,
    TRdrChallenge2rdr *fromFolder );

/*
 *      
 *  Challenge/Responce 
 */
_RDR_DECL TSupErr rdr_auth_change(
    TSupSysEContext *context,
    TRdrLoginInfoType type,
    TRdrChallenge_class Class,
    TRdrChallenge_id id,
    const TRdrChallenge2folder *toFolder,
    TRdrChallenge2rdr *fromFolder );

/*   ""  . */
_RDR_DECL TSupErr rdr_friendly_name_set(    // TODO: doc
    TSupSysEContext * context,
    const TCHAR * tFriendlyName );

/*
 *  ,   
 */

    //    
_RDR_DECL TSupErr rdr_crypt_key_gen(
    TSupSysEContext *context,
    const TRdrFkcPoint *uQs,
    const TRdrFkcPoint *uQpw,
    const TCHAR *tPIN );

    //    
_RDR_DECL TSupErr rdr_crypt_key_set(
    TSupSysEContext *context,
    const TRdrFkcPoint *uQs,
    const TRdrFkcPoint *uQpw,
    const TRdrFkcOrder *udfkc,
    const TRdrFkcSyncro *usyncro,
    const TCHAR *tPIN );

_RDR_DECL TSupErr rdr_crypt_uec_key_set(
				    TSupSysEContext *context,
				    const TRdrFkcOrder *d,
				    BYTE * pubKey
				    );


/*   1     */
_RDR_DECL TSupErr rdr_uec_set_pin1( 
				   TSupSysEContext *context, const TCHAR  *pin );

/*   1     */
_RDR_DECL TSupErr rdr_uec_change_pin1( 
				   TSupSysEContext *context, const TCHAR  *pin );

/*        */
_RDR_DECL TSupErr rdr_uec_read_data(
				    TSupSysEContext *context, unsigned int is_binary, size_t pos,
				    size_t size, unsigned int read_param, void *buffer, size_t *read_len ); 

/*        */
_RDR_DECL TSupErr rdr_uec_open_data (
				     TSupSysEContext *context, unsigned short data_id);

/*        */
_RDR_DECL TSupErr rdr_uec_close_data (
				      TSupSysEContext *context );


/*        */
_RDR_DECL TSupErr rdr_uec_write_data(
			   TSupSysEContext *context, size_t pos, size_t size, const void *buffer,
			   unsigned int is_binary, unsigned int write_param);

    //     
_RDR_DECL TSupErr rdr_set_auth_param(
    TSupSysEContext *context,
    const TRdrFkcPoint *uQs,
    const TRdrFkcPoint *uQpw,
    const TRdrFkcSyncro *usyncro);

    //   
_RDR_DECL TSupErr rdr_crypt_signature_1(
    TSupSysEContext *context,
    const TRdrFkcOrder *e,
    TRdrFkcPoint *uR2, 
    const TRdrFkcTrID	TrId,
    const TRdrFkcTrNewID IsNewTr);

    //       (    k2)
_RDR_DECL TSupErr rdr_crypt_signature_1_debug(
    TSupSysEContext *context,
    const TRdrFkcOrder *e,
    const TRdrFkcOrder *k2,
    TRdrFkcPoint *uR2,
    const TRdrFkcTrID	TrId,
    const TRdrFkcTrNewID IsNewTr );

    //   
_RDR_DECL TSupErr rdr_crypt_signature_2(
    TSupSysEContext *context,
    const TRdrFkcOrder *ur,
    TRdrFkcOrder *us2,
    const TRdrFkcTrID	TrId );

    //  
_RDR_DECL TSupErr rdr_crypt_agreement_1(
    TSupSysEContext *context,
    const TRdrFkcPoint *uQalpha,
    TRdrFkcPoint *uK2,
    const TRdrFkcTrID	TrId,
    const TRdrFkcTrNewID IsNewTr );

//      eToken GOST
_RDR_DECL TSupErr rdr_crypt_agreement_mask(
    TSupSysEContext *context,
    const TRdrFkcPoint *uQalpha,
    TRdrFkcPoint *uDK2,
    TRdrFkcOrder *D);

_RDR_DECL TSupErr rdr_crypt_agreement(
    TSupSysEContext *context,
    const TRdrFkcPoint *uQalpha,
    const TRdrFkcUKM * ukm,
    TRdrFkcOrder *key);

    //   
_RDR_DECL TSupErr rdr_crypt_signature_uec(
				TSupSysEContext *context,
				BYTE * hash,
				DWORD hash_len,
				BYTE * signature,
				DWORD * signature_len
				); 

    //  -
_RDR_DECL TSupErr rdr_crypt_uec_key_gen(
			      TSupSysEContext *context,
			      BYTE * pubKey
			      );

    //    //

//  
_RDR_DECL TSupErr rdr_crypt_hash_init(
    TSupSysEContext *context,
    unsigned int hash_algid, 
    TRdrHashContext ** hash_ctx
    );

//  
_RDR_DECL TSupErr rdr_crypt_hash_data(
    TSupSysEContext *context,
    TRdrHashContext * hash_ctx,
    const void * data,
    size_t data_len,
    size_t * hashed_data_len);

//   
_RDR_DECL TSupErr rdr_crypt_hash_getval(
    TSupSysEContext *context,
    TRdrHashContext * hash_ctx,
    void * buffer,
    size_t * buffer_len);

//      
_RDR_DECL TSupErr rdr_crypt_signature_hash_1(
    TSupSysEContext *context,
    TRdrHashContext * hash_ctx,
    TRdrFkcPoint *uR2, 
    const TRdrFkcTrID	TrId,
    const TRdrFkcTrNewID IsNewTr);

_RDR_DECL TSupErr rdr_crypt_signature_uec_hash(
    TSupSysEContext *context,
    TRdrHashContext * hash_ctx,
    BYTE * signature,
    DWORD * signature_len);

//    
_RDR_DECL TSupErr rdr_crypt_hash_destroy(
    TSupSysEContext *context,
    TRdrHashContext * hash_ctx);

//   
_RDR_DECL TSupErr rdr_get_random(
    TSupSysEContext *context, size_t *length, BYTE *out  );


TSupErr rdrfkc_load_library( void );
void rdrfkc_unload_library( void );

#if defined( __cplusplus )
}
#endif /* defined( __cplusplus ) */


#endif /*!defined(_RDR_FKC_H)*/
/* end of file: $Id: rdr_fkc.h 110687 2014-08-28 05:51:11Z borodin $ */
