/*
 * Copyright(C) 2010-2012
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */
/*!
 * \version $Revision: 109932 $
 * \date $Date: 2014-08-08 01:20:08 +0400 (Птн, 08 Авг 2014) $
 * \author $Author: lse $
 *
 * \brief
 *
 */

#ifndef _TYPEDEFS_SADB_H_
#define _TYPEDEFS_SADB_H_

/*     CPC/CSP, ..
 * typedefs_sadb.h    wincspc.h
 *
 *  SIZEOF_VOID_P  ,   
 * . 
 * TODO:  uintptr_t ,  .   CSP
 *   ULONG_PTR  UINT_PTR,    
 *   uintptr_t.
 */
#if !defined _WINCSPC_H_INCLUDED
typedef struct CPC_CONFIG_ CPC_CONFIG, *LPCPC_CONFIG;
typedef struct CPC_FUNCTION_TABLE_ *HCRYPTMODULE;
#endif	/* !_WINCSPC_H_INCLUDED */

#if !defined __WINCRYPT_H__
#ifndef SIZEOF_VOID_P 
    typedef ULONG_PTR HCRYPTPROV;
    typedef ULONG_PTR HCRYPTKEY;
    typedef ULONG_PTR HCRYPTHASH;
#elif SIZEOF_VOID_P == 4
    typedef unsigned long HCRYPTPROV;
    typedef unsigned long HCRYPTKEY;
    typedef unsigned long HCRYPTHASH;
#elif SIZEOF_VOID_P == 8
    typedef unsigned long long HCRYPTPROV;
    typedef unsigned long long HCRYPTKEY;
    typedef unsigned long long HCRYPTHASH;
#endif
#endif	/* !__WINCRYPT_H__ */

/*!
 * \ingroup sadbData
 * \struct privkey
 * \brief   /. 
 *
 */
typedef struct privkey {
    HCRYPTMODULE hModule;
        /*!< \brief   " CSP".
         */
    HCRYPTPROV hProv;
        /*!< \brief    .
         */
    HCRYPTKEY hKey;
        /*!< \brief   .
         */
} PRIVKEY;

/*   */
typedef uint8_t Tpubkeyblob[0x64]; /* PUBLICKEYBLOB      */
typedef uint8_t Tsimpleblob[71];   /* SIMPLEBLOB      */
typedef uint8_t Tprivateblob[114];   /* PRIVATEKEYBLOB ( )      */

/*!
 * \ingroup sadbData
 * \struct pubkey
 * \brief   /. 
 *
 */
#if !defined SOLARIS		// TODO:    push
    #pragma pack(push,4)
#else
    #pragma pack(4)
#endif
typedef struct pubkey {
    Tpubkeyblob sa;
        /*!< \brief   .
         */
    long long born_time;
        /*!< \brief    .
         */
    CPIPSEC_LDURATION_T ttlutc;
        /*!< \brief    .
         */
} PUBKEY;
#if !defined SOLARIS
    #pragma pack(pop)
#else
    #pragma pack()
#endif

typedef uint8_t CPSADB_UKM_T[8];
typedef uint8_t CPSADB_WKEY_T[32];
typedef uint8_t CPSADB_IMIT_T[4];
typedef uint8_t CPSADB_HASH_T[32];
typedef uint8_t CPSADB_KE_T[64];

/*!
 * \ingroup sadbData
 * \struct CPSADB_KEYWRAP
 * \brief   . 
 *
 */
typedef struct CPSADB_KEYWRAP {
    CPSADB_UKM_T cpsadb_ukm;
    /*!< \brief    . */
    CPSADB_WKEY_T cpsadb_wkey;
    /*!< \brief   . */
    CPSADB_IMIT_T cpsadb_imit;
    /*!< \brief    . */
} CPSADB_KEYWRAP_T;

/*     ipsec/doc/typedefs_sadb.dtx */
/*     */
typedef struct sadbIPsec_SA {
    struct sadb_ipsec_param {
	uint16_t sadb_ip_ver_spec; //      Vendor ID
	uint8_t sadb_ip_spi[4];
	uint8_t sadb_ip_dir;
	uint8_t sadb_ip_satype;  // CPIPSEC_PROTO_IPSEC_ESP, CPIPSEC_PROTO_IPSEC_AH  SADB_SATYPE_AH/SADB_SATYPE_ESP
	uint8_t sadb_ip_encrypt; //     (CPESP_TRANSFORM_ID_T)
				 //  CPIPSEC_PROTO_IPSEC_AH     
				 // sadb_ip_encrypt == CPESP_NULL
				 //
				 // TODO: uint8_t sadb_ip_ah_transform;
	uint16_t sadb_ip_auth;   //      (CPAH_TRANSFORM_ID_T)
				 //  CPIPSEC_PROTO_IPSEC_AH - 2..255
				 //  CPIPSEC_PROTO_IPSEC_ESP - 1..65535
				 //  ,   - union   uint8_t  uint16_t
				 //    sadb_ip_encrypt != CPESP_NULL,   
				 //     CPESP_MAC_NULL
	uint8_t sadb_ip_replay;  //  ,   128
	uint32_t sadb_ip_flags;	 //  ECN ( CPIPSEC_AT_Ext_Serial_Number, CPIPSEC_ATP_Check_SN)
	uint8_t sadb_ip_ivlen;   //  SPIcookie (0-4)  IV ( ? )
	uint8_t sadb_ip_padmod;  //  
	uint8_t sadb_ip_icvlen;  //  ICV --- ???   ???
	uint8_t sadb_ip_hashlen; //  HASH ( 1-4)
	uint8_t sadb_ip_hmaclen; //  HMAC	  (8-32)  
    } sap;

    //   sadb_key_data_ipsec_gost 
    //        
    struct sadb_key_data_ipsec_gost {
	CPSADB_UKM_T sadb_kdgc_ukm;
	struct sadb_kdg_content_ipsec {
	    uint32_t sadb_kdgc_AlgId;
	    uint32_t sadb_kdgc_Magic;
	    CPSADB_KEYWRAP_T sadb_kdgc_Kr_e;
	    CPSADB_KEYWRAP_T sadb_kdgc_Kr_i;
	    uint8_t sadb_kdgc_spicookie[4];
	    uint16_t sadb_kdgc_sbox; /* uint16_t = id Cipher_OID CPESP_SBOX_T*/
	    CPIPSEC_MAX_AUTH_ERR_T sadb_kdgc_max_auth;
	    CPESP_MAX_PKTLEN_T sadb_kdgc_maxmsg;
	    CPIPSEC_LDURATION_T sadb_kdgc_ttlkb;
	    CPIPSEC_LDURATION_T sadb_kdgc_ttlutc;
	} tbh;
	CPSADB_IMIT_T hmac;   // substr(0..3, HMAC(XCH_SADB_vko, tbh))
    } kd;
} SADBIPSECSA;

/*     ipsec/doc/typedefs_sadb.dtx */
typedef struct sadbIKE_SA {
    //   sadb_ike_param 
    //  "host" ,   RFC 2367
    struct sadb_ike_param {
	uint16_t sadb_ikep_ver_spec;	//      Vendor ID
	uint16_t sadb_ikep_auth;	// CPIKE_AUTH_GOST_PSK, CPIKE_AUTH_GOST_SIGNATURE
	uint16_t sadb_ikep_encrypt;	// CPIKE_ENC_A/B/C/D
	uint16_t sadb_ikep_hash;	// CPIKE_HASH_A
	uint8_t sadb_ikep_ivlen;	//  InitVector
	uint8_t sadb_ikep_padmod;	//  
	uint8_t sadb_ikep_icvlen;	//  ICV
	uint8_t sadb_ikep_kelen;	//  KE
	uint8_t sadb_ikep_hashlen;      //  HASH
	uint8_t sadb_ikep_cfgmode_status; // CFGMODE final status
    } sap;

    //   sadb_key_data_ike_gost 
    //        
    struct sadb_key_data_ike_gost {
	CPSADB_UKM_T sadb_kdgc_ukm;
	struct sadb_kdg_ike_content {
	    uint32_t sadb_kdgc_AlgId;
	    uint32_t sadb_kdgc_Magic;
	    CPSADB_KEYWRAP_T sadb_kdgc_SID_d;
	    CPSADB_KEYWRAP_T sadb_kdgc_SID_a;
	    CPSADB_KEYWRAP_T sadb_kdgc_SID_e;
	    uint16_t sadb_kdgc_sbox; /* uint16_t = id Cipher_OID CPESP_SBOX_T*/
	    uint8_t sadb_kdgc_pfs; /* uint8_t   PFS CPIKE_PFSC_T*/
	    CPESP_MAX_PKTLEN_T sadb_kdgc_maxmsg;
	    CPIPSEC_LDURATION_T sadb_kdgc_ttlkb;
	    CPIPSEC_LDURATION_T sadb_kdgc_ttlutc;
	    CPSADB_HASH_T sadb_kdgc_AUTH_I;
	    CPSADB_HASH_T sadb_kdgc_AUTH_R;
	    CPSADB_IMIT_T sadb_kdgc_Last_ICV;  // (   8 ??? )
	    uint32_t sadb_kdgc_gostcookie; // GOST_cookie retro for R65 ver_spec
	    uint32_t sadb_kdgc_counter_bytes; // IPSEC-471 counter_bytes through all
	} tbh;
	CPSADB_IMIT_T hmac;   // substr(0..3, HMAC(XCH_SADB_vko, tbh))
    } kd;
} SADBIKESA;

/*     ipsec/doc/typedefs_sadb.dtx */
typedef struct sadbSADB_SA {
    //   sadb_sa_param 
    //  "host" ,   RFC 2367
    struct sadb_sa_param {	   // 
	uint16_t sadb_sadbp_gtype; // CPIKE_GTYPE_VKO_GOST_R_34_10_2001
	uint16_t sadb_sadbp_group; // CPIKE_GROUP_XchA
	uint16_t sadb_sadbp_hash;  // CPIKE_HASH_A
    } sap;
    //   sadb_key_data_sadb_gost 
    //        
    struct sadb_key_data_sadb_gost {
	struct sadb_kdg_sadb_content {
	    uint32_t sadb_kdgs_AlgId;
	    uint32_t sadb_kdgs_Magic;
	    CPSADB_KE_T sadb_kdgs_ke;
	    CPIPSEC_LDURATION_T sadb_kdgs_ttlutc;
	} tbh;
	CPSADB_IMIT_T hash;  
    } kd;
} SADBSA;

#endif /* _TYPEDEFS_SADB_H_ */
