/* vim:set sw=4 ts=8 fileencoding=cp1251:::WINDOWS-1251[] */
/*
 * Copyright(C) 2004-2013  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 106271 $
 * \date $Date: 2014-05-07 17:31:22 +0400 (Срд, 07 Май 2014) $
 * \author $Author: lse $
 */

static int log_level = 1;
static int log_format = 0x1f;
static char *serial=(char*)0;
#include <linux/version.h>
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,18)
#   error Kernels below 2.4.18 are not supported
#endif
#include <linux/module.h>
#include <linux/vmalloc.h>
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,0)
#   include <linux/init.h>
#   ifndef module_param
#       include <linux/moduleparam.h>
#   endif
    module_param(log_level, int, 0);
    module_param(log_format, int, 0);
    module_param(serial, charp, 0);
#else
#   if defined(CONFIG_MODVERSIONS) && !defined(MODVERSIONS)
#       define MODVERSIONS
#       include <linux/modversions.h>
#   endif
#   define MODULE_VERSION "1.0.0"
#   include <linux/fs.h>
#   include <linux/kernel.h>
#   include <linux/major.h>
#   include <linux/errno.h>
    MODULE_PARM(log_level, "i");
    MODULE_PARM_DESC(log_level, "Log level bitmask, default value is 1 (0x1).");
    MODULE_PARM(log_format, "i");
    MODULE_PARM_DESC(log_format, "Log format bitmask, default value is 31 (0x1f).");
    MODULE_PARM(serial, "s");
    MODULE_PARM_DESC(serial, "Serial number.");
#endif
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,0)
    #include <linux/hardirq.h> /* for in_interrupt() */
#endif
#include <asm/atomic.h>

#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,10)
/* XXX dim  ,   . ..,  ? */
#include <asm/system.h>
#endif

/*#include <stddef.h>*/
typedef int wchar_t;

#include "common.h"

#include "wincspc.h"
#include "wincspc_int.h"

#include "lfmm.h"
#include "lfmm_int.h"
#include "reader/support.h"

typedef INT_PTR intptr_t; //  SUP_STOP,   :) TODO:  

#define USE_FAST_CODE

#ifdef USE_FAST_CODE
#   if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,30)
	    /*   AVX
	     * http://ru.wikipedia.org/wiki/AVX
	     * http://kernelnewbies.org/Linux_2_6_30
	     * http://git.kernel.org/linus/a30469e7921a6dd2067e9e836d7787cfa0105627
	     */
#       define FC_MASK 0
#   else
#       define FC_MASK CSP_FAST_CODE_DISABLE_AVX
#   endif
#   if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,28)
	    /* include/asm-x86   
	     * arch/include/asm
	     */
#       include <asm/i387.h>
#   elif LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,24)
	    /*   asm-i386  asm-x86_64  asm-x86 
	     * http://kernelnewbies.org/Linux_2_6_24
	     */
#       include <asm-x86/i387.h>
#   elif defined(__i386__)
#       include <asm-i386/i387.h>
#   elif defined(__x86_64__) || defined(__AMD64__)
#       include <asm-x86_64/i387.h>
#   else
#       error UNKNOWN PLATFORM
#   endif
#endif  /* USE_FAST_CODE */

#if defined(USE_FAST_CODE) && \
    defined(__i386__) && LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
    	//  <asm-i386/i387.h> kernel_fpu_begin(),   
	//   (> 2.5.0),     

    #if LINUX_VERSION_CODE < KERNEL_VERSION(2, 5, 0)
	static inline void __my_save_init_fpu( struct task_struct *tsk )
	{
	    if ( cpu_has_fxsr ) {
		    asm volatile( "fxsave %0 ; fnclex"
				  : "=m" (tsk->thread.i387.fxsave) );
	    } else {
		    asm volatile( "fnsave %0 ; fwait"
				  : "=m" (tsk->thread.i387.fsave) );
	    }
	    tsk->flags &= ~PF_USEDFPU;
	}

	static void inline my_kernel_fpu_begin(void)
	{
	    struct task_struct *tsk = current;

	    if (tsk->flags & PF_USEDFPU) {
		    __my_save_init_fpu(tsk);
		    return;
	    }
	    clts();
	}
    #else
	static void inline my_kernel_fpu_begin(void)
	{                                                                       
	    struct thread_info *thread = current_thread_info();                 

	    preempt_disable();                                                  
	    if (thread->status & TS_USEDFPU) {                                  
		__save_init_fpu(thread->task);                                  
		return;                                                         
	    }                                                                   
	    clts();                                                             
	}                                                                       
    #endif

#   define fc_kernel_fpu_begin() my_kernel_fpu_begin()
#else 
#   define fc_kernel_fpu_begin() kernel_fpu_begin()
#endif

#if defined(USE_FAST_CODE) && LINUX_VERSION_CODE < KERNEL_VERSION(2,6,32)

#   if !defined(X86_CR0_TS)
	    // : asm/processor-flags.h
#       define X86_CR0_TS        0x00000008 /* Task Switched */
#   endif

#   if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
	static __inline__ int atomic_dec_return(atomic_t *v)
	{
		//       
		//   .
	    atomic_dec(v);
	        // : 0 <= atomic_read(&cpkf_fpu_counter.cnt),
		//      .
	    return atomic_read(v);
	}

	static inline BOOL my_interrupted_kernel_fpu_idle(void) {
	    return !(current->flags & PF_USEDFPU) &&
		    (read_cr0() & X86_CR0_TS);
	}
#   else
	static inline BOOL my_interrupted_kernel_fpu_idle(void) {
	    return !(current_thread_info()->status & TS_USEDFPU) &&
		    (read_cr0() & X86_CR0_TS);
	}
#   endif

    static inline BOOL my_interrupted_user_mode(void) {
        return TRUE;
	//TODO:  2.6.32   ,    
	//  2.6.18:
	//	get_irq_regs() - 
	//	user_mode() - 
	//	user_mode_vm() - 
	//      __get_cpu_var() - 
	//      __irq_regs -  (  set_irq_regs())
        //
        //struct pt_regs *regs = get_irq_regs();
        //return regs && user_mode_vm(regs);
	//
	//static inline struct pt_regs *get_irq_regs(void)
	//{
	//        return __get_cpu_var(__irq_regs);
	//}
    }

    static inline BOOL my_irq_fpu_usable(void) {
        return !in_interrupt() || 
                my_interrupted_user_mode() ||
                my_interrupted_kernel_fpu_idle();
    }

#   define fc_irq_fpu_usable() my_irq_fpu_usable()
#else 
#   define fc_irq_fpu_usable() irq_fpu_usable()
#endif


#define MODNAME "drvcsp"
#if __GNUC__==2
    /* A problem with kernel in gcc 2... We don't have this function */
    void __builtin_delete(void *arg)
    {
      UNUSED(arg);
      printk( KERN_ALERT MODNAME ": __builtin_delete called\n");
    }
#endif

EXPORT_SYMBOL(CPCGetDefaultConfig);
EXPORT_SYMBOL(CPCCreateProvider);
EXPORT_SYMBOL(CPCInitMemoryLF);

#define STATUS_FILE "status"
MODULE_LICENSE("LLC \"Crypto-Pro\"");
MODULE_AUTHOR("CryptoPro Ltd. <support@cryptopro.ru>");
MODULE_DESCRIPTION("CryptoPro CSP kernel module");

#ifdef USE_FAST_CODE
    static CPC_Kernel_Fpu_Begin_Callback kernel_fpu_begin_func;
    static CPC_Kernel_Fpu_End_Callback kernel_fpu_end_func;
#endif

static int
drvcsp_init(void)
{
    printk( KERN_ALERT MODNAME ": Registered\n");
    return 0;
}

static inline void CPCAPI
dprint_func(void *callback_arg, const TCHAR *str)
{
    printk(KERN_INFO "%s\n", str);
}

static inline void CPCAPI
eprint_func(void *callback_arg, const TCHAR *str)
{
    printk(KERN_ERR "%s\n", str);
}

static inline void CPCAPI
elprint_func(void *callback_arg, const TCHAR *str)
{
    printk(KERN_ERR "%s\n", str);
}

static inline void CPCAPI
cprint_func(void *callback_arg, const TCHAR *str)
{
    return dprint_func(callback_arg, str);
}
     
static unsigned long CPCAPI
get_thread_id(void)
{
    return 0;
}

static DWORD CPCAPI
gettimeofday_func(CPC_timeval *pTV, LPVOID lpArg)
{
    struct timeval tv;

    do_gettimeofday (&tv);
    pTV->tv_sec = tv.tv_sec;
    pTV->tv_usec= tv.tv_usec;

    return S_OK;
}

#ifdef USE_FAST_CODE
    #if defined(DEBUG) || defined(_DEBUG)
        #define FPU_SUP_STOP SUP_STOP
    #else
    	#define FPU_SUP_STOP 
    #endif
	    
    typedef enum CHECK_BUF_STATUS_ {
        CFB_UNDEFINED = 0x46444e55 /*'UNDF'*/,
        CFB_FREE      = 0x45455246 /*'FREE'*/,
        CFB_FLOATING  = 0x544c4653 /*'SFLT'*/,
    } CHECK_BUF_STATUS;

    typedef struct CHECK_FLOAT_BUF_ {
        CHECK_BUF_STATUS iType;
        size_t	sSize;
    } CHECK_FLOAT_BUF;

    static struct cpksp_fpu_counter {
        atomic_t cnt;
        atomic_t total;
        atomic_t notusable;
        volatile CHECK_FLOAT_BUF *last_success_save;
        volatile CHECK_FLOAT_BUF *last_success_restore;
    } cpkf_fpu_counter = { ATOMIC_INIT(0), ATOMIC_INIT(0), ATOMIC_INIT(0), 
			    0, 0 /*...*/ };


    static BOOL CPCAPI kernel_fpu_begin_func(BYTE *buf, CPC_SIZE_T sz, DWORD bl_len, DWORD op_type )
    {
        CHECK_FLOAT_BUF *ps;

        if(sz < sizeof(*ps)){
            printk(KERN_ERR MODNAME ":%s:%d: Error: sz < sizeof(*ps) "
			"(%p, %d, 0x%x, 0x%x)\n", 
			__FUNCTION__, __LINE__,
			buf, (int)sz, bl_len, op_type);
	    FPU_SUP_STOP;
	    return FALSE;
        }
        ps = (CHECK_FLOAT_BUF *)buf;
        if(ps->iType == CFB_FLOATING){
            printk(KERN_ERR MODNAME ":%s:%d: Error: Assert failed: "
			"ps->iType == KSP_FLOATING\n",
			__FUNCTION__, __LINE__);
	    FPU_SUP_STOP;
	    return FALSE;
        }
        if(ps->iType == CFB_UNDEFINED){
            printk(KERN_ERR MODNAME ":%s:%d: Error: "
			"ps->iType == CFB_UNDEFINED\n",
			__FUNCTION__, __LINE__);
	    FPU_SUP_STOP;
        }

        if(!fc_irq_fpu_usable()) {
	    //    ,     FPU/AVX
	    //  .  ,   FALSE.

	    atomic_inc(&cpkf_fpu_counter.notusable);
	    // :
	    //KdPrint((MODNAME "! KSP_fpu_begin: "
	    //    "KeGetCurrentIrql() return %d > DISPATCH_LEVEL => Can't FPU access\n", 
	    //    ps->kirql));
	    return FALSE;
        }
        ps->sSize = sizeof(*ps);
        ps->iType = CFB_UNDEFINED;

        fc_kernel_fpu_begin();
        ps->iType = CFB_FLOATING;

	atomic_inc(&cpkf_fpu_counter.total);
	atomic_inc(&cpkf_fpu_counter.cnt);
	cpkf_fpu_counter.last_success_save = ps;

        return TRUE;
    }

    static BOOL CPCAPI kernel_fpu_end_func(BYTE * buf, CPC_SIZE_T sz, DWORD op_type)
    {
        CHECK_FLOAT_BUF *ps;

        if(sz < sizeof(*ps)){
            printk(KERN_ERR MODNAME ":%s:%d: Error: sz < sizeof(*ps) "
			"(%p, %d, 0x%x)\n", 
			__FUNCTION__, __LINE__,
			buf, (int)sz, op_type);
	    FPU_SUP_STOP;
	    return FALSE;
        }
        ps = (CHECK_FLOAT_BUF *)buf;
        if(ps->sSize != sizeof(*ps)){
            printk(KERN_ERR MODNAME ":%s:%d: Error: Assert failed: "
			"ps->sSize != sizeof(*ps)\n",
			__FUNCTION__, __LINE__);
            return FALSE;
        }

        switch(ps->iType){
	case CFB_FLOATING:
            kernel_fpu_end();
	    break;
	case CFB_UNDEFINED:
            printk(KERN_ERR MODNAME ":%s:%d: Error: Assert failed: "
			"Not locked (CFB_UNDEFINED)\n",
			__FUNCTION__, __LINE__);
	    FPU_SUP_STOP;
	    return FALSE;
	case CFB_FREE:
            printk(KERN_ERR MODNAME ":%s:%d: Error: Assert failed: "
			"Double free (CFB_FREE)\n",
			__FUNCTION__, __LINE__);
	    FPU_SUP_STOP;
	    ps->iType = CFB_UNDEFINED;
	    return FALSE;
	default:
            printk(KERN_ERR MODNAME ":%s:%d: Error: Assert failed: "
			"Unknown ps->iType\n",
			__FUNCTION__, __LINE__);
	    FPU_SUP_STOP;
	    ps->iType = CFB_UNDEFINED;
	    return FALSE;
        }

	if(0 > atomic_dec_return(&cpkf_fpu_counter.cnt)) {
	    FPU_SUP_STOP;
            printk(KERN_ERR MODNAME ":%s:%d: Error: Assert failed: "
			"0 > cpkf_fpu_counter.cnt\n",
			__FUNCTION__, __LINE__);
	}
	cpkf_fpu_counter.last_success_restore = ps;
	ps->iType = CFB_FREE;
	ps->sSize = 0;

        return TRUE;
    }

#   define KERNEL_BUF_SIZE (16 + sizeof(CHECK_FLOAT_BUF))
#else
#   define KERNEL_BUF_SIZE 16
#endif

DWORD CPCAPI CPCGetDefaultConfig(
    LPCPC_CONFIG pConfig,
    LPVOID pvReserved
    )
{
    if(pConfig->cbSize < sizeof(CPC_CONFIG) || pConfig->cbSize >= 0x4000 ||
       pvReserved != NULL) {
	return (DWORD)E_INVALIDARG;
    }
    memset(
	((char*)pConfig) + sizeof(pConfig->cbSize) + sizeof(pConfig->pArena), 
	0, 
	pConfig->cbSize - sizeof(pConfig->cbSize) - sizeof(pConfig->pArena));    
    pConfig->logConfig.name=MODNAME;
    pConfig->logConfig.level=log_level;
    pConfig->logConfig.format=log_format;
    pConfig->logConfig.dprint_str=dprint_func;
    pConfig->logConfig.eprint_str=eprint_func;
    pConfig->logConfig.elprint_str=elprint_func;
    pConfig->logConfig.cprint_str=cprint_func;
    pConfig->logConfig.get_thread_id=get_thread_id;
    pConfig->timeFuncs.get_time_of_day=gettimeofday_func;
    #ifdef USE_FAST_CODE
        pConfig->FuncStruct.UsesFunctions=CPC_FAST_CODE_USER;
        pConfig->FuncStruct.cp_kernel_fpu_begin=kernel_fpu_begin_func;
        pConfig->FuncStruct.cp_kernel_fpu_end=kernel_fpu_end_func;
        pConfig->FuncStruct.UsedMask=CSP_OPERATION_ALL|FC_MASK|CSP_FAST_CODE_RT_TS;
    #endif
    pConfig->FuncStruct.Kernel_Buf_Size=KERNEL_BUF_SIZE;
    pConfig->license=0;

    return 0;
}

static void
drvcsp_exit(void)
{
    printk(KERN_ALERT MODNAME ": FPU stats: cnt=%d total=%d notusable=%d "
                              "last_success_save=%p last_success_restore=%p\n",
		atomic_read(&cpkf_fpu_counter.cnt), 
		atomic_read(&cpkf_fpu_counter.total), 
		atomic_read(&cpkf_fpu_counter.notusable),
		cpkf_fpu_counter.last_success_save, 
		cpkf_fpu_counter.last_success_restore);
    printk(KERN_ALERT MODNAME ": Unregistered\n");
}

module_init(drvcsp_init);
module_exit(drvcsp_exit);
