/*
 * Copyright(C) 2003  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 54220 $
 * \date $Date: 2009-05-02 06:33:10 +0400 (Сбт, 02 Май 2009) $
 * \author $Author: lse $
 *
 * \brief PKIXCMP_Server class
 */

#include "common.h"
#include <iostream>
#include <string>
#include <stdio.h>
#ifdef UNIX
#include <unistd.h>
#endif

#include "conwnd.h"

using namespace std;

//     pin-
// \param name [in]  
// \param i [in]     pin.   
//  == 3. 
// \param pin [out] pin-      8 ,  
//    pin
// \param n [in]   
// \param num [in]   
// \return false     pin. true Ok
bool ConsoleWndProv::get_current_pin( const char *name, short i, char pin[9], short n, int num )
{
    UNUSED(n);
    UNUSED(num);

    if( i == 3 )
    {
	cout << name << " pin:"; 
	cout.flush();
    }
    else
    {
	char scount[2];
	sprintf( scount, "%d", i );
	cout << name << "Invalid pin. Retry. Pin [" << scount << "/3]:";
	cout.flush();
    }
    string spin;
    cin >> spin;
    strcpy (pin, spin.c_str());
    return true;
}

//      pin-
// \param name [in]  
// \param pin [out] pin-      8 ,  
//    pin
// \param n [in]   
// \param i [in]   
// \return false     pin. true Ok
bool ConsoleWndProv::get_new_pin( const char *name, char pin[9], short n, int num )
{
    UNUSED(n);
    UNUSED(num);

    cout << name << " new pin:"; 
    cout.flush();
    string spin;
    cin >> spin;
    strcpy (pin, spin.c_str());
    return true;
}

//      
// \return key_size
int ConsoleWndProv::get_key_size( )
{
    cout << "Input key size ( 0-default, 512, 1024...16384 ):"; 
    cout.flush();
    string skeysize;
    cin >> skeysize;
    int keysize = 0;
    sscanf( skeysize.c_str(), "%d", &keysize );
    return keysize;
}

//         
//   name.
// \param name [in]  ,   
// \param error [in]  ,    
//       0   
bool ConsoleWndProv::insert_create( const char *name, unsigned long error, short n, int num )
{
    UNUSED(n);
    UNUSED(num);

    if( error )
	cout << "Error:" << error << endl;
    cout << "Insert '" << name << "' [y/n]"; cout.flush();
    string s;
    cin >> s;
    return true;
}

static void prompt( const char *name, DWORD err )
{
    char str[30]; sprintf( str, "Error %x", err );
    cout << "Insert '" << name << "' " << str << endl;
}

//    .
//          
//     CANCEL.    
//       
bool ConsoleWndProv::retry( const char *name, int num, Retry &retr )
{
    bool ret = retr();
    DWORD last = retr.LastError();
    UNUSED(num);

    if( !ret )
	prompt( name, last );
    while( !ret )
    {
	DWORD err = retr.LastError();
	if( last != err )
	{
	    prompt( name, last );
	    last = err;
	}
#ifdef WIN32
	Sleep (1000);
#else
	sleep (1);
#endif
	ret = retr();
    };
    return true;
}

std::string ConsoleWndProv::get_reader( const ReaderList &list )
{
    std::string out;
    int i;
    cout << "Reader: [";
    ReaderList::const_iterator ci = list.begin();
    ReaderList::const_iterator cie = list.end();
    for( i = 1; ci != cie; ci++, i++ )
    {
	if( i > 1 ) cout << ", "; 
	cout << i << ':' << ci->first.c_str() << '(' << ci->second.c_str() << ')';
    }
    cout << "]? ";
    int out_n;
    do {
	cin >> out;
	out_n = atoi (out.c_str());
    } while (out_n <= 0 || out_n >= i);
    ci = list.begin();
    for( i = 1; ci != cie; ci++, i++ )
    {
	if ( i == out_n ) {
	    out = ci->second.c_str();
	    break;
	}
    }
    cout << out << endl;
    return out;
}

ConsoleWndProv con_wnd_prov;

//     pin-
// \param name [in]  
// \param i [in]     pin.   
//  == 3. 
// \param pin [out] pin-      8 ,  
//    pin
// \param n [in]   
// \param num [in]   
// \return false     pin. true Ok
bool SilentWndProv::get_current_pin( const char *name, short i, char pin[9], short n, int num )
{
    UNUSED(n);
    UNUSED(num);

    if( i != 3 )
    {
	char scount[2];
	sprintf( scount, "%d", i );
	cout << name << "Invalid pin. Retry. Pin [" << scount << "/3]:";
	cout.flush();
	return false;
    }
    cout << name << " pin:"; 
    cout.flush();
    cout << "11111111" << endl;
    strcpy( pin, "11111111" );
    return true;
}

//      pin-
// \param name [in]  
// \param pin [out] pin-      8 ,  
//    pin
// \param n [in]   
// \param i [in]   
// \return false     pin. true Ok
bool SilentWndProv::get_new_pin( const char *name, char pin[9], short n, int num )
{
    UNUSED(n);
    UNUSED(num);

    cout << name << " new pin:"; 
    cout.flush();
    cout << "11111111" << endl;
    strcpy( pin, "11111111" );
    return true;
}

//      
// \return key_size
int SilentWndProv::get_key_size( )
{
    cout << "Input key size ( 0-default, 512, 1024...16384 ):"; 
    cout.flush();
    cout << "1024" << endl;
    return 1024;
}

//         
//   name.
// \param name [in]  ,   
// \param error [in]  ,    
//       0   
bool SilentWndProv::insert_create( const char *name, unsigned long error, short n, int num )
{
    UNUSED(n);
    UNUSED(num);

    if( error )
	cout << "Error:" << error << endl;
    cout << "Insert '" << name << "' [y/n]"; cout.flush();
    cout << "y" << endl;
    return true;
}

//    .
//          
//     CANCEL.    
//       
bool SilentWndProv::retry( const char *, int, Retry &retr )
{
    bool ret = retr();
    if( !ret ) 
    {
	std::cout << "cancel" << std::cout;
	return false;
    }
    return true;
}

std::string SilentWndProv::get_reader( const ReaderList &list )
{
    std::string out;
    int i;
    cout << "Reader: [";
    ReaderList::const_iterator ci = list.begin();
    ReaderList::const_iterator cie = list.end();
    for( i = 1; ci != cie; ci++, i++ )
    {
	if( i > 1 ) cout << ", "; 
	cout << i << ':' << ci->first.c_str() << '(' << ci->second.c_str() << ')';
	if( ci->second == "REGISTRY" || ci->second == "HDIMAGE" )
	    out = ci->second;
    }
    cout << "]? ";
    cout << out << endl;
    return out;
}

bool SilentWndProv::force_new_pin()
{
    return true;
}

SilentWndProv silent_wnd_prov;

bool NoPinWndProv::get_current_pin( const char *, short i, char pin[9], short, int )
{ 
    if( i != 3 )
	return false;
    *pin = 0; 
    return true; 
}

bool NoPinWndProv::get_new_pin( const char *, char pin[9], short, int)
{ 
    *pin = 0; 
    return true; 
}

bool NoPinWndProv::no_pin()
{
    return true;
}

NoPinWndProv no_pin_wnd_prov;

#ifdef _WIN32
WIN32WndProv w32_wnd_prov;
#endif /* _WIN32 */
