/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

#ifndef _TOKEN_H_INCLUDED
#define _TOKEN_H_INCLUDED

#ifndef UNIX
# include <Windows.h>
# include <wincrypt.h>
#endif // UNIX

#include "WinCryptEx.h"

#include "fkchdimgeke.h"

/*********************************************************
*       TOKEN DEFINES
**********************************************************/
#define ECC_PLUS 0
#define ECC_MINUS 1

/* ,      */
#define C_SEQ_FALSE		3
#define C_FALSE			100
#define C_EKE			10000000
#define C_SGN			10000000
#define C_DH			10000000

#define ABILITY_INIT_KEY (TRUE)
#define ABILITY_WRITE_KEY (FALSE)
#define MAX_PASSWD_LENGTH 256
#define DISABLE_PASSWD_CARD (TRUE)

#define DW_KEYLEN 8

#define NAME_LENTH 256

#define PUBLICBLOBLEN	0x64
#define PUBLIC_ECCPOINT	(PUBLICBLOBLEN-(2*SECRET_KEY_LEN))

/*********************************************************
*       TOKEN STRUCT
**********************************************************/
typedef struct _TOKEN_COUNT_ {
    DWORD c_eke;	/*c1*/
    DWORD c_sig;	/*c2*/
    DWORD c_dh;		/*c3*/
    DWORD c_fls;	/*c4*/
    DWORD c_seqfls;	/*c5*/
} COUNTS,*PCOUNTS;

typedef struct _TOKEN_CONTAINER_ {
    BOOL	disablePass;
    BOOL	abilityInitKeys;
    BOOL	abilityWriteKeys;
    TCHAR	defaultPass[MAX_PASSWD_LENGTH+1];
    TCHAR 	TokenName[NAME_LENTH];	
    BYTE	pszKeyOID[0x20];    /*Temp*/
    DWORD 	dwKeySpec;	    /*AT_SIGNATURE,AT_KEYEXCHANGE*/
    ALG_ID 	aAlgId;		    /*CALG_GR3410EL,CALG_DH_EL_EPHEM*/
    COUNTS	C;
    HCRYPTPROV  hContainer;
    HCRYPTKEY   hKeyPair;
    HCRYPTHASH	signHash;

    BYTE syncro[SECRET_KEY_LEN];
    BYTE syncroNew[SECRET_KEY_LEN];
    BYTE deltaNew[SECRET_KEY_LEN];

    /*  */
    LPBYTE	    pbPublicKeyBlob;
    LPBYTE	    pbPWPublicKeyBlob;	    /*Qpw =Kpw*Qs*/
    LPBYTE	    pbPWPublicKeyBlobNew;
    LPBYTE	    pbSaltPublicBlob;	    /*Qs*/

    //TEMP//    . 
    //   ,   .
    LPBYTE	    pbPPHeader;	    /*  */
    DWORD	    dwPubBlobLen;

    /* EKE  */
    TRdrFkcCommitMask	    curmask;
    DWORD		    readyChange;

    /* */
    TRdrFkcTrID		    curtrid;

    LPEKE_CONTAINER	    lpEKEop;
    BOOL opened;
    BOOL isnew_fofrname;
} TOKEN_CONTAINER, *LPTOKEN_CONTAINER;


/*********************************************************
*       TOKEN CONTAINER NAMES
**********************************************************/
#include "Magistra.h"

#ifdef __cplusplus
extern "C" {
#endif
/*********************************************************
*       TOKEN CONTAINER FUNCS
**********************************************************/
void FKCReleaseTContainer(LPTOKEN_CONTAINER psRootKeys);

/*********************************************************
*       TOKEN KEY FUNCS
**********************************************************/
DWORD FKCAddPubKey(HCRYPTPROV hProv, LPBYTE pbPubKeyBlobA,LPBYTE pbPubKeyBlobB, 
		   DWORD* pdwBlobLen, DWORD dwECCSign, LPBYTE* ppbPubKeyBlobRes, DWORD * err_in_add);
DWORD FKCCreateEKE (LPTOKEN_CONTAINER pFKC, LPBYTE pData, LPBYTE kBVal, 
		    TRdrFkcEKEChallenge_id id, LPBYTE dataRes);

DWORD FKCSetDelta_e(LPTOKEN_CONTAINER pFKC, LPBYTE pData);

/*********************************************************
*       TOKEN SIGNATURE FUNCS
**********************************************************/
extern BYTE PublicHeaders[5][0x24];
DWORD FKCCreateTContainer(LPTOKEN_CONTAINER psRootKeys, BOOL isNew );

/*  HSM - CSP */

/*********************************************************
*       TOKEN EXCHANGE FUNCS
**********************************************************/
/*  TOKEN */
DWORD isInCurve(LPTOKEN_CONTAINER pFkc, BYTE *blob);
void makePublicBlob (LPTOKEN_CONTAINER pFkc, BYTE * blob, BYTE *PointX, BYTE *PointY) ;
void makePointFromBlob (BYTE *PointX, BYTE *PointY,BYTE * blob);

/*********************************************************
*       TOKEN SUPPORT FUNCS
**********************************************************/
DWORD CreatePublicKeyBlob(HCRYPTKEY   hKeyPair, DWORD* pdwBlobLen, LPBYTE* ppbKeyBlob);
DWORD SetPublicKeyBlob(TOKEN_CONTAINER* pTKN);
DWORD FKCCreateEKEVerify(TRdrFkcEKEChallenge_id id, LPTOKEN_CONTAINER pTKN,LPBYTE pbData,
			 TCHAR * contname, TCHAR * frname);

#ifdef __cplusplus
}
#endif

#endif /* _TOKEN_H_INCLUDED */
