/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/****
 * $Id: fkchdimg.c 82960 2012-11-22 12:49:01Z borodin $
 *
 *       (READER).
 *
 *   /      (FAT12).
 *
 *       FAT12.
 *
 * : fkchdimg_*
 *
 ****/

#include "fkchdimgprj.h" /*+ Project (READER/FAT12) include.
     include    (READER/FAT12). +*/

/*++++
 *           Windows.
 ++++*/
TSupErr fkchdimg_os_error( void )
/*+
 * :   Windows  .
 +*/
{
#if defined _WIN32
    DWORD w = GetLastError();
    SetLastError( 0 );
    switch( w )
    {
	/*+ 0 -> SUP_ERR_NO +*/
	case 0:
	    return SUP_ERR_NO;
	/*+ ERROR_FILE_NOT_FOUND -> RDR_ERR_FILE_NOT_FOUND +*/
	case ERROR_PATH_NOT_FOUND:
	case ERROR_FILE_NOT_FOUND:
	    return RDR_ERR_FILE_NOT_FOUND;
	/*+ ERROR_WRONG_DISK -> RDR_ERR_ANOTHER_MEDIA +*/
	case ERROR_WRONG_DISK:
	    return RDR_ERR_ANOTHER_MEDIA;
	/*+ ERROR_NOT_ENOUGH_MEMORY -> SUP_ERR_MEMORY +*/
	case ERROR_NOT_ENOUGH_MEMORY:
	    return SUP_ERR_MEMORY;
	/*+ ERROR_WRITE_PROTECT -> RDR_ERR_WRITE_PROTECT +*/
	case ERROR_WRITE_PROTECT:
	    return RDR_ERR_WRITE_PROTECT;
	/*+ ERROR_REQUEST_ABORTED, ERROR_NOT_READY -> RDR_ERR_NO_CARRIER +*/
	case ERROR_REQUEST_ABORTED:
	    return SUP_ERR_CANCEL;
	case ERROR_INVALID_HANDLE:
	case ERROR_NOT_READY:
	    return RDR_ERR_NO_CARRIER;
	/*+ ERROR_INVALID_DRIVE, ERROR_ACCESS_DENIED, ERROR_SHARING_VIOLATION
	ERROR_LOCK_VIOLATION, ERROR_DRIVE_LOCKED, ERROR_BUSY ->
	SUP_ERR_CONNECT +*/
	case ERROR_INVALID_DRIVE:
	case ERROR_ACCESS_DENIED:
	case ERROR_SHARING_VIOLATION:
	case ERROR_LOCK_VIOLATION:
	case ERROR_DRIVE_LOCKED:
	case ERROR_BUSY:
	    return SUP_ERR_CONNECT;
	case ERROR_FILE_INVALID:
	    return RDR_ERR_MEDIA_CHANGED;
	case ERROR_DISK_FULL:
	case ERROR_HANDLE_DISK_FULL:
	    return RDR_ERR_FULL;
	case ERROR_ALREADY_EXISTS:
	case ERROR_FILE_EXISTS:
	    return RDR_ERR_FILE_EXIST;
	case ERROR_INVALID_NAME:
	    return SUP_ERR_PARAM;
    }
    /*+ otherwise  -> RDR_ERR_INVALID_MEDIA+*/
    return RDR_ERR_INVALID_MEDIA;
#else /* _WIN32 */
    switch( errno )
    {
      /*+ 0 - SUP_ERR_NO +*/
    case 0:
      return SUP_ERR_NO;
      
      /*+ ENOMEM, ECONTR, EINVMEM - SUP_ERR_MEMORY +*/
    case ENOMEM:
#ifndef UNIX
    case ECONTR:
    case EINVMEM:
#endif /* UNIX */
      return SUP_ERR_MEMORY;
      
      /*+ ENOFILE, ENOPATH, EACCES, ENOTSAM, ENOENT - RDR_ERR_NO_CARRIER +*/
#ifdef UNIX
    case ENOENT:
    case ENOTDIR:
    case EISDIR:
#else /* UNIX */
    case ENOFILE:
    case ENOPATH:
    case ENOTSAM:
#endif /* UNIX */
    case EACCES:
      return RDR_ERR_NO_CARRIER;
      
      /*+ EINVDRV, EINVACC - SUP_ERR_CONNECT +*/
#ifdef UNIX
    case EMFILE:
    case ENOSPC:
    case ENFILE:
#else /* UNIX */  
    case EINVDRV:
    case EINVACC:
#endif /* UNIX */
      return SUP_ERR_CONNECT;
    }
    return RDR_ERR_INVALID_MEDIA;
    /*+ otherwise  -> RDR_ERR_INVALID_MEDIA+*/
#endif /* _WIN32 */
}

/*+ end of file: $Id: fkchdimg.c 82960 2012-11-22 12:49:01Z borodin $ +*/
