/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 71878 $
 * \date $Date: 2011-10-22 17:53:50 +0400 (Сбт, 22 Окт 2011) $
 * \author $Author: dim $
 * \brief    
 */

#include "fkchdimgprj.h"

static DWORD srtOIDtoDWORD(const char * pszKeyOID);

/*todo*/
TSupErr fkchdimg_get_auth_type ( 
    TSupSysContext *context, 
    TSupSysInfo *info )
{
    TFKCHDImgContext * ctx = (TFKCHDImgContext*)context;
    TReaderInfoAuthType * teke = (TReaderInfoAuthType *)info;
    TSupErr code = 0;

    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    SUPSYS_PRE_INFO( info, TReaderInfoAuthType );

    code = init_read(ctx);
    if (code) return code;

    //TODO:        , if( state < RDR_STATE_FOLDER ) ctx = ctx->cardctx;
    if (ctx->cont.pbSaltPublicBlob && ctx->names.RealName && (_tcslen(ctx->names.RealName)>0)) 
    {
	TRdrInfoAuthTypeEKE * tEkEPart = P2CH(TRdrInfoAuthTypeEKE,teke->authType);
	SUPSYS_PRE_WRITE_PTRS( tEkEPart, sizeof(TReaderInfoPasswdInfo));

	tEkEPart->type = RDR_LOGIN_INFO_EKE;
	if (ctx->names.FriendlyName) {
	    _tcscpy(tEkEPart->tFriendlyName,ctx->names.FriendlyName);
	} else {
	    _tcscpy(tEkEPart->tFriendlyName,_TEXT("\0"));
	}
	tEkEPart->bEnableDH = (ctx->cont.dwKeySpec==AT_KEYEXCHANGE);

	makeCounters(&(tEkEPart->c), &(ctx->cont.C));
	tEkEPart->uiIDg = srtOIDtoDWORD((char*)ctx->cont.pszKeyOID);
	makePointFromBlob(tEkEPart->uQs.x, tEkEPart->uQs.y, ctx->cont.pbSaltPublicBlob);
    } else {
	TReaderInfoPasswdInfo * passwd_info = (TReaderInfoPasswdInfo*)teke->authType;
	SUPSYS_PRE_WRITE_PTRS( passwd_info, sizeof(TReaderInfoPasswdInfo) );

	passwd_info->type = RDR_LOGIN_INFO_PASSWD;
	passwd_info->min_length = 1;
	passwd_info->max_length = 8;
    }
    return SUP_ERR_NO;
}

static DWORD srtOIDtoDWORD(const char * pszKeyOID) {
    DWORD oid = RDR_FKC_IDG_CP_OPTIONAL_PARAMSET;

    if (pszKeyOID) {
	if ((!strcmp(pszKeyOID,RDR_FKC_IDG_CP_A_OID_EXCH))||
	    (!strcmp(pszKeyOID,RDR_FKC_IDG_CP_A_OID_SIGN))) {
		oid = RDR_FKC_IDG_CP_A_PARAMSET;
	}
	if (!strcmp(pszKeyOID,RDR_FKC_IDG_CP_B_OID_SIGN)) {
		oid = RDR_FKC_IDG_CP_B_PARAMSET;
	}
	if ((!strcmp(pszKeyOID,RDR_FKC_IDG_CP_C_OID_EXCH))||
	    (!strcmp(pszKeyOID,RDR_FKC_IDG_CP_C_OID_SIGN))) {
		oid = RDR_FKC_IDG_CP_C_PARAMSET;
	}
    }
    return oid;
}

static DWORD makeDWORD2BE(DWORD be) 
{
    return ((be&0xFF000000)>>24)|((be&0xFF0000)>>8)|((be&0xFF00)<<8)|((be&0xFF)<<24);
}

void makeCounters(TRdrFkcInfoCounters *dest, COUNTS *src)
{
    (*dest)[TRIFc_EKE] = makeDWORD2BE(src->c_eke);
    (*dest)[TRIFc_Sign] = makeDWORD2BE(src->c_sig);
    (*dest)[TRIFc_DH] = makeDWORD2BE(src->c_dh);
    (*dest)[TRIFc_fail] = makeDWORD2BE(src->c_fls);
    (*dest)[TRIFc_cfail] = makeDWORD2BE(src->c_seqfls);
}
