/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

#include "fkchdimgprj.h" /* Project (READER/FAT12) include.
     include    (READER/FAT12). */

/*!
 * \ingroup fkchdimg_info_general
 * \brief    .
 * \return  
 */
TSupErr fkchdimg_context_dup( 
    TSupSysContext *context, 
    TSupSysInfo *info )
{
    TSupSysInfoContextDup *inf = (TSupSysInfoContextDup*)info;
    TFKCHDImgContext *dest;
    TFKCHDImgContext *src = (TFKCHDImgContext*)context;

    /*   . */
    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    SUPSYS_PRE_INFO( info, TSupSysInfoContextDup );

    dest = malloc( sizeof( *dest ) );
    if( dest == NULL )
	return SUP_ERR_MEMORY;
    memset( dest, 0, sizeof( *dest ) );	// TODO:    
    dest->path = NULL;
    if( src->path )
    {
	dest->path = malloc( ( _tcslen( src->path ) + 1 ) * sizeof( TCHAR ) );
	if( !dest->path )
	{
	    free( dest );
	    return SUP_ERR_MEMORY;
	}
	_tcscpy( dest->path, src->path );
    }
    dest->volume_label = NULL;
    dest->file_name = NULL;
    dest->folder = NULL;
    _tcscpy( dest->connect, src->connect );
    dest->cardctx = src->cardctx;
    //,  ,    TOKEN_CONTAINER.
    memset(&dest->cont,0,sizeof(TOKEN_CONTAINER));

    support_mutex_init(&dest->filelock);

#ifdef UNIX
    dest->handle = NULL;
#else /* UNIX */
    dest->access = 0;
    dest->handle = INVALID_HANDLE_VALUE;
#endif /* UNIX */
    inf->dest_context = dest;
    return SUP_ERR_NO;
}

