/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 64132 $
 * \date $Date: 2010-09-24 17:06:37 +0400 (Птн, 24 Сен 2010) $
 * \author $Author: dim $
 * \brief   .
 */

#include "fkchdimgprj.h"

/*!
 * \ingroup fkchdimg_fun_reader
 * \brief   .
 * \param context [in]  . 
 * \param info [in/out]  #TReaderInfoFolderClear
 * \sa TReaderInfoFolderClear, READER_FUN_FOLDER_OPEN, 
 *  TSupSysFunction, fkchdimg_folder_close, fkchdimg_folder_open
 *  #rdr_folder_open, #rdr_folder_close, #rdr_folder_clear
 */
TSupErr fkchdimg_folder_clear( 
    TSupSysContext *context, 
    TSupSysInfo *info )
{
    TReaderInfoFolderClear *inf = (TReaderInfoFolderClear*)info;
    TCHAR *path;
    TFKCHDImgContext *ctx = (TFKCHDImgContext*)context;
    TCHAR keysname [NAME_LENTH+1];
    HCRYPTPROV hFKC;

    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    SUPSYS_PRE_INFO( info, TReaderInfoFolderClear );

    inf->size_of = sizeof( TReaderInfoFolderOpen );

    if( !ctx->folder )
	return SUP_ERR_NO;
    FKCReleaseTContainer( &ctx->cont);
#if defined UNIX
    _tcscpy(keysname,_TEXT("\\\\.\\hdimage\\"));
#else
    _tcscpy(keysname,_TEXT("\\\\.\\REGISTRY\\"));
#endif /* UNIX */
    _tcscat(keysname,ctx->folder);
    CryptAcquireContext(&hFKC, keysname, ctx->cardctx->provname, PROV_GOST_2001_DH, CRYPT_DELETEKEYSET);

    fkchdimg_infofile_clear (ctx );
    fkchdimg_headerfile_clear (ctx);
    close_lock(ctx);

    path = (TCHAR*)malloc( ( _tcslen( ctx->folder ) 
	+ 2 + _tcslen( ctx->path )
	+ 1 ) * sizeof( TCHAR ) );
    if( path == NULL )
	return SUP_ERR_MEMORY;
    _tcscpy( path, ctx->path );
    _tcscat( path, ctx->folder );
#ifdef UNIX
    if( _trmdir( path ) )
#else /* UNIX */
    if( !RemoveDirectory( path ) )
#endif /* UNIX */
    {
	TSupErr code = fkchdimg_os_error();
	if (path) {
	    free( path );
	}
	if (ctx->folder) {
	    free(ctx->folder);
	    ctx->folder = NULL;
	}
	return code;
    }
    if (ctx->folder) {
	free(ctx->folder);
	ctx->folder = NULL;
    }
    free(path);

    return SUP_ERR_NO;
}
/* end of file: $Id: fkchdimgdclr.c 64132 2010-09-24 13:06:37Z dim $ */
