/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 75485 $
 * \date $Date: 2012-03-04 15:41:26 +0300 (Вск, 04 Мар 2012) $
 * \author $Author: dim $
 * \brief       .
 */

#include "fkchdimgprj.h"

static const TCHAR LOCAL_PATH[] = _TEXT( "\\protected_local" );
static const TCHAR GLOBAL_PATH[] = _TEXT( "\\protected_global" );

#define FKCIMGADD (_TEXT("/CPFKC"))
#define FKCIMGDLM (_TEXT("/"))

TSupErr hdimage_path_default( TCHAR **str, int machine )
{
    size_t length = 0;
    TCHAR *path;
    const TCHAR *p;
    TSupErr code;
    int exist;

    if( machine & 1 )
	p = GLOBAL_PATH;
    else
	p = LOCAL_PATH;
    code = support_path2dir( p, &length, NULL );
    if( code )
	return code;
    path = malloc( length*sizeof(TCHAR) + sizeof(FKCIMGADD) + sizeof(FKCIMGDLM) );
    if( path == NULL )
	return SUP_ERR_MEMORY;
    code = support_path2dir( p, &length, path );
    if( code )
    {
	free( path );
	return code;
    }
    _tcscat( path, FKCIMGADD );
    exist = fkchdimg_is_dir_exist( path, NULL, NULL);
    if( exist == DIR_INVALID )
    {
	free( path );
	return RDR_ERR_FILE_NOT_FOUND;
    }
    if( !exist )
    {
	// TODO:   
#     ifdef UNIX
	if( _tmkdir( path, (machine&1)?S_IRWXG|S_IRWXU:S_IRWXU ) )
#     else
	if( !CreateDirectory( path, NULL ) )	// TODO:   
#     endif /* UNIX */
	{
	    code = fkchdimg_os_error();
	    free( path );
	    return code;
	}
    }
#ifdef UNIX
    if (!(machine & 1))
    {
	code = support_thread_actualize_uids();
	if (code)
	{
	    free(path);
	    return code;
	}
        if (chmod(path,S_IRWXU)) {
	    code = fkchdimg_os_error();
	    support_thread_deactualize_uids();
	    free( path );
	    return code;
	}
	support_thread_deactualize_uids();
    }
#endif /* UNIX */
    _tcscat( path, FKCIMGDLM );
    *str = path;

    return SUP_ERR_NO;
}
/* end of file: $Id: fkchdimgdef.c 75485 2012-03-04 12:41:26Z dim $ */
