/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 64132 $
 * \date $Date: 2010-09-24 17:06:37 +0400 (Птн, 24 Сен 2010) $
 * \author $Author: dim $
 * \brief    -
 */

#include "fkchdimgprj.h"

TSupErr fkchdimg_dh ( 
    TSupSysContext *context, 
    TSupSysInfo *info )
{
    DWORD err = SUP_ERR_NO;
    TReaderFkcAgreeInfo * aI = (TReaderFkcAgreeInfo *)info;
    TFKCHDImgContext *ctx = (TFKCHDImgContext*)context;

    HCRYPTKEY hAgreeKeyFKC=0;
    LPBYTE pbPubKeyBlobToFKC=NULL;
    LPBYTE pbPubKeyBlobFromFKC=NULL;
    DWORD dwBlobLen = ctx->cont.dwPubBlobLen;

    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    SUPSYS_PRE_INFO( info, TReaderFkcAgreeInfo );
    SUPSYS_PRE_READ_PTRS(aI->toFKC.uQalpha->x, SECRET_KEY_LEN);
    SUPSYS_PRE_READ_PTRS(aI->toFKC.uQalpha->y, SECRET_KEY_LEN);
    SUPSYS_PRE_WRITE_PTRS(aI->fromFKC.uK2->x, SECRET_KEY_LEN);
    SUPSYS_PRE_WRITE_PTRS(aI->fromFKC.uK2->y, SECRET_KEY_LEN);

    err = init_read(ctx);
    if (err) goto done;

    if(isCNULL(ctx)) 
    {
	err= SUP_ERR_CANCEL;
	goto done;
    }
    if (ctx->cont.dwKeySpec!=AT_KEYEXCHANGE)
    {
	err= SUP_ERR_CANCEL;
	goto done;
    }

    if (aI->toFKC.IsNewTr == FKC_TRANSACTION_IS_NEW) {
	ctx->cont.curmask = FKC_TRANS_SET_ZERO;
	ctx->cont.curtrid = aI->toFKC.TrId;
    } else {
	if (ctx->cont.curtrid) {
	    if (ctx->cont.curtrid != aI->toFKC.TrId) {
		err = RDR_ERR_FKC_TRANSACTION;
		goto done;
	    }
	}
    }

    if( !ctx->auth) {
	err = RDR_ERR_FKC_NEED_CONT_AUTH;
	goto done;
    }

    pbPubKeyBlobToFKC = malloc(dwBlobLen);
    if(!pbPubKeyBlobToFKC) {
	err = SUP_ERR_MEMORY;
	pbPubKeyBlobToFKC = NULL;
	goto done;
    }

    makePublicBlob(&ctx->cont, pbPubKeyBlobToFKC, (LPBYTE)aI->toFKC.uQalpha->x, (LPBYTE)aI->toFKC.uQalpha->y);

    pbPubKeyBlobFromFKC = malloc(dwBlobLen);
    if(!pbPubKeyBlobFromFKC) {
	err = SUP_ERR_MEMORY;
	pbPubKeyBlobFromFKC = NULL;
	goto done;
    }

    /*		d2, Qs+aQ1   */
    if(!CryptImportKey( ctx->cont.hContainer,pbPubKeyBlobToFKC,dwBlobLen,
	ctx->cont.hKeyPair,0,&hAgreeKeyFKC))
    {
	err = GetLastError();
	goto done; 
    }

    /*CALG_PRO_AGREEDKEY_DH = a621*/
    if(!CryptExportKey(hAgreeKeyFKC, 0, PUBLICKEYBLOB, 0, 
	pbPubKeyBlobFromFKC , &dwBlobLen))
    {
	err = GetLastError();
	goto done; 
    }

    makePointFromBlob(aI->fromFKC.uK2->x,aI->fromFKC.uK2->y,pbPubKeyBlobFromFKC);
    ctx->cont.C.c_dh--;

done: 

    if (hAgreeKeyFKC) CryptDestroyKey(hAgreeKeyFKC);
    hAgreeKeyFKC = 0;
    if (pbPubKeyBlobToFKC) free(pbPubKeyBlobToFKC);
    if (pbPubKeyBlobFromFKC) free(pbPubKeyBlobFromFKC);
    return err;
}

BOOL isCNULL (TFKCHDImgContext *ctx) 
{
    return (!ctx->cont.C.c_dh) || (!ctx->cont.C.c_eke) || (!ctx->cont.C.c_fls) || 
	(!ctx->cont.C.c_seqfls) || (!ctx->cont.C.c_sig);
}
