/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 67475 $
 * \date $Date: 2011-04-14 17:10:23 +0400 (Чтв, 14 Апр 2011) $
 * \author $Author: borodin $
 * \brief   .
 */

#include "fkchdimgprj.h"

static TSupErr FirstInitContCtx (TFKCHDImgContext * ctx, TCHAR *name, BOOL enableDH, DWORD idG)
{
    BOOL isRelease;

    memset(&ctx->cont,0,sizeof(TOKEN_CONTAINER));
    ctx->cont.C.c_dh = C_DH;
    ctx->cont.C.c_sig =C_SGN;
    ctx->cont.C.c_eke =C_EKE;
    ctx->cont.C.c_fls =C_FALSE;
    ctx->cont.C.c_seqfls =C_SEQ_FALSE;
    ctx->cont.abilityInitKeys = ABILITY_INIT_KEY;
    ctx->cont.abilityWriteKeys = ABILITY_WRITE_KEY;
    if(!CSPVersion(&isRelease)) 
	ctx->cont.abilityWriteKeys = !isRelease;
    ctx->cont.disablePass = DISABLE_PASSWD_CARD;
    ctx->cont.defaultPass[0] = _TEXT('\000');
    ctx->names.FriendlyName = NULL;
    ctx->cont.isnew_fofrname = TRUE;
    memset(ctx->cont.syncro,0,SECRET_KEY_LEN);

    ctx->cont.pbPWPublicKeyBlob = (LPBYTE)malloc(100);
    if (!ctx->cont.pbPWPublicKeyBlob)
	return SUP_ERR_MEMORY;

    memset(ctx->cont.pbPWPublicKeyBlob, 0xff, 100);

    _tcscpy(ctx->names.RealName,name);
    switch (idG) 
	{
	case RDR_FKC_IDG_CP_OPTIONAL_PARAMSET:
	case RDR_FKC_IDG_CP_A_PARAMSET:
	    if (enableDH)
		strcpy((char*)ctx->cont.pszKeyOID,RDR_FKC_IDG_CP_A_OID_EXCH);
	    else 
		strcpy((char*)ctx->cont.pszKeyOID,RDR_FKC_IDG_CP_A_OID_SIGN);
	    break;
	case RDR_FKC_IDG_CP_B_PARAMSET:
	    if (enableDH)
	    {
		free (ctx->cont.pbPWPublicKeyBlob);
		return SUP_ERR_PARAM;
	    }
	    else 
		strcpy((char*)ctx->cont.pszKeyOID,RDR_FKC_IDG_CP_B_OID_SIGN);
	    break;
	case RDR_FKC_IDG_CP_C_PARAMSET:
	    if (enableDH)
		strcpy((char*)ctx->cont.pszKeyOID,RDR_FKC_IDG_CP_C_OID_EXCH);
	    else 
		strcpy((char*)ctx->cont.pszKeyOID,RDR_FKC_IDG_CP_C_OID_SIGN);
	    break;
	default:
	
	    free (ctx->cont.pbPWPublicKeyBlob);
	    return SUP_ERR_PARAM;
	}
    return SUP_ERR_NO;
}


/*!
 * \ingroup fkchdimg_fun_reader
 * \brief   .
 * \param context [in]  . 
 * \param info [in/out]  #TReaderInfoFolderOpen
 * \sa TReaderInfoFolderOpen, READER_FUN_FOLDER_OPEN, 
 *  TSupSysFunction, fkchdimg_folder_close, #rdr_folder_open, #rdr_folder_close
 */
TSupErr fkchdimg_folder_open_ex( 
    TSupSysContext *context, 
    TSupSysInfo *info )
{
    TSupErr ret;
    TReaderInfoFolderOpenEx *inf = (TReaderInfoFolderOpenEx*)info;
    TFKCHDImgContext *ctx = (TFKCHDImgContext*)context;
    TrdrInfoFolderOpenEx_fkc_param * fkcpar;
    SUPSYS_PRE_INFO( info, TReaderInfoFolderOpen );
    SUPSYS_PRE_INFO( info, TReaderInfoFolderOpenEx );

    ret = fkchdimg_folder_open(context, info);
    if (ret!=SUP_ERR_NO) return ret;

    fkcpar = P2CH(TrdrInfoFolderOpenEx_fkc_param,(TRdrInfoFolderOpenEx_param *)inf->folderParam);
    //TODO:  ,    ZeroMemory(&ctx->cont,sizeof(TOKEN_CONTAINER));

    if (inf->mode->o_creat) {
	ret = FirstInitContCtx (ctx, inf->name.text, 
	    fkcpar->bEnableDH, fkcpar->uiIDg);

	if (ret!=SUP_ERR_NO) 	
	{
	    goto done;
	}
	ctx->cont.opened = TRUE;
	ctx->cont.dwKeySpec = (fkcpar->bEnableDH)?AT_KEYEXCHANGE:AT_SIGNATURE;
	ret = fkchdimg_infofile_write(ctx);
	if (ret!=SUP_ERR_NO) 
	{
	    goto done;
	}
	ret = IntFKCTContainer(ctx, ctx->names.RealName, TRUE);
	if (ret!=SUP_ERR_NO) {
	    ret = SUP_ERR_CANCEL;
	    goto done;
	}
    } else {
	ret = SUP_ERR_CANCEL;
	goto done;
    }

done:
    if (ret!=SUP_ERR_NO) {
	if (inf->mode->o_creat) {
	    TReaderInfoFolderClear fclr;
	    memset(&fclr, 0, sizeof(fclr));
	    fclr.size_of = sizeof(TReaderInfoFolderClear);
	    fkchdimg_folder_clear(context,&fclr);
	} else {
	    TReaderInfoFolderClose fcl;
	    fkchdimg_folder_close(context,&fcl);
	}
    }
    return ret;
}

DWORD IntFKCTContainer(TFKCHDImgContext *ctx, TCHAR *name, BOOL isNew)
{
    HCRYPTPROV	hFKC=0;
    DWORD err = 0,dwControl=0;

#if defined UNIX
    _tcscpy(ctx->cont.TokenName, _TEXT("\\\\.\\hdimage\\"));
#else
    _tcscpy(ctx->cont.TokenName, _TEXT("\\\\.\\REGISTRY\\"));
#endif /* UNIX */
    _tcscat(ctx->cont.TokenName, name);

    if (isNew) {
	dwControl = CRYPT_NEWKEYSET;
    } else {
	dwControl = 0;
    }
    if(!CryptAcquireContext(&hFKC, (ctx->cont.TokenName), ctx->cardctx->provname, PROV_GOST_2001_DH, 
			    dwControl | CRYPT_TOKEN_SHARED)) {
	err = GetLastError();
	goto done;
    }

    ctx->cont.hContainer = hFKC;
    ctx->cont.dwPubBlobLen = PUBLICBLOBLEN;
            
    if(isNew) {
	if(!CryptSetProvParam( ctx->cont.hContainer,PP_HASHOID,(LPBYTE)szOID_GostR3411_94_CryptoProParamSet,0)){err = GetLastError();};
	if(err) return err;
	    
	if(!CryptSetProvParam( ctx->cont.hContainer,PP_CIPHEROID,(LPBYTE)szOID_Gost28147_89_CryptoPro_C_ParamSet,0)){err = GetLastError();};
	if(err) return err;
	    
	if (ctx->cont.dwKeySpec == AT_KEYEXCHANGE) {
	    if(!CryptSetProvParam( ctx->cont.hContainer,PP_DHOID,(LPBYTE)ctx->cont.pszKeyOID,0)){err = GetLastError();};
	    if(err) return err;
	} else if (ctx->cont.dwKeySpec == AT_SIGNATURE) {
	    if(!CryptSetProvParam( ctx->cont.hContainer,PP_SIGNATUREOID,(LPBYTE)ctx->cont.pszKeyOID,0)){err = GetLastError();};
	    if(err) return err;
	}

    }

    err = FKCCreateTContainer(&ctx->cont, isNew);

done:
    return err;
}
