/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 94046 $
 * \date $Date: 2013-09-07 10:52:17 +0400 (Сбт, 07 Сен 2013) $
 * \author $Author: raa $
 * \brief    
 */

#include "fkchdimgprj.h"

TSupErr fkchdimg_get_param ( 
    TSupSysContext *context, 
    TSupSysInfo *info )
{
    TRdrFkcFolderEnumParam paramID;
    TRdrFolderParamValue * pv;
    TFKCHDImgContext * ctx;

    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    //SUPSYS_PRE_STATE_GE( context, RDR_STATE_CARRIER );
    pv = ((TReaderInfoFolderParamGet *)info)->paramValue;
    ctx = (TFKCHDImgContext*)context;

    paramID = ((TReaderInfoFolderParamGet *)info)->paramID;
    switch (paramID) 
    {
    case TCEP_password:
	{
    	    TRdrFkcFolderPasswordParam * value = P2CH(TRdrFkcFolderPasswordParam,pv);
	    if (!ctx->cardctx->cont.disablePass) {
		_tcscpy(value->tPassword, ctx->cardctx->cont.defaultPass);
	    } 
	    else 
	    {
		_tcscpy(value->tPassword, _TEXT(""));
	    }
	}
	break;
    case TCEP_disablePassword:
	{
	    TRdrFkcFolderDisablePasswordParam *value = P2CH(TRdrFkcFolderDisablePasswordParam,pv);
	    value->bDisablePassword = ctx->cardctx->cont.disablePass;
	}
	break;
    case TCEP_newKeys:
	{
	    TRdrFkcFolderNewKeysParam *value = P2CH(TRdrFkcFolderNewKeysParam,pv);
	    value->bEnableInitKeys = ctx->cardctx->cont.abilityInitKeys;
	    value->bEnableSetKeys = ctx->cardctx->cont.abilityWriteKeys;
	}
	break;
    case TCEP_counters:
	{
	    TRdrFkcFolderCountersParam *value = P2CH(TRdrFkcFolderCountersParam, pv);
	    TFKCHDImgContext * realctx = ctx->folder ? ctx /*   NULL- */ : ctx->cardctx;
	    makeCounters(&value->initCounters, &realctx->cont.C);
	}
	break;
    case TCEP_oid0:
	{
	    TRdrFkcFolderOID0Param *value = P2CH(TRdrFkcFolderOID0Param,pv);
	    SUPSYS_PRE_WRITE_PTRS(value->tOID0, strlen((LPCSTR)ctx->cardctx->cont.pszKeyOID)+1);
	    _ascii2cpy(value->tOID0,(LPCSTR)ctx->cardctx->cont.pszKeyOID);
	}
	break;
    default:
	return SUP_ERR_PARAM;
    }
    return SUP_ERR_NO;
}
