/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

#if !defined( _READER_FAT12_FAT12INF_H )
#define _READER_FAT12_FAT12INF_H /*+   . +*/

#include "reader/rdr.h" /*+ Project (READER) include.
        . +*/
#include "reader.kit/reader.h" /*+ Project (READER/RDR) include.
         . +*/

#if defined( __cplusplus )
extern "C" {
#endif /* defined( __cplusplus ) */

#if defined( _WIN32 )
#   ifndef UNDER_CE
typedef struct TFat12ConnectEnum_
{
    TCHAR *drive_strings;
    TCHAR *cur;
} TFat12ConnectEnum;
#   else
typedef struct TFat12ConnectEnum_
{
    HANDLE hSearch;         // Search handle returned by FindFirstFile
    WIN32_FIND_DATA  fd;    // Data structure describes the file found
} TFat12ConnectEnum;
#   endif

#elif defined UNIX
  typedef struct TFat12ConnectEnumElem_ TFat12ConnectEnumElem;
  struct TFat12ConnectEnumElem_
  {
    TCHAR *connect_str;
    TFat12ConnectEnumElem *next;
  };
  
  typedef struct TFat12ConnectEnum_
  {
    TFat12ConnectEnumElem *drive_strings;
    TFat12ConnectEnumElem *cur;
  } TFat12ConnectEnum;
#endif /* _WIN32 */

TSupErr fkchdimg_info_instance(
    TSupSysContext *context, 
    TSupSysInfo *info );

TSupErr fkchdimg_info_ids(
    TSupSysContext *context, 
    TSupSysInfo *info );

TSupErr fkchdimg_info_system_flag(
    TSupSysContext *context, TSupSysInfo* );

TSupErr fkchdimg_register( 
    TSupSysContext *context, TSupSysInfo* );

TSupErr fkchdimg_unregister( 
    TSupSysContext *context, TSupSysInfo* );

TSupErr fkchdimg_lock( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_unlock( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_local_machine( 
    void *context, 
    TSupSysInfo *info );

TSupErr fkchdimg_context_dup( 
    TSupSysContext *context, TSupSysInfo* );

TSupErr fkchdimg_context_free( 
    TSupSysContext *context, TSupSysInfo* );

/*   . */
TSupErr fkchdimg_open( 
    TSupSysContext *context, TSupSysInfo *info );

/*    . */
TSupErr fkchdimg_write( 
    TSupSysContext *context, TSupSysInfo *info );

/*    . */
TSupErr fkchdimg_read( 
    TSupSysContext *context, TSupSysInfo *info );

/*   . */
TSupErr fkchdimg_close( 
    TSupSysContext *context, TSupSysInfo *info );

/*    . */
TSupErr fkchdimg_length(
    TSupSysContext *context, TSupSysInfo *info );

/*   . */
TSupErr fkchdimg_unlink( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_info_folder_enum_open( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_info_folder_enum_next( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_info_folder_enum_close( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_folder_open( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_folder_close( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_folder_clear( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_chsize( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_get_param( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_set_param( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_get_auth_type( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_folder_open_ex( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_eke_auth_challenge( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_eke_auth_change ( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_friendly_name_set( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_new_key( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_login ( 
    TSupSysContext *context, 
    TSupSysInfo *info );

TSupErr fkchdimg_key_set( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_signature( 
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_signature_debug (
    TSupSysContext *context, TSupSysInfo *info );

TSupErr fkchdimg_dh( 
    TSupSysContext *context, TSupSysInfo *info );

#if defined( __cplusplus )
}
#endif /* defined( __cplusplus ) */

#endif /* !defined( _READER_FAT12_FAT12INF_H ) */
/*+ end of file:$Id: fkchdimginf.h 75485 2012-03-04 12:41:26Z dim $.h +*/
