/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

#if !defined( _READER_FAT12_FAT12INT_H )
#define _READER_FAT12_FAT12INT_H /*+   . +*/

#include <tchar.h> /*+ Windows or project (READER) windows include. 
        . +*/

#include "reader/rdr.h" /*+ Project (READER) include.
        . +*/
#include "reader.kit/reader.h" /*+ Project (READER) include. 
         . +*/

#include "Token.h"

#define DIR_NOTEXIST 0
#define DIR_EXIST 1
#define DIR_INVALID 2

#if defined( __cplusplus )
extern "C" {
#endif /* defined( __cplusplus ) */

#if !defined( _RESOURCE )
/*+  . +*/
extern TSupResourceInstance FKCHDIMG_RESOURCE;
#else
#define FKCHDIMG_RESOURCE FKCHDIMG_DLL_INSTANCE
extern HINSTANCE FKCHDIMG_DLL_INSTANCE;
#endif /* !defined( _RESOURCE ) */

typedef struct TFKCHDIHiddenFileInfo_ {
    TCHAR RealName[NAME_LENTH+1];
    TCHAR *FriendlyName;
} TFKCHDIHiddenFileInfo;

typedef struct TFKCHDImgContext_ TFKCHDImgContext;

/*+       fkchdimg. +*/
struct TFKCHDImgContext_ {
    TCHAR *path; /*+  . 
	 A: "A",  B: "B",  removable  . +*/
    unsigned long volume_serial;
    TCHAR *volume_label;
    TCHAR *file_name; /*!<   . */
    TCHAR *folder;
    int machine;
    TSupSysENickname connect;
    TSupportMutex filelock;
#if defined _WIN32
    HANDLE handle;
    DWORD access; /*!<    . */
#else
    FILE *handle;
#endif /* _WIN32 */
    TFKCHDIHiddenFileInfo names;
    TOKEN_CONTAINER cont;
    TFKCHDImgContext * cardctx;
    BOOL auth;
    TCHAR * provname;
};

/*++++
 *           .
 ++++*/
TSupErr fkchdimg_os_error( void );

TSupErr create_lock (TCHAR* folder, TFKCHDImgContext *ctx);
TSupErr close_lock (TFKCHDImgContext *ctx);
TSupErr lock_lock (TFKCHDImgContext *ctx);
TSupErr unlock_lock (TFKCHDImgContext *ctx);

int fkchdimg_is_dir_exist( const TCHAR *path, const TCHAR * contname, const TCHAR * provname );

BOOL isCNULL (TFKCHDImgContext *ctx);
DWORD CSPVersion(BOOL *isrelease);
TSupErr init_read(TFKCHDImgContext *ctx );

TSupErr hdimage_path_default( TCHAR **str, int machine );

TSupErr fkchdimg_infofile_read (TFKCHDImgContext *ctx );

TSupErr fkchdimg_infofile_write (TFKCHDImgContext *ctx );

TSupErr fkchdimg_infofile_clear (TFKCHDImgContext *ctx );
TSupErr fkchdimg_headerfile_clear (TFKCHDImgContext *ctx );

DWORD IntFKCTContainer(TFKCHDImgContext *ctx, TCHAR *name, BOOL isNew);


// UECHDIMG

typedef struct TUECHDImgContext_ TUECHDImgContext;

/*+      uechdimg. +*/
struct TUECHDImgContext_ {
    char pin[9]; //    224 : 2
    BYTE file_id;
    BYTE * file;
    unsigned status;
    BYTE folder;    
    size_t file_length;
    TCHAR * path;
    TCHAR * key_blob_path;
    TCHAR * header_path;
    TCHAR * info_path;
    TCHAR * pin_path;
    TCHAR * pin_count_path;
    TCHAR * puk_path;
    TCHAR * puk_count_path;
    TCHAR * pin_need_path;
};

#define CF_NAME_SIZE 68
#define CF_HEAD2_SIZE 5120
#define CF_NAME2_SIZE 128
#define KEY_BLOB_PATH _TEXT("\\Config\\KeyDevices\\UECHDIMG\\Default\\Key_blob")
#define HEADER_PATH _TEXT("\\Config\\KeyDevices\\UECHDIMG\\Default\\header")
#define INFO_PATH _TEXT("\\Config\\KeyDevices\\UECHDIMG\\Default\\info")
#define PIN_PATH _TEXT("\\Config\\KeyDevices\\UECHDIMG\\Default\\pin")
#define PIN_COUNT_PATH _TEXT("\\Config\\KeyDevices\\UECHDIMG\\Default\\pin_count")
#define PIN_NEED_PATH _TEXT("\\Config\\KeyDevices\\UECHDIMG\\Default\\pin_need")
#define PUK_PATH _TEXT("\\Config\\KeyDevices\\UECHDIMG\\Default\\puk")
#define PUK_COUNT_PATH _TEXT("\\Config\\KeyDevices\\UECHDIMG\\Default\\puk_count")

#define KEY_BLOB_PATH_2 _TEXT("\\Config\\KeyDevices\\UECHDIMG2\\Default\\Key_blob")
#define HEADER_PATH_2 _TEXT("\\Config\\KeyDevices\\UECHDIMG2\\Default\\header")
#define INFO_PATH_2 _TEXT("\\Config\\KeyDevices\\UECHDIMG2\\Default\\info")
#define PIN_PATH_2 _TEXT("\\Config\\KeyDevices\\UECHDIMG2\\Default\\pin")
#define PIN_COUNT_PATH_2 _TEXT("\\Config\\KeyDevices\\UECHDIMG2\\Default\\pin_count")
#define PIN_NEED_PATH_2 _TEXT("\\Config\\KeyDevices\\UECHDIMG2\\Default\\pin_need")
#define PUK_PATH_2 _TEXT("\\Config\\KeyDevices\\UECHDIMG2\\Default\\puk")
#define PUK_COUNT_PATH_2 _TEXT("\\Config\\KeyDevices\\UECHDIMG2\\Default\\puk_count")

#define MAGIC_IMPORT_KEY_CONST "Crypto-Pro_UEC_Key_Import_Const123"
#define MAGIC_PIN "11111111"

#define UEC_PIN2 2
#define UEC_PUK 5

#define MAX_PIN_TRIES 3

#define AUTH_PHRASE ",   ()!"


#if defined( __cplusplus )
}
#endif /* defined( __cplusplus ) */

#endif /* !defined( _READER_FAT12_FAT12INT_H ) */
