/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/****
 * $Id: fkchdimgkchs.c 61208 2010-04-11 11:01:31Z dim $
 *
 *       (READER).
 *
 *   /      (FAT12).
 *
 *   /      .
 *    .
 *
 * : fkchdimg_write
 ****/

#include "fkchdimgprj.h"
#if defined(UNIX)
#include <unistd.h>
#endif /* UNIX */

#ifdef UNIX
static TSupErr set_file_size(FILE *handle, size_t size)
{
  if(!ftruncate(fileno(handle),size)) return SUP_ERR_NO;
  /* Shit, ftruncate didn't work, we need manual intervention */
  if(fseek(handle, size, SEEK_SET)==-1) return fkchdimg_os_error(); 

  return 0;
}
#else /* UNIX */
static TSupErr set_file_size(HANDLE handle, size_t size)
{
    SUPSYS_PRE( size <= MAXLONG );
    if( SetFilePointer( handle, (long)size, NULL, FILE_BEGIN ) 
	== INVALID_SET_FILE_POINTER )
	    return fkchdimg_os_error();
    if( !SetEndOfFile( handle ) )
	    return fkchdimg_os_error();

  return SUP_ERR_NO;
} 
#endif /* UNIX */

/*++++ 
 *    . 
 ++++*/
TSupErr fkchdimg_chsize( 
	TSupSysContext *context, 
	TSupSysInfo *info) 
{
    TSupErr code;
    TReaderInfoChSize *inf = (TReaderInfoChSize*)info;
    TFKCHDImgContext *ct = (TFKCHDImgContext*)context;

    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    SUPSYS_PRE_INFO( info, TReaderInfoChSize );

    inf->size_of = sizeof( TReaderInfoChSize );
#ifdef UNIX
    if( ct->handle == NULL )
#else
    if( ct->handle == INVALID_HANDLE_VALUE )
#endif
	return RDR_ERR_MEDIA_CHANGED;

    code = set_file_size(ct->handle, inf->length);
    if( code ) return code;

    return SUP_ERR_NO;
}
/*+ end of file: $Id: fkchdimgkchs.c 61208 2010-04-11 11:01:31Z dim $ +*/
