/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

#include "fkchdimgprj.h" /*+ Project (READER/FAT12) include.
     include    (READER/FAT12). +*/


/*++++ 
 *   . 
 ++++*/
TSupErr fkchdimg_close(TSupSysContext *context, TSupSysInfo *info)
{
    TReaderInfoClose *inf = (TReaderInfoClose*)info;
    TSupErr code=SUP_ERR_NO;
    TFKCHDImgContext *ct = (TFKCHDImgContext*)context;
  
    SUPSYS_PRE_INFO( info, TReaderInfoClose );
  
    inf->size_of = sizeof( TReaderInfoClose );
    if( context == NULL ) return SUP_ERR_NO;

#ifdef UNIX
    if( fclose( ct->handle ) ){
	code = fkchdimg_os_error();
	if( !code ) code=RDR_ERR_INVALID_MEDIA;
    }
    ct->handle = NULL;
#else /* UNIX */
    if( ct->handle != INVALID_HANDLE_VALUE )
    {
	FILETIME time1;
	FILETIME time2;
	SYSTEMTIME cur_time;
	unsigned int last_error_mode;
	last_error_mode = 0;
      
	GetSystemTime( &cur_time );
	SystemTimeToFileTime( &cur_time, &time2 );
	GetFileTime( ct->handle, &time1, NULL, NULL );
	if( ( ct->access & GENERIC_WRITE )
	    && !SetFileTime( ct->handle, &time1, &time2, &time2 ) ) {
	    code = fkchdimg_os_error();
	    if( code != RDR_ERR_MEDIA_CHANGED ) goto done;
	}
#ifndef UNDER_CE 
	last_error_mode = SetErrorMode( 0 );
#endif
	CloseHandle( ct->handle ); 
#ifndef UNDER_CE
	SetErrorMode( last_error_mode );
#endif
    }
done:
    ct->handle = INVALID_HANDLE_VALUE;
#endif /* UNIX */
    free( ct->file_name ); ct->file_name = NULL;
    unlock_lock(ct);
    return code;
}
