/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/****
 * $Id: fkchdimgklen.c 75485 2012-03-04 12:41:26Z dim $
 *
 *       (READER).
 *
 *   /      (FAT12).
 *
 *   /      .
 *    .
 *
 * : fkchdimg_length
 ****/

#include "fkchdimgprj.h" /*+ Project (READER/FAT12) include.
     include    (READER/FAT12). +*/

/*++++
 *    .
 ++++*/
TSupErr fkchdimg_length(TSupSysContext *context, TSupSysInfo *info)
{
    TReaderInfoLength *inf = (TReaderInfoLength*)info;
    TFKCHDImgContext *ct = (TFKCHDImgContext*)context;

#ifndef UNIX
    BY_HANDLE_FILE_INFORMATION finfo;
#endif /* UNIX */

    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    SUPSYS_PRE_INFO( info, TReaderInfoLength );

    inf->size_of = sizeof( TReaderInfoLength );
#ifdef UNIX
    if( fseek( ct->handle, 0, SEEK_END ) )
	return fkchdimg_os_error();
    inf->length = (size_t)ftell( ct->handle );
    if( inf->length == (size_t)-1 )
	return fkchdimg_os_error();
#else /* UNIX */
    if( !GetFileInformationByHandle( ct->handle, &finfo ) )
	return fkchdimg_os_error();
    inf->length = finfo.nFileSizeLow;
    if( finfo.nFileSizeHigh )
	inf->length = (size_t)-1;
#endif /* UNIX */
    return SUP_ERR_NO;
}
