/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

#include "fkchdimgprj.h" /*+ Project (READER/FAT12) include.
     include    (READER/FAT12). +*/


/*++++
 *   . 
 ++++*/
TSupErr fkchdimg_open(TSupSysContext *context, TSupSysInfo *info)
{
    TCHAR *fname;
    TReaderInfoOpen *inf = (TReaderInfoOpen*)info;
    TReaderInfoOpenFlags *mode;
    TFKCHDImgContext *ct = (TFKCHDImgContext*)context;
    TSupErr code = 0;

#ifdef UNIX
    char str_mode[3];
#else
    DWORD dwCreationDisposition = 0;
#endif

    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    SUPSYS_PRE_INFO( info, TReaderInfoOpen );
    SUPSYS_PRE( ct->file_name == NULL );
    SUPSYS_PRE_READ_PTRS( inf->mode, sizeof( TReaderInfoOpenFlags ) );
    SUPSYS_PRE( inf->mode_bits >= READER_MODEFLAG_BITS );
    SUPSYS_PRE( inf->name.length );
    SUPSYS_PRE_STRING_PTRS( inf->name.text, inf->name.length );
#ifdef UNIX
    SUPSYS_PRE( ct->handle == NULL );
#else
    SUPSYS_PRE( ct->handle == INVALID_HANDLE_VALUE );
#endif
     
    inf->size_of = sizeof( TReaderInfoOpen );
    fname = inf->name.text;
    ct->file_name = malloc( ( _tcslen( fname ) + 1 + _tcslen( ct->path ) 
	+ 2 + ( ct->folder ? _tcslen( ct->folder ) : 0 ) + 1 )
	* sizeof( TCHAR ) );

    code = lock_lock(ct);
    if (code) {
	if (ct->file_name) {
	    free (ct->file_name);
	    ct->file_name = NULL;
	}
	return code;
    }

    
    if( ct->file_name == NULL ) {
	unlock_lock(ct);
	return SUP_ERR_MEMORY;
    }
    _tcscpy( ct->file_name, ct->path );
    if( ct->folder ) 
    {
	_tcscat( ct->file_name, ct->folder );
	_tcscat( ct->file_name, _TEXT( "/" ) );
    }
    _tcscat( ct->file_name, fname );
    mode = inf->mode;
#ifdef UNIX
    str_mode[2]=str_mode[1]='\0';
    
#if 0
    r  +  +  +  -  -
	w  +  +  -  +  +
	c  +  -  ?  +  -
	mode w+ r+ r  w  r+
#endif
	
	if(mode->o_write){
	    str_mode[0]=((mode->o_creat)?'w':'r');
	    if(mode->o_read||!mode->o_creat) str_mode[1]='+';
	} else
	    str_mode[0]='r';

	if (support_thread_actualize_uids()!= SUP_ERR_NO)
	{
	    free(ct->file_name);
	    ct->file_name = NULL;
	    ct->handle = NULL;
	    unlock_lock(ct);
	    return SUP_ERR_RIGHTS;
	}

	ct->handle = fopen( ct->file_name, str_mode);
	/* free( file_name ); */
	/*   Write Protect */
	/*     . */
	if( ct->handle == NULL ){
	    code = fkchdimg_os_error();
	    support_thread_deactualize_uids();
	    free( ct->file_name );
	    ct->file_name = NULL;
	    ct->handle = NULL;
	    if( errno == ENOENT ) {
		unlock_lock(ct);
		return RDR_ERR_FILE_NOT_FOUND;
	    }
	    unlock_lock(ct);
	    return code;
	}
	if(fchmod(fileno(ct->handle),(((TFKCHDImgContext *)context)->machine)?S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP:S_IRUSR|S_IWUSR )){
	    code = fkchdimg_os_error();
	    support_thread_deactualize_uids();
	    free( ct->file_name );
	    ct->file_name = NULL;
	    fclose(ct->handle);
	    ct->handle = NULL; 
	    unlock_lock(ct);
	    return code;
	}
	support_thread_deactualize_uids();

#else /* UNIX */
    if( mode->o_creat )
	dwCreationDisposition |= CREATE_ALWAYS;
    else
	dwCreationDisposition |= OPEN_EXISTING;
    ct->access = 0;
    if( mode->o_read )
        ct->access |= GENERIC_READ;
    if( mode->o_write )
        ct->access |= GENERIC_WRITE;
    ct->handle = CreateFile( ct->file_name, ct->access,
        FILE_SHARE_READ | FILE_SHARE_WRITE, NULL,
        dwCreationDisposition, FILE_ATTRIBUTE_ARCHIVE, NULL );

    if( ct->handle == INVALID_HANDLE_VALUE ){
	TSupErr code = fkchdimg_os_error();
	free( ct->file_name ); ct->file_name = NULL;
	unlock_lock(ct);
	return code; 
    }
#ifndef WINCE
    //    FlushFileBuffers   CreateFile
    //  CE    ERROR_NOT_SUPPORTED,     
    // FlushFileBuffers   ERROR_NOT_SUPPORTED.
    if( mode->o_write )
    {
	if( !FlushFileBuffers( ct->handle ) )
	{
	    TSupErr code = fkchdimg_os_error();
	    CloseHandle( ct->handle );
	    free( ct->file_name ); ct->file_name = NULL;
	    unlock_lock(ct);
	    return code; 
	}
    }
#endif //WINCE

#endif /* UNIX */
	
    return SUP_ERR_NO;
}
