/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

#include "fkchdimgprj.h" /* Project (READER/FAT12) include.
     include    (READER/FAT12). */

/*++++ 
 *    . 
 ++++*/
TSupErr fkchdimg_read(TSupSysContext *context, TSupSysInfo *info)
{
    TReaderInfoRead *inf = (TReaderInfoRead*)info;
    TFKCHDImgContext *ct = (TFKCHDImgContext*)context;

#ifdef UNIX
    size_t loc_read = 0;
    TSupErr code;
#else /* UNIX */
    DWORD loc_read = 0;
    void *buffer = (void*)inf->info.info;
#endif /* UNIX */

    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    SUPSYS_PRE_INFO( info, TReaderInfoRead );
    SUPSYS_PRE_WRITE_PTRS( inf->info.info, inf->info.length );

    inf->size_of = sizeof( TReaderInfoRead );
#ifdef UNIX
    if( fseek( ct->handle, inf->from, SEEK_SET ) )
	return fkchdimg_os_error();
    errno=0;
    loc_read = fread( inf->info.info, 1, inf->info.length, ct->handle );
    if((code = fkchdimg_os_error()))
	return code;
#else /* UNIX */
    if( ct->handle == INVALID_HANDLE_VALUE )
	return RDR_ERR_MEDIA_CHANGED;
    SUPSYS_PRE( inf->from <= MAXLONG );
    if( SetFilePointer( ct->handle, (long)inf->from, NULL, 
	FILE_BEGIN ) == INVALID_SET_FILE_POINTER )
	return fkchdimg_os_error(); 
    SUPSYS_PRE( inf->info.length <= MAXLONG );
    if( !ReadFile( ct->handle, buffer, (long)inf->info.length, &loc_read, 
	NULL ) )
	return fkchdimg_os_error();
#endif /* UNIX */
    inf->info.length -= loc_read;
    return SUP_ERR_NO;
}
