/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 63052 $
 * \date $Date: 2010-07-10 16:54:07 +0400 (Сбт, 10 Июл 2010) $
 * \author $Author: dim $
 * \brief   
 */

#include "fkchdimgprj.h"

TSupErr fkchdimg_key_set ( 
    TSupSysContext *context, 
    TSupSysInfo *info )
{

    TSupErr err = SUP_ERR_NO;
    BYTE tst [100];
    TReaderFkcKeySet *inf = (TReaderFkcKeySet*)info;
    TFKCHDImgContext *ctx = (TFKCHDImgContext*)context;
    CRYPT_DATA_BLOB blb;
    BYTE data [SECRET_KEY_LEN];
    blb.cbData = SECRET_KEY_LEN;
    blb.pbData = data;

    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    SUPSYS_PRE_INFO( info, TReaderFkcKeySet );

    err = init_read(ctx);
    if (err) goto done;

    if (!ctx->cont.abilityWriteKeys) {
	err = SUP_ERR_CANCEL;
	goto done;
    }
    SUPSYS_PRE_READ_PTRS(inf->uQpw->x,SECRET_KEY_LEN);
    SUPSYS_PRE_READ_PTRS(inf->uQpw->y,SECRET_KEY_LEN);
    SUPSYS_PRE_READ_PTRS(inf->uQs->x,SECRET_KEY_LEN);
    SUPSYS_PRE_READ_PTRS(inf->uQs->y,SECRET_KEY_LEN);

    makePublicBlob(&ctx->cont,tst,(LPBYTE)inf->uQpw->x,(LPBYTE)inf->uQpw->y);
    err = isInCurve(&ctx->cont, tst);
    if (err) {
	err = SUP_ERR_PARAM;
	goto done;
    }
    memcpy(ctx->cont.pbPWPublicKeyBlob,tst,PUBLICBLOBLEN);

    makePublicBlob(&ctx->cont,tst,(LPBYTE)inf->uQs->x,(LPBYTE)inf->uQs->y);
    err = isInCurve(&ctx->cont, tst);
    if (err) {
	err = SUP_ERR_PARAM;
	goto done;
    }
    if (!ctx->cont.pbSaltPublicBlob) ctx->cont.pbSaltPublicBlob = malloc(PUBLICBLOBLEN);
    memcpy(ctx->cont.pbSaltPublicBlob,tst,PUBLICBLOBLEN);

    blb.cbData = SECRET_KEY_LEN;
    be2le(blb.pbData,(LPBYTE)inf->udfkc->v,SECRET_KEY_LEN);
    //memcpy(ctx->cont.KP_X_SAVE,blb.pbData,SECRET_KEY_LEN);
    if (!CryptSetKeyParam(ctx->cont.hKeyPair,KP_X,(BYTE*)&blb,0)) {
	err = GetLastError();
	goto done;
    }

    be2le((LPBYTE)&ctx->cont.syncro+8,(LPBYTE)inf->usyncro->v,24);
    memset(&ctx->cont.syncro,0,8);

    err = fkchdimg_infofile_write(ctx);

done:

    return err;
}
