/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/****
 * $Id: fkchdimgkunl.c 75485 2012-03-04 12:41:26Z dim $
 *
 *       (READER).
 *
 *   /      (FAT12).
 *
 *   /      .
 *   .
 *
 * : fkchdimg_unlink
 ****/

#include "fkchdimgprj.h" /*+ Project (READER/FAT12) include.
     include    (READER/FAT12). +*/

/*++++ 
 *   .
 ++++*/
TSupErr fkchdimg_unlink(TSupSysContext *context, TSupSysInfo *info)
{
    TCHAR *file_name;
    TCHAR *fname;
    TSupErr code = 0;
    TReaderInfoUnlink *inf = (TReaderInfoUnlink*)info;
    TFKCHDImgContext *ctx = (TFKCHDImgContext*)context;

    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    SUPSYS_PRE_INFO( info, TReaderInfoUnlink );
    SUPSYS_PRE_STRING_PTRS( inf->name.text, inf->name.length );
#ifdef UNIX
    SUPSYS_PRE( ctx->handle == NULL );
#else
    SUPSYS_PRE( ctx->handle == INVALID_HANDLE_VALUE );
#endif

    inf->size_of = sizeof( TReaderInfoUnlink );
    fname = inf->name.text;
    file_name = malloc( ( _tcslen( fname )
	+ 2 + _tcslen( ctx->path )
	+ 1 + ( ctx->folder ? _tcslen( ctx->folder ) : 0 )
	+ 1 /* '\0' */ ) * sizeof( TCHAR ) );
        
    if(file_name == NULL)
	return SUP_ERR_MEMORY;

    code = lock_lock(ctx);
    if(code) {
	free(file_name);
	return code;
    }

    _tcscpy( file_name, ctx->path );
    if( ctx->folder ) {
	_tcscat( file_name, ctx->folder );
	_tcscat( file_name, _TEXT( "/" ) );
    }
    _tcscat( file_name, fname );
#ifdef UNIX
    if( remove( file_name ) )
#else
    if( !DeleteFile( file_name ) )
#endif /* UNIX */
    {
	code = fkchdimg_os_error();
	free( file_name );
	unlock_lock(ctx);
	return code;
    }
    free( file_name );
    unlock_lock(ctx);
    return SUP_ERR_NO;
}
