/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/****
 * $Id: fkchdimgkwri.c 63052 2010-07-10 12:54:07Z dim $
 *
 *       (READER).
 *
 *   /      (FAT12).
 *
 *   /      .
 *    .
 *
 * : fkchdimg_write
 ****/

#include "fkchdimgprj.h" /*+ Project (READER/FAT12) include.
     include    (READER/FAT12). +*/
#include "limits.h" 
/*++++ 
 *    . 
 ++++*/
TSupErr fkchdimg_write(TSupSysContext *context, TSupSysInfo *info)
{
    TReaderInfoWrite *inf = (TReaderInfoWrite*)info;
    TFKCHDImgContext *ct = (TFKCHDImgContext*)context;

#ifdef UNIX
    size_t loc_writen;
#else /* UNIX */
    DWORD loc_writen = 0;
    void *buffer = (void*)inf->info.info;
#endif /* UNIX */

    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    SUPSYS_PRE_INFO( info, TReaderInfoWrite );
    SUPSYS_PRE( inf->from <= LONG_MAX );
    SUPSYS_PRE( inf->info.length <= LONG_MAX );

    SUPSYS_PRE_READ_PTRS( inf->info.info, inf->info.length );

    inf->size_of = sizeof( TReaderInfoWrite );
#ifdef UNIX
    if( ct->handle == NULL )
#else
    if( ct->handle == INVALID_HANDLE_VALUE )
#endif
	return RDR_ERR_MEDIA_CHANGED;
#ifdef UNIX
    if( fseek( ct->handle, inf->from, SEEK_SET ) )
	return fkchdimg_os_error();
    loc_writen = fwrite( inf->info.info, 1, inf->info.length, ct->handle );
    if( loc_writen != inf->info.length )
	return fkchdimg_os_error();
#else /* UNIX */
    if( SetFilePointer( ct->handle, (LONG)inf->from, NULL, 
	FILE_BEGIN ) == INVALID_SET_FILE_POINTER )
	return fkchdimg_os_error();
    if( !WriteFile( ct->handle, buffer, (LONG)inf->info.length, &loc_writen, 
	    NULL ) )
	return fkchdimg_os_error();
#endif /* UNIX */
    inf->info.length -= loc_writen;
    return SUP_ERR_NO;
}
