/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 89378 $
 * \date $Date: 2013-05-23 14:53:02 +0400 (Чтв, 23 Май 2013) $
 * \author $Author: sagafyin $
 * \brief   
 */

#include "fkchdimgprj.h"

/*TSupErr rdr_crypt_key_gen(
    TSupSysEContext *context,
    const TSupSysInfoUntyped *uQs,
    const TSupSysInfoUntyped *uQpw,
    const TCHAR *tPIN ) */
TSupErr fkchdimg_new_key ( 
    TSupSysContext *context, 
    TSupSysInfo *info )
{
    TSupErr err = SUP_ERR_NO;
    BYTE tst [100];
    TReaderFkcKeyGen *inf = (TReaderFkcKeyGen*)info;
    TFKCHDImgContext *ctx = (TFKCHDImgContext*)context;

    SUPSYS_PRE_CONTEXT( context, TFKCHDImgContext );
    SUPSYS_PRE_INFO( info, TReaderFkcKeyGen );
    
    err = init_read(ctx);
    if (err) goto done;

    if (!ctx->cont.abilityInitKeys) {
	err = SUP_ERR_CANCEL;
	goto done;
    }
    SUPSYS_PRE_READ_PTRS(inf->uQpw->x,SECRET_KEY_LEN);
    SUPSYS_PRE_READ_PTRS(inf->uQpw->y,SECRET_KEY_LEN);
    SUPSYS_PRE_READ_PTRS(inf->uQs->x,SECRET_KEY_LEN);
    SUPSYS_PRE_READ_PTRS(inf->uQs->y,SECRET_KEY_LEN);

    
    makePublicBlob(&ctx->cont,tst,(LPBYTE)inf->uQpw->x,(LPBYTE)inf->uQpw->y);
    err = isInCurve(&ctx->cont, tst);
    if (err) {
	err = SUP_ERR_PARAM;
	goto done;
    }
    memcpy(ctx->cont.pbPWPublicKeyBlob,tst,PUBLICBLOBLEN);
    memset(ctx->cont.syncro+8,0xff,24);

    makePublicBlob(&ctx->cont,tst,(LPBYTE)inf->uQs->x,(LPBYTE)inf->uQs->y);
    err = isInCurve(&ctx->cont, tst);
    if (err) {
	err = SUP_ERR_PARAM;
	goto done;
    }
    if (!ctx->cont.pbSaltPublicBlob) ctx->cont.pbSaltPublicBlob = malloc(PUBLICBLOBLEN);
    memcpy(ctx->cont.pbSaltPublicBlob,tst,PUBLICBLOBLEN);


    err = fkchdimg_infofile_write(ctx);
    if (err!=SUP_ERR_NO) 
    {
	goto done;
    }
done:

    return err;
}

void makePublicBlob (LPTOKEN_CONTAINER pFkc, BYTE * blob, BYTE *PointX, BYTE *PointY) 
{
    memcpy(blob, pFkc->pbPPHeader, 0x24);
    be2le(blob+0x24,PointX,SECRET_KEY_LEN);
    be2le(blob+0x24+SECRET_KEY_LEN,PointY,SECRET_KEY_LEN);
}

void makePointFromBlob (BYTE *PointX, BYTE *PointY, BYTE * blob) 
{
    be2le(PointX,blob+0x24,SECRET_KEY_LEN);
    be2le(PointY,blob+0x24+SECRET_KEY_LEN,SECRET_KEY_LEN);
}


DWORD isInCurve(LPTOKEN_CONTAINER pFkc, BYTE *blob)
{
    HCRYPTKEY newkey = 0;
    DWORD err = 0;
    
    if (!CryptImportKey(pFkc->hContainer, blob, PUBLICBLOBLEN, 0, 0, &newkey)) {
	err = GetLastError();
    }
    if (newkey) {
	if (!CryptDestroyKey(newkey)) GetLastError();
    }
    return err;
}

#ifndef WORDS_BIGENDIAN
BYTE PublicHeaders[5][0x24] = {
    {
	 //1
	0x06,0x20,0x00,0x00, 0x23,0x2e,0x00,0x00, 0x4d,0x41,0x47,0x31, 0x00,0x02,0x00,0x00,
	0x30,0x12,0x06,0x07, 0x2a,0x85,0x03,0x02, 0x02,0x23,0x02,0x06, 0x07,0x2a,0x85,0x03,
	0x02,0x02,0x1e,0x01
    },
    {
	 //2
	0x06,0x20,0x00,0x00, 0x23,0x2e,0x00,0x00, 0x4d,0x41,0x47,0x31, 0x00,0x02,0x00,0x00,
	0x30,0x12,0x06,0x07, 0x2a,0x85,0x03,0x02, 0x02,0x23,0x01,0x06, 0x07,0x2a,0x85,0x03,
	0x02,0x02,0x1e,0x01
    },
    {
	 //3
	0x06,0x20,0x00,0x00, 0x23,0x2e,0x00,0x00, 0x4d,0x41,0x47,0x31, 0x00,0x02,0x00,0x00,
	0x30,0x12,0x06,0x07, 0x2a,0x85,0x03,0x02, 0x02,0x23,0x03,0x06, 0x07,0x2a,0x85,0x03,
	0x02,0x02,0x1e,0x01
    },
    {
	 //4
	0x06,0x20,0x01,0x00, 0x23,0x2e,0x00,0x00, 0x4d,0x41,0x47,0x31, 0x00,0x02,0x00,0x00,
	0x30,0x12,0x06,0x07, 0x2a,0x85,0x03,0x02, 0x02,0x24,0x00,0x06, 0x07,0x2a,0x85,0x03,
	0x02,0x02,0x1e,0x01
    },
    {
	 //5
	0x06,0x20,0x01,0x00, 0x23,0x2e,0x00,0x00, 0x4d,0x41,0x47,0x31, 0x00,0x02,0x00,0x00,
	0x30,0x12,0x06,0x07, 0x2a,0x85,0x03,0x02, 0x02,0x24,0x01,0x06, 0x07,0x2a,0x85,0x03,
	0x02,0x02,0x1e,0x01
    },
};
#else /* WORDS_BIGENDIAN */
BYTE PublicHeaders[5][0x24] = {
    {
	 //1
	0x06,0x20,0x00,0x00, 0x00,0x00,0x2e,0x23, 0x31,0x47,0x41,0x4d, 0x00,0x00,0x02,0x00,
	0x30,0x12,0x06,0x07, 0x2a,0x85,0x03,0x02, 0x02,0x23,0x02,0x06, 0x07,0x2a,0x85,0x03,
	0x02,0x02,0x1e,0x01
    },
    {
	 //2
	0x06,0x20,0x00,0x00, 0x00,0x00,0x2e,0x23, 0x31,0x47,0x41,0x4d, 0x00,0x00,0x02,0x00,
	0x30,0x12,0x06,0x07, 0x2a,0x85,0x03,0x02, 0x02,0x23,0x01,0x06, 0x07,0x2a,0x85,0x03,
	0x02,0x02,0x1e,0x01
    },
    {
	 //3
	0x06,0x20,0x00,0x00, 0x00,0x00,0x2e,0x23, 0x31,0x47,0x41,0x4d, 0x00,0x00,0x02,0x00,
	0x30,0x12,0x06,0x07, 0x2a,0x85,0x03,0x02, 0x02,0x23,0x03,0x06, 0x07,0x2a,0x85,0x03,
	0x02,0x02,0x1e,0x01
    },
    {
	 //4
	0x06,0x20,0x00,0x00, 0x00,0x00,0x2e,0x23, 0x31,0x47,0x41,0x4d, 0x00,0x00,0x02,0x00,
	0x30,0x12,0x06,0x07, 0x2a,0x85,0x03,0x02, 0x02,0x24,0x00,0x06, 0x07,0x2a,0x85,0x03,
	0x02,0x02,0x1e,0x01
    },
    {
	 //5
	0x06,0x20,0x00,0x00, 0x00,0x00,0x2e,0x23, 0x31,0x47,0x41,0x4d, 0x00,0x00,0x02,0x00,
	0x30,0x12,0x06,0x07, 0x2a,0x85,0x03,0x02, 0x02,0x24,0x01,0x06, 0x07,0x2a,0x85,0x03,
	0x02,0x02,0x1e,0x01
    },
};
#endif /* WORDS_BIGENDIAN */

