/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

#ifndef _TOKEN_H_INCLUDED
#define _TOKEN_H_INCLUDED

#ifndef UNIX
# include <Windows.h>
# include <wincrypt.h>
#endif // UNIX

#include "WinCryptEx.h"

#define FKCHDIMG_PATH _TEXT("\\Config\\KeyDevices\\FKCHDIMG\\Default\\Destprov")

/*********************************************************
*       TOKEN DEFINES
**********************************************************/
#define FKC_GENKEY  0x00cc0000

#define ECC_PLUS 0
#define ECC_MINUS 1

/* ,      */
#define TOKENEKE_SYNCRO		0x80000ff0  /*Syncro*/
#define TOKENEKE_SYNCRO_	0x80000ff1  /*Syncro_*/
#define TOKENEKE_PWPUBLIC	0x80000ef2  /*Q_pw*/
#define TOKENEKE_DELTA		0x80000ef3  /*Delta*/
#define TOKENEKE_PUBLIC		0x80000ef4  /*Q_fkc*/
#define TOKENEKE_PWPUBLICNULL	0x80000ef5  /*Q_pw = NULL*/
#define TOKENEKE_PIN		0x80000ff5  /*Pin, SaltPin*/
#define TOKENEKE_VERIFY		0x80000f00  /*Verify*/

#define CSP_C			0x81000000  /*CSP*/
#define TOKEN_MASK		0x03000000  /**/

#define EVALUATE_PASSWORD_COUNT 1999
#define LOW_COUNT 1

#define DW_KEYLEN 8

#define NAME_LENTH 256

#define PUBLICBLOBLEN	0x64
#define PUBLIC_ECCPOINT	(PUBLICBLOBLEN-(2*SECRET_KEY_LEN))

/**********************************************
	  
*****************************************************/
#define pszPW_0	"W47rgffDO485r3fhbo"

/*********************************************************
*       FKC CONTAINER NAMES
**********************************************************/
#define FKC_CONTAINER_NAME _TEXT("FKCKeyContainer")
#define FKC_DUP_CONTAINER_NAME _TEXT("FKCKeyDupContainer")
#define FKC_CONTAINER_NAME_T _TEXT("TCHrpPghFKC1")

/*********************************************************
*       TOKEN STRUCT
**********************************************************/
enum id{id_syncro,id_syncro_,id_delta,id_Q_PW,id_Q_FKC,
	id_Q_S,id_Name,id_Unique,id_PIN,
	id_Q_USER,
	id_e,id_R2,id_R,id_S2,
	id_dh_in,id_dh_out,
	id_verify,
	id_PublicKeyBlob,id_Q_PW_0
};

typedef struct _TOKEN_COUNT_ {
    DWORD c_eke;	/*c1*/
    DWORD c_sig;	/*c2*/
    DWORD c_dh;		/*c3*/
    DWORD c_fls;	/*c4*/
    DWORD c_seqfls;	/*c5*/
} COUNTS,*PCOUNTS;

typedef struct _TOKEN_CONTAINER_ {
    TCHAR	TokenName[NAME_LENTH+1];
    BYTE        UniqueTokenName[NAME_LENTH+1];	
    BYTE 	    friendlyname[NAME_LENTH+1];
    BYTE	    pszKeyOID[0x20];	/*Temp - ,  TEMP*/
    DWORD 	    dwKeySpec;	/*AT_SIGNATURE,AT_KEYEXCHANGE*/
    ALG_ID 	    aAlgId;	/*CALG_GR3410EL,CALG_DH_EL_EPHEM*/
    DWORD 	    dwControl;	/*0,CRYPT_VERIFYCONTEXT*/
    DWORD	    Num_ECC;   /**/
    COUNTS	    C;
    HCRYPTPROV  hContainer;
    HCRYPTKEY   hKeyPair;
    HCRYPTKEY   hPublicKey;
    HCRYPTKEY   hKeyPW;

    HCRYPTKEY   hKeyPW_Pair;
    HCRYPTKEY   hPWPublicKey;
    HCRYPTKEY   hKey_A;
    HCRYPTKEY   hEKEAgree_A_B;
    CRYPT_DATA_BLOB	    dKeyPW;
/*  */
    HCRYPTKEY   hUserPublicKey;
/*   */
    HCRYPTKEY   hFKCPublicKey;
/*     EKE */
    LPBYTE		pbEKE_A;
    LPBYTE		pbEKE_MA_Verify;
    LPBYTE		pbEKE_MB_Verify;
    BYTE a_b[SECRET_KEY_LEN];
    BYTE syncro[SECRET_KEY_LEN];
    DWORD Verify_A;
    DWORD Verify_B;
/*  */
    LPBYTE	    pbPublicKeyBlob;
    LPBYTE	    pbUserPublicKeyBlob;    /*Quser*/
    LPBYTE	    pbFKCPublicKeyBlob;	    /*Qfkc*/
    LPBYTE	    pbPWPublicKeyBlob_d;    /*Qpw = init */
    LPBYTE	    pbPWPublicKeyBlob;	    /*Qpw =Kpw*Qs*/
    LPBYTE	    pbSaltPublicBlob;	    /*Qs*/
    DWORD	    dwPubBlobLen;
        
    TRdrLoginInfoType logType;
    BYTE controlvector [8];
    DWORD	randidentificator;
} TOKEN_CONTAINER, *LPTOKEN_CONTAINER;

/*********************************************************
*       TOKEN CONTAINER NAMES
**********************************************************/
#include "tMagistra.h"

#ifdef __cplusplus
extern "C" {
#endif

/*********************************************************
*       TOKEN CONTAINER FUNCS
**********************************************************/
void FKCtstReleaseTContainer( LPTOKEN_CONTAINER psRootKeys);

/*********************************************************
*       TOKEN KEY FUNCS
**********************************************************/
DWORD FKCCreateKeysManyMany(LPTOKEN_CONTAINER pCSP);
DWORD FKCCreateDelta_e(LPTOKEN_CONTAINER pCSP,LPBYTE pbData);
DWORD FKCAddPubKey_t(HCRYPTPROV hProv, LPBYTE pbPubKeyBlobA,LPBYTE pbPubKeyBlobB, 
		   DWORD* pdwBlobLen, DWORD dwECCSign, LPBYTE* ppbPubKeyBlobRes);

/*********************************************************
*       TOKEN PROTOCOL FUNCS
**********************************************************/
DWORD FKCCreatePWPublic(LPTOKEN_CONTAINER pCSP,LPSTR pszPW);
DWORD FKCCreateSyncro_e(LPTOKEN_CONTAINER pCSP,PTOKEN_DATA pData);

/*********************************************************
*       TOKEN SIGNATURE FUNCS
**********************************************************/
DWORD FKCVerifySign(HCRYPTPROV hProv, LPBYTE pbPubKeyBlob, DWORD dwBlobLen, BYTE *text, DWORD textlen,
		    BYTE *pbSignature);

/*********************************************************
*       TOKEN SUPPORT FUNCS
**********************************************************/
DWORD SetTokenData(DWORD dwControl,LPBYTE pbData,DWORD cbData,PTOKEN_DATA pData);
void FreeTokenData(PTOKEN_DATA pData);
DWORD SetPublicTokenContainer(PTOKEN_DATA pData,LPTOKEN_CONTAINER pCont);
DWORD SetDataPublicTokenContainer(DWORD tControl,BYTE* pbData, DWORD cbData,
				  LPTOKEN_CONTAINER pCont);

DWORD CreatePublicKeyBlob_test(HCRYPTKEY   hKeyPair, DWORD* pdwBlobLen, LPBYTE* ppbKeyBlob);
DWORD FKCTCreateUserPublicKey(HCRYPTPROV hProv, 
			      LPBYTE pbPkeyBlobCSP,LPBYTE pbPkeyBlobFKC, DWORD dwBlobLen, DWORD dwECCSign,
			      HCRYPTKEY* phUserPubKey, LPBYTE* ppbUserPubKeyBlob);

DWORD SetPublicKeyBlob_test(TOKEN_CONTAINER* pTKN);

/*********************************************************
*       TOKEN TEST FUNCS
**********************************************************/
DWORD Test_FKCAdminCreate(TSupSysEContext * ctx, TSupSysEContext * dupctx, LPTSTR pszFKCContainerName, DWORD dwKeySpec, char * pszKeyOID, LPSTR pPW, BOOL setkey);
DWORD loginToNull(TSupSysEContext * ctx, BYTE defar[128], DWORD first);

DWORD
CSPCreateTContainer(LPSTR pszPW, LPTOKEN_CONTAINER psRootKeys);

DWORD 
FKCSetEKE_A_(LPTOKEN_CONTAINER pCSP, PTOKEN_DATA pData);
DWORD 
FKCGetEKE_A_(LPTOKEN_CONTAINER pCSP, PTOKEN_DATA pData, BOOL wrong_A);
DWORD 
FKCSetEKE_DATA_(LPTOKEN_CONTAINER pCSP, PTOKEN_DATA pbData);
DWORD 
FKCGetEKE_DATA_(LPTOKEN_CONTAINER pCSP, PTOKEN_DATA pbData);
DWORD
FKCCreateEKEVerify1(TOKEN_CONTAINER *pTKN,PTOKEN_DATA pData,PTOKEN_DATA pEKEData);
DWORD
FKCCreateEKEVerify2(TOKEN_CONTAINER *pTKN,PTOKEN_DATA pData,PTOKEN_DATA pEKEData);
DWORD 
FKCVerifyEKE_t(LPTOKEN_CONTAINER pTKN, DWORD secval);
void makePublicBlob_t (LPTOKEN_CONTAINER pFkc, BYTE * blob, BYTE *Point);

/*************************************************************
	 4.
	    CONF_
	(file ConformityFKCPerformance.c)
************************************************************/
DWORD IntCSPTContainer(LPTSTR pszTokenName, DWORD dwControl,
		       DWORD dwKeySpec,char *  pszKeyOID, LPTOKEN_CONTAINER* ppCSP);
DWORD srtOIDtoDWORD(const char * pszKeyOID);

#ifdef __cplusplus
}
#endif

#endif /* _TOKEN_H_INCLUDED */
