/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 96749 $
 * \date $Date: 2013-10-31 12:52:50 +0300 (Чтв, 31 Окт 2013) $
 * \author $Author: sagafyin $
 * \brief    .
 */

#include "fkchdimgprj.h"

/*!
 * \ingroup hdimage_internal
 * \brief  .
 */
static const unsigned char UECHDIMAGE_FLAGS_GENERAL[] = 
{ 
    0 << 7 
};

static const unsigned char UECHDIMAGE_FLAGS_CONNECT[] = 
{
    0 << 7 /* SUPSYS_FLAG_CONNECT_MANY */
    | 0 << 6 /* SUPSYS_FLAG_CONNECT_COM */
    | 0 << 5 /* SUPSYS_FLAG_CONNECT_LPT */
    | 0 << 4 /* SUPSYS_FLAG_CONNECT_AUTO */
    | 0 << 3 /* SUPSYS_FLAG_CONNECT_MULTY */
    | 0 << 2 /* SUPSYS_FLAG_CONNECT_PNPGROUP */
};

static const unsigned char UECHDIMAGE_FLAGS_RDR[] = 
{
    1 << 7 /* RDR_FLAG_RDR_LONG_NAMES */
    | 0 << 6 /* RDR_FLAG_RDR_REMOVABLE */
    | 0 << 5 /* RDR_FLAG_RDR_UNIQUE */
    | 0 << 4 /* RDR_FLAG_RDR_FOLDERS */
    | 1 << 3 /* RDR_FLAG_RDR_FOLDER_ROOT */
    | 0 << 2 /*	RDR_FLAG_RDR_PROTECTED */
    | 1 << 1 /*	RDR_FLAG_RDR_FKC_SUPPORTED  -      FKC */
};

static const unsigned char UECHDIMAGE_FLAGS_FKC [] = 
{
    1 << 7  /* RDR_FLAG_FKC_NULL_FOLDER */
    | 1 << 6 /* RDR_FLAG_FKC_DISABLE_PASSWORD */
    | 1 << 5 /* RDR_FLAG_FKC_ENABLE_INIT_KEYS */
    | 0 << 4 /* RDR_FLAG_FKC_ENABLE_SET_KEYS */
    | 1 << 3 /* RDR_FLAG_UEC */
    | 1 << 1 /* RDR_FLAG_NOT_SPLIT */
    | 1 << 1 /* RDR_FLAG_FKC_PIN_TO_DELETE */
};

/*! 
 * \ingroup hdimage_fun_general
 * \brief    .
 * \param context [in]  .  .
 * \param info [out]  #TReaderInfoSystemFlag
 * \sa #TReaderInfoSystemFlag, #READER_FUN_SYSTEM_FLAG, 
 *  #supsys_flag
 * \return  
 */
TSupErr uechdimg_info_system_flag(
    TSupSysContext *context, 
    TSupSysInfo *info )
{
    TSupSysInfoFlags *flags = (TSupSysInfoFlags*)info;
    size_t length;
    const unsigned char *ptr = NULL;

    UNUSED( context );
    SUPSYS_PRE_INFO( info, TSupSysInfoFlags );
    SUPSYS_PRE( flags->type <= RDR_FLAG_BLOCK_FKC );
    SUPSYS_PRE( flags->type == RDR_FLAG_BLOCK_FKC
	|| flags->type == RDR_FLAG_BLOCK_RDR
	|| flags->type == SUPSYSE_FLAG_BLOCK_GENERAL
	|| flags->type == SUPSYS_FLAG_BLOCK_CONNECT );
    length = flags->string.bits;
    if( flags->type == SUPSYSE_FLAG_BLOCK_GENERAL )
    {
	length = SUPSYSE_FLAG_GENERAL_VERSION_1;
	ptr = UECHDIMAGE_FLAGS_GENERAL;
    }
    if( flags->type == SUPSYS_FLAG_BLOCK_CONNECT )
    {
	length = SUPSYS_FLAG_CONNECT_VERSION_3;
	ptr = UECHDIMAGE_FLAGS_CONNECT;
    }
    if( flags->type == RDR_FLAG_BLOCK_FKC )
    {
	BOOL isrelease = TRUE;
	
	if (CSPVersion(&isrelease)) 
	    return SUP_ERR_CANCEL;
	length = RDR_FLAG_FKC_VERSION_4;
	ptr = UECHDIMAGE_FLAGS_FKC;
    }
    if( flags->type == RDR_FLAG_BLOCK_RDR )
    {
	length = RDR_FLAG_RDR_VERSION_3;
	ptr = UECHDIMAGE_FLAGS_RDR;
    }
    if( flags->string.string == NULL )
    {
	flags->string.bits = length;
	return SUP_ERR_NO;
    }
    if( flags->string.bits > length )
	flags->string.bits = length;
    memcpy( flags->string.string, ptr, 
	flags->string.bits / 8 + ( flags->string.bits % 8 ? 1 : 0 ) );
    flags->string.bits = length;
    return SUP_ERR_NO;
}
