/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 87511 $
 * \date $Date: 2013-04-02 16:29:02 +0400 (Втр, 02 Апр 2013) $
 * \author $Author: sagafyin $
 * \brief    .
 */

#include "fkchdimgprj.h"
#include "reader.kit/rdr_ver.h"

/*!
 * \ingroup hdimage_internal
 * \brief      .
 * \sa #TSupSysFunctionTable, #TSupSysFunctionTableItem, #hdimage_funs
 */
static const TSupSysFunctionTableItem uechdimg_funs[] =
{
    { SUPSYS_FUN_INSTANCE, fkchdimg_info_instance },
    { SUPSYS_FUN_CONTEXT_DUP, uechdimg_context_dup },
    { SUPSYS_FUN_CONTEXT_FREE, uechdimg_context_free },
    { SUPSYS_FUN_IDS_BLOCK, uechdimg_info_ids },
    { SUPSYS_FUN_FLAGS, uechdimg_info_system_flag },
    { SUPSYS_FUN_VERSIONSUPPORT, info_versionsupport},

    { READER_FUN_CARRIER_TYPE, uechdimg_default_carrier_type},
 
    { SUPSYS_FUN_REGISTER, uechdimg_register },
    { SUPSYS_FUN_UNREGISTER, uechdimg_unregister },

    { READER_FUN_LOCK, fkchdimg_lock },
    { READER_FUN_UNLOCK, fkchdimg_unlock },

    { READER_FUN_FOLDER_PARAM_GET, uechdimg_get_param},

    { READER_FUN_FOLDER_OPEN, uechdimg_folder_open },
    { READER_FUN_FOLDER_CLOSE, uechdimg_folder_close },
    { READER_FUN_PASSWD_PHRASE, uechdimg_auth_phrase },

    { READER_FUN_LOGIN, uechdimg_login },
    { READER_FUN_LOGOUT, uechdimg_logout },

    { READER_FUN_PASSWD_CHANGE, uechdimg_change_pin },
    { READER_FUN_OPEN, uechdimg_file_open },
    { READER_FUN_CLOSE, uechdimg_file_close },

    { READER_FUN_READ, uechdimg_file_read },
    { READER_FUN_WRITE, uechdimg_file_write },
    { READER_FUN_CHSIZE, uechdimg_file_chsize },
    { READER_FUN_LENGTH, uechdimg_file_size },

    { READER_FUN_KEY_GEN, uechdimg_new_key},
    { READER_FUN_SIGNATURE, uechdimg_sign }
};

static const TSupSysFunctionTableItem uechdimg2_funs[] =
{
    { SUPSYS_FUN_INSTANCE, fkchdimg_info_instance },
    { SUPSYS_FUN_CONTEXT_DUP, uechdimg2_context_dup },
    { SUPSYS_FUN_CONTEXT_FREE, uechdimg_context_free },
    { SUPSYS_FUN_IDS_BLOCK, uechdimg2_info_ids },
    { SUPSYS_FUN_FLAGS, uechdimg_info_system_flag },
    { SUPSYS_FUN_VERSIONSUPPORT, info_versionsupport},

    { READER_FUN_CARRIER_TYPE, uechdimg_default_carrier_type},
 
    { SUPSYS_FUN_REGISTER, uechdimg2_register },
    { SUPSYS_FUN_UNREGISTER, uechdimg_unregister },

    { READER_FUN_LOCK, fkchdimg_lock },
    { READER_FUN_UNLOCK, fkchdimg_unlock },

    { READER_FUN_FOLDER_PARAM_GET, uechdimg_get_param},

    { READER_FUN_FOLDER_OPEN, uechdimg_folder_open },
    { READER_FUN_FOLDER_CLOSE, uechdimg_folder_close },
    { READER_FUN_PASSWD_PHRASE, uechdimg_auth_phrase },

    { READER_FUN_LOGIN, uechdimg_login },
    { READER_FUN_LOGOUT, uechdimg_logout },
    { READER_FUN_PUK_ENTER, uechdimg_puk_enter },

    { READER_FUN_PASSWD_CHANGE, uechdimg_change_pin },
    { READER_FUN_OPEN, uechdimg_file_open },
    { READER_FUN_CLOSE, uechdimg_file_close },
    { READER_FUN_CLEAR_TRIES, uechdimg_clear_tries },

    { READER_FUN_READ, uechdimg_file_read },
    { READER_FUN_WRITE, uechdimg_file_write },
    { READER_FUN_CHSIZE, uechdimg_file_chsize },
    { READER_FUN_LENGTH, uechdimg_file_size },

    { READER_FUN_KEY_GEN, uechdimg_new_key},
    { READER_FUN_SIGNATURE, uechdimg_sign }
};

/*!
 * \ingroup hdimage_internal
 * \brief    .
 * \sa #TSupSysFunctionTable, #TSupSysFunctionTableItem, #hdimage_funs
 */
static const TSupSysFunctionTable uechdimg_table =
{
    sizeof( TSupSysFunctionTable ),
    sizeof( uechdimg_funs ) / sizeof( TSupSysFunctionTableItem ),
    uechdimg_funs
};

static const TSupSysFunctionTable uechdimg2_table =
{
    sizeof( TSupSysFunctionTable ),
    sizeof( uechdimg2_funs ) / sizeof( TSupSysFunctionTableItem ),
    uechdimg2_funs
};

/*!
 * \ingroup hdimage_external
 * \brief      .
 * \sa #rdr_register_all, #TSupSysExportFunction
 * \return      .
 * \internal    #hdimage_table
 */
const TSupSysEHandle *
    uechdimg_reader_get_handle(
    void )
{
    return (const TSupSysEHandle*)&uechdimg_table;
}

const TSupSysEHandle *
    uechdimg2_reader_get_handle(
    void )
{
    return (const TSupSysEHandle*)&uechdimg2_table;
}


/* end of file: $Id: uechdimgis.c 87511 2013-04-02 12:29:02Z sagafyin $ */
