/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/*!
 * \file $RCSfile$
 * \version $Revision: 85126 $
 * \date $Date: 2013-01-28 16:24:04 +0300 (Пнд, 28 Янв 2013) $
 * \author $Author: dim $
 * \brief   .
 */

#include "fkchdimgprj.h"

/*!
 * \ingroup hdimage_fun_reader
 * \brief   .
 * \param context [in]  .
 * \param info [in/out]  #TSupSysInfoRegister
 * \sa #TSupSysInfoRegister, #SUPSYS_FUN_REGISTER, 
 *  #TSupSysFunction, #hdimage_info_unregister, 
 *  #rdr_unregister
 * \return  
 * \retval #SUP_ERR_NO  
 * \retval #SUP_ERR_PARAM    
 * \retval #SUP_ERR_MEMORY    
 * \retval #SUP_ERR_VERIFY     
 */
TSupErr uechdimg_register(
    TSupSysContext *context, 
    TSupSysInfo *info )
{
    TSupSysInfoRegister *inf = (TSupSysInfoRegister*)info;
    TUECHDImgContext *ctx;

    SUPSYS_PRE( context == NULL );
    SUPSYS_PRE_INFO( info, TSupSysInfoRegister );

    inf->size_of = sizeof( TSupSysInfoRegister );
    if( support_load_library() )
	return SUP_ERR_VERIFY;
    ctx = malloc( sizeof( *ctx ) );
    if( ctx == NULL )
    {
	support_unload_library();
	return SUP_ERR_MEMORY;
    }
    memset( ctx, 0, sizeof( *ctx ) );

    ctx->key_blob_path = (TCHAR*) KEY_BLOB_PATH;
    ctx->header_path = (TCHAR*) HEADER_PATH;
    ctx->info_path = (TCHAR*) INFO_PATH;
    ctx->pin_path = (TCHAR*) PIN_PATH;
    ctx->pin_count_path = (TCHAR*) PIN_COUNT_PATH;
    ctx->puk_path = (TCHAR*) PUK_PATH;
    ctx->puk_count_path = (TCHAR*) PUK_COUNT_PATH;
    ctx->pin_need_path = (TCHAR *) PIN_NEED_PATH;

    inf->context = ctx;
    return SUP_ERR_NO;
}

TSupErr uechdimg2_register(
			  TSupSysContext *context, 
			  TSupSysInfo *info )
{
    TSupSysInfoRegister *inf = (TSupSysInfoRegister*)info;
    TUECHDImgContext *ctx;

    SUPSYS_PRE( context == NULL );
    SUPSYS_PRE_INFO( info, TSupSysInfoRegister );

    inf->size_of = sizeof( TSupSysInfoRegister );
    if( support_load_library() )
	return SUP_ERR_VERIFY;
    ctx = malloc( sizeof( *ctx ) );
    if( ctx == NULL )
    {
	support_unload_library();
	return SUP_ERR_MEMORY;
    }
    memset( ctx, 0, sizeof( *ctx ) );

    ctx->key_blob_path = (TCHAR*) KEY_BLOB_PATH_2;
    ctx->header_path = (TCHAR*) HEADER_PATH_2;
    ctx->info_path = (TCHAR*) INFO_PATH_2;
    ctx->pin_path = (TCHAR*) PIN_PATH_2;
    ctx->pin_count_path = (TCHAR*) PIN_COUNT_PATH_2;
    ctx->puk_path = (TCHAR*) PUK_PATH_2;
    ctx->puk_count_path = (TCHAR*) PUK_COUNT_PATH_2;
    ctx->pin_need_path = (TCHAR *) PIN_NEED_PATH_2;

    inf->context = ctx;
    return SUP_ERR_NO;
}


TSupErr uechdimg_unregister( 
    TSupSysContext *context, 
    TSupSysInfo *info )
{
    TUECHDImgContext *ctx = (TUECHDImgContext*)context;

    /*   . */
    SUPSYS_PRE_INFO( info, TSupSysInfoUnregister );
    if( ctx == NULL )
	return SUP_ERR_NO;
    free(ctx);

    support_unload_library();
    return SUP_ERR_NO;
}

/* end of file: $Id: uechdimgreg.c 85126 2013-01-28 13:24:04Z dim $ */
