/*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

/****
 * $Id: tst_file.c 82960 2012-11-22 12:49:01Z borodin $
 *
 *       (READER).
 *
 *   (TEST).
 *
 *     .
 *
 * : test_file_*
 *
 *    define: 
 *
 * : 
 *
 *  :
 *
 ****/

#include "tst_prj.h" /*+ Project (READER/RDR/TEST) include.
    include    (READER/RDR/TEST). +*/

enum CarrierFiles_
{
    CF_HEADER, /*!<      . */
    CF_PRIMARY, /*!<    primary  . */
    CF_MASKS, /*!<     primary  . */
    CF_PRIMARY2, /*!<    primary  . */
    CF_MASKS2, /*!<     primary  . */
    CF_NAME, /*!<     . */
    CF_MAX_V1, /*!<    - 1  . */
    CF_DEF = CF_MAX_V1, /*!<  def file */
    CF_MAX_ALL_V2
};

extern const TCHAR *CARRIER_FILE_NAMES[CF_MAX_ALL_V2];

const TCHAR *CARRIER_FILE_NAMES[7] = 
{
    _TEXT( "header.key" ),
    _TEXT( "primary.key" ), _TEXT( "masks.key" ),
    _TEXT( "primary2.key" ), _TEXT( "masks2.key" ),
    _TEXT( "name.key" ),
    _TEXT( "def.key" ),
};

/*! \internal
 * \ingroup grp_carrier_zone_def
 * \brief    ,     .
 *
 *      - 1.
 * \sa #CarrierFiles, #CARRIER_FILE_NAMES
 */
const TRdrFileNumber CARRIER_FILE_NUMBERS[7] = 
{
    3, 
    2, 1,
    5, 4,
    6,
    7,
};


TSupErr reader_test_DEF_READ( 
    TSupSysEContext *context, 
    BYTE arrayname [128])
{
    TSupErr code;
    //static const TCHAR *test_file_name = _TEXT( "filename" );
    const TCHAR *file_name = CARRIER_FILE_NAMES[CF_DEF];
    TRdrFileNumber rdr_fileno = CARRIER_FILE_NUMBERS[CF_DEF];

    printf ("Open/read/close DEF function test in progress...\n");
    /*+    . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Open/read/close DEF function test in progress...")));    

    /*+  . +*/
    code = rdr_file_open( context, _TEXT( "r" ), file_name, rdr_fileno );
    if( code )
	return test_error( context, code );

    /*+   . +*/
    code = rdr_file_read( context, 0, 128, arrayname, NULL );
    if( code )
	return test_error( context, code );
    code = rdr_file_close( context );
    if( code )
	return test_error( context, code );

    /*+     . +*/
    printf ("Open/read/close DEF function test successful.\n");
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Open/read/close DEF function test successful.")));    
    return SUP_ERR_NO;

}


TSupErr reader_test_DEF_WRITE( 
    TSupSysEContext *context, 
    BYTE arrayname [128])
/*+
 * :
 *
 * SUP_ERR_NO,  .
 *
 *  ,  .
 +*/
{
    TSupErr code;
    //static const TCHAR *test_file_name = _TEXT( "filename" );
    const TCHAR *file_name = CARRIER_FILE_NAMES[CF_DEF];
    TRdrFileNumber rdr_fileno = CARRIER_FILE_NUMBERS[CF_DEF];
    unsigned char buffer[128];

    /*+    . +*/
    printf ("Create/write/close DEF function test in progress...\n");
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Create/write/close DEF function test in progress...")));

    /*+  . +*/
    code = rdr_file_open( context, _TEXT( "wp" ), file_name, rdr_fileno );
    if( code )
    {
	test_error( context, SUP_ERR_UNSUPPORTED );
	code = rdr_file_open( context, _TEXT( "r+p" ), file_name, rdr_fileno );
    }
    if( code )
	return test_error( context, code );

    /*    . +*/
    code = reader_test_file_chsize( context, 128 );
    if( code )
	return code;

    memcpy(buffer, arrayname, sizeof(buffer));
    /*+    . +*/
    code = rdr_file_write( context, 0, 128, buffer, NULL );
    if( code )
	return test_error( context, code );

    /*+  . +*/
    code = rdr_file_close( context );
    if( code )
	return test_error( context, code );

    /*+     . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Create/write/close DEF function test successful.")));    
    printf ("Create/write/close DEF function test successful.\n");    
    return SUP_ERR_NO;
}


TSupErr reader_test_HEADER_GET( 
    TSupSysEContext *context, 
    BYTE controlvec [16])
{
    TSupErr code;
    //static const TCHAR *test_file_name = _TEXT( "filename" );
    const TCHAR *file_name = CARRIER_FILE_NAMES[CF_HEADER];
    TRdrFileNumber rdr_fileno = CARRIER_FILE_NUMBERS[CF_HEADER];

    /*+    . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Open/read/close HEADER function test in progress...")));    

    /*+  . +*/
    code = rdr_file_open( context, _TEXT( "r" ), file_name, rdr_fileno );
    if( code )
	return test_error( context, code );

    /*+   . +*/
    code = rdr_file_read( context, 0, 16, controlvec, NULL );
    if( code )
	return test_error( context, code );
    code = rdr_file_close( context );
    if( code )
	return test_error( context, code );

    /*+     . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Open/read/close HEADER function test successful.")));    
    return SUP_ERR_NO;

}


TSupErr reader_test_HEADER_WRITE( 
    TSupSysEContext *context, 
    BYTE controlvec [8],
    size_t length )
/*+
 * :
 *
 * SUP_ERR_NO,  .
 *
 *  ,  .
 +*/
{
    TSupErr code;
    //static const TCHAR *test_file_name = _TEXT( "filename" );
    const TCHAR *file_name = CARRIER_FILE_NAMES[CF_HEADER];
    TRdrFileNumber rdr_fileno = CARRIER_FILE_NUMBERS[CF_HEADER];
    unsigned char *buffer;
    size_t i;

    /*+    . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Create/write/close HEADER function test in progress...")));

    /*+  . +*/
    code = rdr_file_open( context, _TEXT( "wp" ), file_name, rdr_fileno );
    if( code == SUP_ERR_UNSUPPORTED )
    {
	test_error( context, SUP_ERR_UNSUPPORTED );
	code = rdr_file_open( context, _TEXT( "r+p" ), file_name, rdr_fileno );
    }
    if( code )
	return test_error( context, code );

    /*    . +*/
    code = reader_test_file_chsize( context, length+8 );
    if( code )
	return code;

    buffer = malloc( length+8 );
    if( buffer == NULL )
    {
	rdr_file_close( context );
	return test_error( context, SUP_ERR_MEMORY );
    }

    for (i = 0; i < 8; i++) buffer[i] = controlvec[i];
    /*+    . +*/
    for( i = 0; i < length; i++ )
	buffer[i+8] = (unsigned char)i;
    code = rdr_file_write( context, 0, length+8, buffer, NULL );
    free( buffer );
    if( code )
	return test_error( context, code );

    /*+  . +*/
    code = rdr_file_close( context );
    if( code )
	return test_error( context, code );

    /*+     . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Create/write/close HEADER function test successful.")));    
    return SUP_ERR_NO;
}


/*++++
 *      .
 ++++*/
TSupErr reader_test_file_all( 
    TSupSysEContext *context, /*+ (i) Handle . +*/
    size_t length )
/*+
 * :
 *
 * SUP_ERR_NO,  .
 *
 *  ,  .
 +*/
{
    TSupErr code;
    //static const TCHAR *test_file_name = _TEXT( "filename" );
    const TCHAR *file_name = CARRIER_FILE_NAMES[CF_HEADER];
    TRdrFileNumber rdr_fileno = CARRIER_FILE_NUMBERS[CF_HEADER];

    /*+    . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "File function test in progress...")));
    /*+   , ,  . +*/
    code = reader_test_file_create( context, file_name, rdr_fileno, length );
    if( code )
	return code;

    /*+   , ,  . +*/
    code = reader_test_file_read( context, file_name, rdr_fileno, length );
    if( code )
	return code;
    /*+    . +*/
    code = reader_test_file_unlink( context, file_name, rdr_fileno );
    if( code && code != SUP_ERR_UNSUPPORTED )
	return code;
    /*+     . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "File function test successful.")));

    return SUP_ERR_NO;
}

/*++++
 *    , ,  .
 ++++*/
TSupErr reader_test_file_create( 
    TSupSysEContext *context, /*+ (i) Handle . +*/
    const TCHAR *file_name, /*+ (i)   . +*/
    TRdrFileNumber rdr_fileno, /*+ (i)   . +*/
    size_t test_length )
/*+
 * :
 *
 * SUP_ERR_NO,  .
 *
 *  ,  .
 +*/
{
    TSupErr code;
    unsigned char *buffer;
    size_t i;

    /*+    . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Create/write/close function test in progress...")));

    /*+  . +*/
    code = rdr_file_open( context, _TEXT( "wp" ), file_name, rdr_fileno );
    if( code == SUP_ERR_UNSUPPORTED )
    {
	test_error( context, SUP_ERR_UNSUPPORTED );
	code = rdr_file_open( context, _TEXT( "r+p" ), file_name, rdr_fileno );
    }
    if( code )
	return test_error( context, code );

    /*    . +*/
    code = reader_test_file_chsize( context, test_length );
    if( code )
	return code;

    buffer = malloc( test_length );
    if( buffer == NULL )
    {
	rdr_file_close( context );
	return test_error( context, SUP_ERR_MEMORY );
    }

    /*+    . +*/
    for( i = 0; i < test_length; i++ )
	buffer[i] = (unsigned char)i;
    code = rdr_file_write( context, 0, test_length, buffer, NULL );
    free( buffer );
    if( code )
	return test_error( context, code );

    /*+  . +*/
    code = rdr_file_close( context );
    if( code )
	return test_error( context, code );

    /*+     . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Create/write/close function test successful.")));    
    return SUP_ERR_NO;
}

/*++++
 *    , ,  .
 ++++*/
TSupErr reader_test_file_read( 
    TSupSysEContext *context, /*+ (i) Handle . +*/
    const TCHAR *file_name, /*+ (i)   . +*/
    TRdrFileNumber rdr_fileno, /*+ (i)   . +*/
    size_t test_length )
/*+
 * :
 *
 * SUP_ERR_NO,  .
 *
 *  ,  .
 +*/
{
    TSupErr code;
    unsigned char *buffer;
    size_t i;

    /*+    . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Open/read/close function test in progress...")));    

    /*+  . +*/
    code = rdr_file_open( context, _TEXT( "r" ), file_name, rdr_fileno );
    if( code )
	return test_error( context, code );

    /*+    . +*/
    code = reader_test_file_length( context );
    if( code )
    {
	rdr_file_close( context );
	return code;
    }

    buffer = malloc( test_length );
    if( buffer == NULL )
    {
	rdr_file_close( context );
	return test_error( context, SUP_ERR_MEMORY );
    }

    /*+   . +*/
    code = rdr_file_read( context, 0, test_length, buffer, NULL );
    if( code ) {
	free(buffer);
	rdr_file_close(context);
	return test_error(context, code);
    }
    for( i = 0; i < test_length; i++ )
	if( buffer[i] != ( i & 0xff ) )
	{
	    free(buffer);
	    rdr_file_close(context);
	    return test_error(context, SUP_ERR_VERIFY);
	}

    free( buffer );
    /*+  . +*/
    code = rdr_file_close( context );
    if( code )
	return test_error( context, code );

    /*+     . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Open/read/close function test successful.")));    
    return SUP_ERR_NO;
}

/*++++
 *      .
 ++++*/
TSupErr reader_test_file_length( 
    TSupSysEContext *context ) /*+ (i) Handle . +*/
{
    TSupErr code;
    size_t length = 0;

    /*+    . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "File length test in progress...")));    

    /*+   . +*/
    code = rdr_file_length( context, &length );
    if( code )
	return test_error( context, code );

    /*+     . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "File length:%u."),length));        
    return SUP_ERR_NO;
}

/*++++
 *        .
 ++++*/
TSupErr reader_test_file_chsize( 
    TSupSysEContext *context, /*+ (i) Handle . +*/
    size_t test_length )
/*+
 * :
 *
 * SUP_ERR_NO,  .
 *
 *  ,  .
 +*/
{
    TSupErr code;
    size_t length = test_length;

    /*+    . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "File limit test in progress...")));        
    
    /*+   . +*/
    code = rdr_file_chsize( context, &length );
    if( code )
	return test_error( context, code );

    /*+     . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "File limit:%u."),length));        

    return SUP_ERR_NO;
}

/*++++
 *     .
 ++++*/
TSupErr reader_test_file_unlink( 
    TSupSysEContext *context, /*+ (i) Handle . +*/
    const TCHAR *file_name, /*+ (i)   . +*/
    TRdrFileNumber rdr_fileno ) /*+ (i)   . +*/
/*+
 * :
 *
 * SUP_ERR_NO,  .
 *
 *  ,  .
 +*/
{
    TSupErr code;

    /*+    . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "Unlink test in progress...")));        

    /*+  . +*/
    code = rdr_file_unlink( context, file_name, rdr_fileno );
    if( code )
	return test_error( context, code );

    /*+     . +*/
    DbTrace(DB_TRACE, (FTEXT(support_context_io, "File unlink successful.")));        
    return SUP_ERR_NO;
}

/*+ end of file:$Id: tst_file.c 82960 2012-11-22 12:49:01Z borodin $ +*/
