<?xml version="1.0" encoding="windows-1251"?>
 <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 		xmlns:fo="http://www.w3.org/1999/XSL/Format"
 		version='1.0'>


<!--          ,      .. -->



<!--    -->	
<xsl:template name="skzi_list">

	<!--     : -->
    <fo:block text-align="left"
	      font-family="Times" font-size="10pt"
	      space-before="22pt"
	      space-after="0pt"
	      space-before.precedence="0"
	      space-after.precedence="6"                
	      keep-with-next="always"
	      >
      <xsl:call-template name="printTEXT"> <xsl:with-param name="textID">local_crypt_product</xsl:with-param> </xsl:call-template>		<!--  -->
    </fo:block>


        <!--  ,    -->
    <fo:block text-align="center"
	      font-family="Times" font-size="10pt"
	      space-before="11pt"
	      space-after="0pt"
	      space-before.precedence="0"
	      space-after.precedence="6"            	
	      keep-with-next="always"
	      border-after-style="solid"
	      >
          <xsl:call-template name="printPERS"> <xsl:with-param name="persID">pers_csp_list</xsl:with-param> </xsl:call-template>       <!--  -->
    </fo:block>


	<!--    -->
    <fo:block text-align="center" 
	      font-family="Times" font-size="6pt"
	      space-before="0pt"
	      space-after="11pt"
	      space-before.precedence="6"               
	      space-after.precedence="3"
	      >
      <xsl:call-template name="printTEXT"> <xsl:with-param name="textID">local_skzi_name</xsl:with-param> </xsl:call-template>		<!--  -->
    </fo:block>
</xsl:template>


<!--     -->	
<xsl:template name="uc_title">        

	<!--   -->
    <fo:block text-align="center"
	      font-family="Times" font-size="12pt"
	      space-before="22pt"
	      space-after="0pt"                         
	      space-before.precedence="0"
	      space-after.precedence="6"
	      keep-with-next="always"
	      border-after-style="solid"
	      >
	<xsl:call-template name="printPERS"> <xsl:with-param name="persID">pers_uc_title</xsl:with-param> </xsl:call-template>
    </fo:block>


	<!--     -->
<!--    <fo:block text-align="center" 
	      font-family="Times" font-size="6pt"
	      space-before="0pt"
	      space-after="11pt"                        
	      space-before.precedence="6"
	      space-after.precedence="3"
	      keep-with-next="always"
	      >
      <xsl:call-template name="printTEXT"> <xsl:with-param name="textID">local_uc_name</xsl:with-param> </xsl:call-template>
    </fo:block> -->
</xsl:template>



<!--footer      -->

<xsl:template name="stamp-issuer-or-subject">
  <xsl:param name="title"/>
  <fo:block font-family="Times" font-size="10pt"                		
	    space-before="20pt"
	    space-after="10pt"
	    space-before.precedence="0"
	    space-after.precedence="3"
	    >
    <fo:table text-align="center"
	      keep-with-next="always"
	      >
      <fo:table-column column-width="55%"/>
      <fo:table-column column-width="45%"/>
      <fo:table-body>
	<fo:table-row>
	  <fo:table-cell padding="1pt" text-align="left">
	    <fo:block
		      keep-with-next="always"
		      >
	      <xsl:value-of select="$title"/>
	      <xsl:text>:</xsl:text>
	    </fo:block>
	  </fo:table-cell>
	  <fo:table-cell padding="1pt" text-align="right">
	    <fo:block
		      keep-with-next="always"
		      >
			
		<!--   -->
	      <xsl:call-template name="printTEXT"> <xsl:with-param name="textID">local_sign_place</xsl:with-param> </xsl:call-template>
	    </fo:block>
	    <fo:block
		      keep-with-next="always"
		      >
	      <xsl:text> </xsl:text>
	    </fo:block>
	    <fo:block
		      keep-with-next="always"
		      >

		<!--    -->
	      <xsl:call-template name="printTEXT"> <xsl:with-param name="textID">local_date_place</xsl:with-param> </xsl:call-template>
	    </fo:block>

	<!--  .. -->
	    <fo:block text-align="center">
	      <xsl:call-template name="printTEXT"> <xsl:with-param name="textID">local_mp</xsl:with-param> </xsl:call-template>
	    </fo:block>
	  </fo:table-cell>
	</fo:table-row>
      </fo:table-body>
    </fo:table>
  </fo:block>
</xsl:template>


 </xsl:stylesheet>