%if %{!?kernel_release:1}%{?kernel_release:0}
%define kernel_release %(uname -r)
%endif
Summary: Sobol driver
Name: sobol-%{kernel_release}
Source0: sobol.tar.gz
Version: 1
Release: 4
#Source1: ./%{name}-%{version}.%{release}.tar.gz
License: CryptoPro
Group: Applications/Security
URL: http://www.cryptopro.ru/
Packager: Dedal <dedal@cryptopro.ru>
BuildRoot: /tmp/%{name}-%{version}.%{release}-inst

%description
This package contains sobol driver for linux.
Install this package if you plan to use any of CryptoProCSP products.

%prep
%setup -a0 -T -c

%build 
KVER=%{kernel_release}
for BUILDDIR in /lib/modules/$KVER/build /usr/src/linux-$KVER /usr/src/linux-headers-$KVER
do
    if test -d $BUILDDIR || test -h $BUILDDIR
    then
    	break
    fi
done
if ! test -d $BUILDDIR && ! test -h $BUILDDIR
then
    echo "Cannot find any suitable kernel headers"
    exit 1
fi

case $KVER in
2.*) make -C $BUILDDIR SUBDIRS=$PWD modules;;
3.*) make -C $BUILDDIR M=$PWD;;
esac

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kernel_release}/kernel/drivers/misc
if test -f sobol.ko; then 
  install -m755 sobol.ko $RPM_BUILD_ROOT/lib/modules/%{kernel_release}/kernel/drivers/misc
else
  install -m755 sobol.o $RPM_BUILD_ROOT/lib/modules/%{kernel_release}/kernel/drivers/misc
fi


%clean
rm -rf $RPM_BUILD_ROOT

%files 
/lib/modules/%{kernel_release}/kernel/drivers/misc/sobol*

%post
case `uname -r` in
2.4*) mknod /dev/sobol c 61 0;;
esac
depmod -a
modprobe sobol

%preun
modprobe -r sobol

%postun
depmod -a
